// Generated by CoffeeScript 1.6.3
(function() {
  this.AjaxManager = {
    xdm_xhrs_: new Object(),
    query: function(method, url, parameters, success_cb, failure_cb) {
      var manager, parameter_string;
      if (!(parameters != null)) {
        parameters = new Object();
      }
      parameters['rnd'] = Math.random();
      manager = this;
      if (method !== "GET") {
        parameter_string = Utils.generate_parameter_string(parameters, true);
        return jQuery.ajax({
          type: method,
          url: url,
          data: parameter_string,
          success: function(data) {
            if (success_cb != null) {
              return success_cb(Utils.json_to_object(data));
            }
          },
          error: function(xhr, err) {
            if (failure_cb != null) {
              failure_cb(xhr.status, xhr.responseText);
            } else {
              Utils.display_debug_message("AJAX request to " + url + " failed");
            }
          }
        });
      } else {
        parameter_string = Utils.generate_parameter_string(parameters, true);
        url += "?" + parameter_string;
        return jQuery.ajax({
          type: method,
          url: url,
          headers: {
            Accept: "application/json"
          },
          success: function(data) {
            if (success_cb != null) {
              return success_cb(Utils.json_to_object(data));
            }
          },
          error: function(xhr, err) {
            if (failure_cb != null) {
              return failure_cb(xhr.status, xhr.responseText);
            } else {
              return Utils.display_debug_message("AJAX request to " + url + " failed " + xhr.responseText + " " + err + " " + xhr.status + " " + xhr);
            }
          }
        });
      }
    },
    remote_query: function(remote_xdmpath, method, url, parameters, success_cb, failure_cb) {
      var parameter_string, xhr, xhrs,
        _this = this;
      if (Utils.equals_null(parameters)) {
        parameters = new Object();
      }
      xhrs = this.xdm_xhrs_;
      xhr = xhrs[remote_xdmpath];
      if (Utils.equals_null(xhr)) {
        xhr = new easyXDM.Rpc({
          swf: remote_xdmpath + "/easyxdm.swf",
          remote: remote_xdmpath + "/cors/",
          remoteHelper: remote_xdmpath + "/name.html"
        }, {
          remote: {
            request: {}
          }
        });
        xhrs[remote_xdmpath] = xhr;
      }
      if (method === "GET") {
        parameters['randomize'] = Math.random();
        parameter_string = Utils.generate_parameter_string(parameters, true);
        url += "?" + parameter_string;
        return xhr.request({
          url: url,
          headers: {
            Accept: "application/json"
          },
          method: method
        }, function(rpcdata) {
          if (success_cb) {
            return success_cb(Utils.json_to_object(rpcdata.data));
          }
        });
      } else {
        Utils.display_error("remote query method " + method + " not implemented yet");
      }
    },
    query_json: function(url, success_cb, failure_cb) {
      return $.jsonp({
        'url': url,
        'success': success_cb,
        'error': failure_cb
      });
    },
    querySync: function(method, url, parameters) {
      var data, parameter_string;
      if (!(parameters != null)) {
        parameters = new Object();
      }
      parameter_string = Utils.generate_parameter_string(parameters, true);
      data = $.ajax({
        url: url,
        async: false,
        type: method,
        data: parameter_string,
        dataType: "json"
      });
      if (data['responseText'] != null) {
        data = JSON.parse(data['responseText']);
      }
      return data;
    }
  };

}).call(this);
