// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.BuilderBlogsList = (function(_super) {
    __extends(BuilderBlogsList, _super);

    function BuilderBlogsList() {
      _ref = BuilderBlogsList.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    BuilderBlogsList.prototype.on_build = function(block, $container, params) {
      var search, size, skip,
        _this = this;
      Application.track_google_analytics_event("blog", "open", "");
      skip = params['skip'];
      size = params['size'];
      search = params['search'];
      if (!(skip != null)) {
        skip = 0;
      }
      if (!(size != null)) {
        size = 5;
      }
      return PageData.get_blogslist(skip, size, search, function(page) {
        var $blogslist, $follow, $pager, $search, $unfollow, blogs_block, blogslist, body, editable, ii, is_follower, pager_str, total_blogs, _i, _ref1;
        ThemeCompiler.compile_block(block, params, $container);
        $blogslist = _this.get_element("blogslist");
        if (blogslist = page['blogslist']) {
          is_follower = page['is_follower'];
          blogs_block = Blocks("blogsitem");
          for (ii = _i = 0, _ref1 = blogslist.length - 1; _i <= _ref1; ii = _i += 1) {
            body = EternaUtils.format_body(blogslist[ii]['body']);
            if (page['uid'] === blogslist[ii]['uid']) {
              editable = true;
            } else {
              editable = false;
            }
            blogs_block.add_block($blogslist, {
              Editable: editable,
              nid: blogslist[ii]['nid'],
              title: blogslist[ii]['title'],
              body: body,
              created: blogslist[ii]['created'],
              sticky: parseInt(blogslist[ii]['sticky']) > 0,
              comments: blogslist[ii]['comments']
            });
            if (is_follower[ii]) {
              _this.show_unfollow(blogslist[ii]['nid']);
            } else {
              _this.show_follow(blogslist[ii]['nid']);
            }
            if (editable && !is_follower[ii]) {
              Follow.follow(blogslist[ii]['nid'], "node", null, function(data) {
                if (data['success']) {
                  return _this.show_unfollow(blogslist[ii]['nid']);
                } else {
                  return alert("Follow fail");
                }
              });
            }
            if ($follow = _this.get_element(blogslist[ii]['nid'] + "-follow")) {
              $follow.click(function(e) {
                var nid;
                nid = e.target.id.split('-')[0];
                Overlay.set_loading("");
                Overlay.show();
                return Follow.follow(nid, "node", null, function(data) {
                  if (data['success']) {
                    _this.show_unfollow(nid);
                  } else {
                    alert("Follow fail");
                  }
                  return Overlay.hide();
                });
              });
            }
            if ($unfollow = _this.get_element(blogslist[ii]['nid'] + "-unfollow")) {
              $unfollow.click(function(e) {
                var nid;
                nid = e.target.id.split('-')[0];
                Overlay.set_loading("");
                Overlay.show();
                return Follow.expire_follow(nid, "node", function(data) {
                  if (data['success']) {
                    _this.show_follow(nid);
                  } else {
                    alert("Unfollow fail");
                  }
                  return Overlay.hide();
                });
              });
            }
          }
        }
        total_blogs = page['num_blogs'];
        if ($pager = _this.get_element("pager")) {
          pager_str = EternaUtils.get_pager(Math.floor(skip / size), Math.ceil(total_blogs / size), function(pageindex) {
            var url_params;
            url_params = {
              skip: pageindex * size,
              size: size
            };
            if (search != null) {
              url_params['search'] = search;
            }
            return "/web/blog/?" + Utils.generate_parameter_string(url_params, true);
          });
          $pager.html(pager_str);
        }
        if ($search = _this.get_element("search")) {
          $search.attr("value", search);
          return $search.keyup(function(e) {
            var url;
            if (e.keyCode === KeyCode.KEYCODE_ENTER) {
              search = $search.attr("value");
              url = "/web/blog/?" + Utils.generate_parameter_string({
                search: search
              }, true);
              return Utils.redirect_to(url);
            }
          });
        }
      });
    };

    BuilderBlogsList.prototype.show_unfollow = function(nid) {
      var $follow, $unfollow;
      if ($follow = this.get_element(nid + "-follow")) {
        $follow.hide();
      }
      if ($unfollow = this.get_element(nid + "-unfollow")) {
        return $unfollow.show();
      }
    };

    BuilderBlogsList.prototype.show_follow = function(nid) {
      var $follow, $unfollow;
      if ($follow = this.get_element(nid + "-follow")) {
        $follow.show();
      }
      if ($unfollow = this.get_element(nid + "-unfollow")) {
        return $unfollow.hide();
      }
    };

    return BuilderBlogsList;

  })(Builder);

  this.BuilderBlog = (function(_super) {
    __extends(BuilderBlog, _super);

    function BuilderBlog() {
      _ref1 = BuilderBlog.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    BuilderBlog.prototype.on_build = function(block, $container, params) {
      var nid,
        _this = this;
      nid = params['nid'];
      if (!(nid != null)) {
        Utils.display_error("nid not specified");
        return;
      }
      return PageData.get_blogs(nid, function(page) {
        var $follow, $unfollow, blog, input_params;
        blog = page['blog'];
        input_params = {};
        input_params['nid'] = nid;
        input_params['title'] = blog['title'];
        input_params['created'] = blog['created'];
        input_params['body'] = EternaUtils.format_body(blog['body']);
        input_params['founder'] = blog['uid'];
        input_params['comments'] = page['comments'];
        if (page['uid'] === blog['uid']) {
          input_params['Editable'] = true;
        } else {
          input_params['Editable'] = false;
        }
        ThemeCompiler.compile_block(block, input_params, $container);
        if ((page['follow'] != null) && (page['follow'][0] != null)) {
          _this.show_unfollow();
        } else {
          _this.show_follow();
        }
        if (input_params['Editable']) {
          if ((page['follow'] == null) || (page['follow'][0] == null)) {
            Follow.follow(nid, "node", null, function(data) {
              if (data['success']) {
                return _this.show_unfollow();
              } else {
                return alert("Follow fail");
              }
            });
          }
        }
        if ($follow = _this.get_element("follow")) {
          $follow.click(function() {
            Overlay.set_loading("");
            Overlay.show();
            return Follow.follow(nid, "node", null, function(data) {
              if (data['success']) {
                _this.show_unfollow();
              } else {
                alert("Follow fail");
              }
              return Overlay.hide();
            });
          });
        }
        if ($unfollow = _this.get_element("unfollow")) {
          return $unfollow.click(function() {
            Overlay.set_loading("");
            Overlay.show();
            return Follow.expire_follow(nid, "node", function(data) {
              if (data['success']) {
                _this.show_follow();
              } else {
                alert("Unfollow fail");
              }
              return Overlay.hide();
            });
          });
        }
      });
    };

    BuilderBlog.prototype.show_unfollow = function() {
      var $follow, $unfollow;
      if ($follow = this.get_element("follow")) {
        $follow.hide();
      }
      if ($unfollow = this.get_element("unfollow")) {
        return $unfollow.show();
      }
    };

    BuilderBlog.prototype.show_follow = function() {
      var $follow, $unfollow;
      if ($follow = this.get_element("follow")) {
        $follow.show();
      }
      if ($unfollow = this.get_element("unfollow")) {
        return $unfollow.hide();
      }
    };

    return BuilderBlog;

  })(Builder);

}).call(this);
