// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1, _ref2,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.BuilderComments = (function(_super) {
    var $comment_input, $comment_mention, $comment_submit, $comment_submit_container, $comment_suggestions, $comments, $mention_in_progress_, $submitting, $suggestion_focus_idx_, $usernames_;

    __extends(BuilderComments, _super);

    function BuilderComments() {
      _ref = BuilderComments.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    $usernames_ = [];

    $suggestion_focus_idx_ = -1;

    $mention_in_progress_ = false;

    $comments = null;

    $comment_input = null;

    $comment_mention = null;

    $comment_suggestions = null;

    $comment_submit_container = null;

    $comment_submit = null;

    $submitting = null;

    BuilderComments.prototype.initialize_elements = function() {
      this.$comments = this.get_element("comments");
      this.$comment_input = this.get_element("comment-input");
      this.$comment_mention = this.get_element("mention-button");
      this.$comment_suggestions = this.get_element("comment-suggestions");
      this.$comment_submit_container = this.get_element("comment-submit-container");
      this.$comment_submit = this.get_element("comment-submit");
      return this.$submitting = this.get_element("submitting");
    };

    BuilderComments.prototype.on_build = function(block, $container, params) {
      var comments, hide, is_super, nid, packer, supercomments,
        _this = this;
      ThemeCompiler.compile_block(block, params, $container);
      this.initialize_elements();
      this.initialize_events();
      is_super = parseInt(params['super']) === 1;
      comments = params['comments'];
      supercomments = params['supercomments'];
      nid = params['nid'];
      if ((!(comments != null) && !(supercomments != null)) || !(nid != null)) {
        Utils.display_error("comments or nid missing");
        return;
      }
      if (this.$comments != null) {
        packer = Packers(this.$comments);
        if (is_super && (supercomments != null)) {
          packer.add(supercomments);
        } else if ((!is_super) && (comments != null)) {
          packer.add(comments);
        }
      }
      hide = false;
      if (is_super) {
        if (!(Application.CURRENT_USER != null)) {
          hide = true;
        } else {
          if (Application.CURRENT_USER['uid'] !== params['uid']) {
            hide = true;
          }
        }
      }
      if ((this.$comment_input != null) && (this.$comment_submit != null) && (this.$comment_mention != null)) {
        if (hide) {
          this.$comment_input.hide();
          this.$comment_submit.hide();
          this.$comment_mention.hide();
          this.$comment_submit_container.hide();
          return;
        }
        return this.$comment_submit.click(function() {
          var body;
          Application.track_google_analytics_event("comment", "submit", "");
          body = _this.$comment_input.attr("value");
          if (Utils.is_text_empty(body)) {
            Utils.display_error("Please write something");
            return;
          }
          _this.lock_commenting();
          return Comment.post_comment(nid, body, is_super, function(ret) {
            _this.$comment_input.attr("value", "");
            _this.unlock_commenting();
            if (_this.$comments && ret['comments']) {
              _this.$comments.html("");
              return packer.add(ret['comments']);
            }
          });
        });
      }
    };

    BuilderComments.prototype.lock_commenting = function() {
      if (this.$submitting != null) {
        this.$comment_input.disabled = true;
        this.$comment_input.fadeTo(500, 0.6);
        return this.$submitting.show();
      }
    };

    BuilderComments.prototype.unlock_commenting = function() {
      if (this.$submitting) {
        this.$comment_input.disabled = false;
        this.$comment_input.fadeTo(200, 1.0);
        return this.$submitting.hide();
      }
    };

    BuilderComments.prototype.update_comment = function(text) {
      var body;
      this.$comment_input.focus();
      body = this.$comment_input.attr("value");
      if (text === "@") {
        if (body.length > 0) {
          body += " ";
        }
      }
      body += text;
      this.$comment_input.attr("value", body);
      return this.$comment_input.show();
    };

    BuilderComments.prototype.replace_mention = function(username) {
      var body, current_body, current_mention, cursor, cursor_offset,
        _this = this;
      this.$comment_input.focus();
      if (/(.*)\s+$/.test(username)) {
        username = username.replace(" ", "_");
        username = username.slice(0, username.length - 1) + " ";
      } else {
        username = username.replace(" ", "_");
      }
      current_mention = null;
      current_body = body = this.$comment_input.attr("value");
      try {
        cursor = this.$comment_input.prop('selectionStart');
        current_body = current_body.slice(0, cursor);
      } catch (_error) {}
      cursor_offset = 0;
      current_body = current_body.replace(/@(.*)$/, function($m) {
        var $m_last, $m_spl;
        $m_spl = $m.split("@");
        $m_last = $m_spl.pop();
        $m_spl.push(username);
        $m = $m_spl.join("@");
        cursor_offset = username.length - $m_last.length;
        return $m;
      });
      body = current_body + body.slice(cursor, body.length);
      cursor = this.$comment_input.prop('selectionStart');
      this.$comment_input.attr("value", body);
      this.$comment_input.show();
      this.$comment_input.prop('selectionStart', cursor + cursor_offset);
      return this.$comment_input.prop('selectionEnd', cursor + cursor_offset);
    };

    BuilderComments.prototype.check_mention_in_progress = function() {
      var body, current_body, current_mention, current_word, cursor, matches;
      current_mention = null;
      current_body = body = this.$comment_input.attr("value");
      try {
        cursor = this.$comment_input.prop('selectionStart');
        current_body = current_body.slice(0, cursor);
      } catch (_error) {}
      current_word = current_body.split(" ").pop();
      if (matches = current_word.match(/^[\[\(]*[^a-zA-Z0-9_-]*@([a-zA-Z0-9_'-]*)/)) {
        if (current_word.indexOf("@@") < 0) {
          current_mention = matches.pop();
          this.$mention_in_progress_ = true;
        }
      }
      return current_mention;
    };

    BuilderComments.prototype.comment_suggestions_loading = function(search) {
      var $comment_suggestion_loading, height, packer;
      packer = Packers(this.$comment_suggestions);
      packer.add([
        {
          'loading': 'https://s3.amazonaws.com/eterna/icon_img/loading.gif',
          'search': search
        }
      ]);
      if ($comment_suggestion_loading = $('.comment-suggestion')) {
        $comment_suggestion_loading.css({
          'pointer-events': 'none'
        });
      }
      this.$comment_suggestions.height(80);
      height = this.$comment_suggestions.height();
      this.$comment_suggestions.css("top", (48 - height) + "px");
      return this.clear_focus();
    };

    BuilderComments.prototype.comment_suggestions_topbar = function(search) {
      var $comment_suggestion_topbar, packer;
      packer = Packers(this.$comment_suggestions);
      packer.add([
        {
          'topbar': 1,
          'search': search
        }
      ]);
      if ($comment_suggestion_topbar = $('.comment-suggestion')) {
        $comment_suggestion_topbar.css({
          'pointer-events': 'none'
        });
      }
      this.$comment_suggestions.css({
        'min-width': '400px'
      });
      if ((search != null) && search !== "") {
        return this.$comment_suggestions.css({
          'min-width': (500 + 5 * search.length) + 'px'
        });
      }
    };

    BuilderComments.prototype.initialize_suggestions = function() {
      var cb, current_mention, search, size, skip;
      if (!(this.$comment_suggestions != null)) {
        return;
      }
      this.$comment_suggestions.hide();
      current_mention = this.check_mention_in_progress();
      if (current_mention === null) {
        return;
      }
      search = current_mention;
      size = 50;
      skip = 0;
      if (search === '') {
        size = 5;
      }
      this.reset_comment_suggestions(search);
      this.comment_suggestions_loading(search);
      cb = this;
      return PageData.get_usernames(search, size, skip, function(data) {
        var packer;
        cb.$usernames_ = data['usernames'];
        cb.reset_comment_suggestions(search);
        packer = Packers(cb.$comment_suggestions);
        packer.add(cb.$usernames_);
        cb.update_suggestions_layout();
        if (cb.$usernames_.length < 1) {
          cb.$comment_suggestions.hide();
        }
      });
    };

    BuilderComments.prototype.reset_comment_suggestions = function(search) {
      this.$comment_suggestions.html('');
      this.comment_suggestions_topbar(search);
      this.$comment_suggestions.show();
      return this.$suggestion_focus_idx_ = -1;
    };

    BuilderComments.prototype.update_suggestions_layout = function() {
      var d, element_offset, height, max_h, n, scroll_top;
      scroll_top = $(window).scrollTop();
      element_offset = this.$comment_suggestions.offset().top;
      max_h = this.$comment_suggestions.css('max-height');
      if (this.$usernames_ != null) {
        n = this.$usernames_.length;
        if (max_h > ((n + 1) * 40)) {
          max_h = (n + 1) * 40;
        }
      }
      height = this.$comment_suggestions.height();
      d = element_offset - scroll_top;
      if (d > 0) {
        if (d < max_h) {
          max_h = height - d;
          max_h -= 10;
        }
      } else {
        max_h = height + d;
      }
      this.$comment_suggestions.height(max_h);
      height = this.$comment_suggestions.height();
      this.$comment_suggestions.css("top", (48 - height) + "px");
      return this.update_suggestion_focus(1);
    };

    BuilderComments.prototype.init_current_suggestion_focus_index = function(increment) {
      var index;
      if (!(this.$suggestion_focus_idx_ != null)) {
        this.$suggestion_focus_idx_ = -1;
      }
      index = this.$suggestion_focus_idx_;
      if (increment != null) {
        index += increment;
      }
      if (index >= $('.comment-suggestion').length) {
        index = 1;
      }
      if ((typeof ingrement !== "undefined" && ingrement !== null) && increment < 0 && index < 0) {
        index = $('.comment-suggestion').length - 1;
      }
      if ((increment != null) && increment < 0) {
        if (index === 0) {
          index = $('.comment-suggestion').length - 1;
        }
        if (index === -1) {
          index = $('.comment-suggestion').length - 2;
        }
      }
      this.$suggestion_focus_idx_ = index;
      if ((increment != null) && increment > 0 && index === 0) {
        index = 1;
      }
      return index;
    };

    BuilderComments.prototype.clear_focus = function() {
      var $comment_suggestion;
      if ($comment_suggestion = this.get_element('comment-suggestion')) {
        return $($comment_suggestion).css({
          'border': '0px solid #467097',
          'box-shadow': 'inset 0px 0px 1px rgba(0,0,0,1.0)'
        });
      }
    };

    BuilderComments.prototype.update_suggestion_focus = function(increment) {
      var $comment_suggestion, index, scroll_offset;
      index = this.init_current_suggestion_focus_index(increment);
      if ($comment_suggestion = this.get_element('comment-suggestion')) {
        this.clear_focus();
        $($comment_suggestion.get(index)).css({
          'box-shadow': '0px 0px 2px',
          'border': '1px solid rgba(256,256,256,0.5)'
        });
        scroll_offset = ((index + 1) * 40) - this.$comment_suggestions.height();
        return this.$comment_suggestions.css({
          scrollTop: scroll_offset
        });
      }
    };

    BuilderComments.prototype.get_current_suggestion_username = function() {
      var $user, $users, index, username;
      if ((this.$usernames_ != null) && this.$usernames_.length > 0) {
        index = this.init_current_suggestion_focus_index(0) - 1;
        if ($users = this.get_element('comment-suggestion-user')) {
          if ($user = $users.get(index)) {
            if (username = $user.dataset.username) {
              return username;
            }
          }
        }
      }
      this.$comment_suggestions.hide();
      return null;
    };

    BuilderComments.prototype.try_current_suggestion = function(pad) {
      var username;
      if (username = this.get_current_suggestion_username()) {
        console.log("try suggestion: " + username);
        if ((pad != null) && pad === true) {
          this.replace_mention(username + " ");
        } else {
          this.replace_mention(username);
        }
      }
    };

    BuilderComments.prototype.initialize_events = function() {
      var $comment_suggestion_user, cb,
        _this = this;
      cb = this;
      this.$comment_input.on('input propertychange', function(e) {
        return cb.initialize_suggestions();
      });
      this.$comment_input.keydown(function(e) {
        if (e.which === 9) {
          cb.check_mention_in_progress();
          if (cb.$mention_in_progress_ === true) {
            e.preventDefault();
            if (e.shiftKey === true) {
              cb.update_suggestion_focus(-1);
            } else {
              cb.update_suggestion_focus(1);
            }
          }
          if ((cb.$usernames_ != null) && cb.$usernames_.length === 1) {
            cb.try_current_suggestion(true);
            cb.$comment_suggestions.hide();
            cb.$mention_in_progress_ = false;
          } else {
            cb.try_current_suggestion();
          }
        }
        if (e.which === 13) {
          cb.check_mention_in_progress();
          if (cb.$mention_in_progress_ === true) {
            e.preventDefault();
            cb.try_current_suggestion(true);
            cb.$comment_suggestions.hide();
            cb.$mention_in_progress_ = false;
          }
        }
        if (e.which === 27) {
          cb.$mention_in_progress_ = false;
          cb.$comment_suggestions.hide();
        }
        if (e.which === 32) {
          cb.$mention_in_progress_ = false;
          return cb.$comment_suggestions.hide();
        }
      });
      this.$comment_input.keyup(function(e) {
        if (e.which === 16) {
          return;
        }
        if (e.which === 9) {

        }
      });
      this.$comment_mention.click(function() {
        cb.update_comment("@");
        return cb.initialize_suggestions();
      });
      if ($comment_suggestion_user = this.get_element('comment-suggestion-user')) {
        $comment_suggestion_user.click(function() {
          var username;
          if (username = $(_this).dataset.username) {
            cb.replace_mention(username);
            return cb.update_comment(" ");
          }
        });
      }
      $(window).bind('resize', function() {
        var resize_timeout;
        if (typeof resize_timeout !== "undefined" && resize_timeout !== null) {
          clearTimeout(resize_timeout);
        }
        return resize_timeout = setTimeout(function() {
          return cb.update_suggestions_layout();
        }, 500);
      });
      return $(window).bind('scroll', function() {
        var scroll_timeout;
        if (typeof scroll_timeout !== "undefined" && scroll_timeout !== null) {
          clearTimeout(scroll_timeout);
        }
        return scroll_timeout = setTimeout(function() {
          return cb.update_suggestions_layout();
        }, 800);
      });
    };

    return BuilderComments;

  })(Builder);

  this.BuilderComment = (function(_super) {
    __extends(BuilderComment, _super);

    function BuilderComment() {
      _ref1 = BuilderComment.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    BuilderComment.prototype.on_build = function(block, $container, params) {
      var $delete, cid,
        _this = this;
      params['picture'] = EternaUtils.get_user_picture(params['picture']);
      params['is_deletable'] = Application.CURRENT_USER != null ? Application.CURRENT_USER['uid'] === params['uid'] : false;
      params['comment'] = EternaUtils.format_comment_mentions(params['comment']);
      cid = params['cid'];
      if (!(cid != null)) {
        Utils.display_error("cid missing");
        return;
      }
      ThemeCompiler.compile_block(block, params, $container);
      if ($delete = this.get_element("delete")) {
        return $delete.click(function() {
          $container.hide();
          return Comment.delete_comment(cid, function(ret) {});
        });
      }
    };

    return BuilderComment;

  })(Builder);

  this.BuilderCommentSuggestion = (function(_super) {
    var text_;

    __extends(BuilderCommentSuggestion, _super);

    function BuilderCommentSuggestion() {
      _ref2 = BuilderCommentSuggestion.__super__.constructor.apply(this, arguments);
      return _ref2;
    }

    text_ = null;

    BuilderCommentSuggestion.prototype.on_build = function(block, $container, params) {
      this.text_ = params['username'];
      params['userpicture'] = EternaUtils.get_user_picture(params['userpicture']);
      return ThemeCompiler.compile_block(block, params, $container);
    };

    return BuilderCommentSuggestion;

  })(Builder);

}).call(this);
