// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.BuilderGroups = (function(_super) {
    __extends(BuilderGroups, _super);

    function BuilderGroups() {
      _ref = BuilderGroups.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    BuilderGroups.prototype.on_build = function(block, $container, params) {
      var search, size, skip, sort,
        _this = this;
      skip = params['skip'];
      size = params['size'];
      search = params['search'];
      sort = params['sort'];
      if (!(sort != null)) {
        sort = params['sort'] = "date";
      }
      if (!(skip != null)) {
        skip = 0;
      }
      if (!(size != null)) {
        size = 9;
      }
      return PageData.get_groups(skip, size, search, sort, function(page) {
        var $groups, $pager, $search, founder_name, group_params, groups, ii, name, packer, pager_str, param_string, total_groups, _i, _ref1;
        param_string = {};
        param_string.size = size;
        param_string.search = search;
        param_string.sort = "date";
        params['date_sort_url'] = "/web/group/?" + Utils.generate_parameter_string(param_string);
        param_string.sort = "title";
        params['title_sort_url'] = "/web/group/?" + Utils.generate_parameter_string(param_string);
        param_string.sort = params['sort'];
        groups = page["groups"];
        ThemeCompiler.compile_block(block, params, $container);
        $groups = _this.get_element("groups");
        packer = Packers($groups);
        group_params = [];
        for (ii = _i = 0, _ref1 = groups.length - 1; _i <= _ref1; ii = _i += 1) {
          name = EternaUtils.format_summary(groups[ii]['name'], 10);
          founder_name = EternaUtils.format_summary(groups[ii]['founder_name'], 12);
          group_params.push({
            nid: groups[ii]['nid'],
            name: name,
            num_members: groups[ii]['num_members'],
            description: groups[ii]['description'],
            founder_uid: groups[ii]['founder_uid'],
            founder_name: founder_name,
            founder_picture: EternaUtils.get_user_picture(groups[ii]['founder_picture']),
            group_picture: groups[ii]['picture'],
            is_private: groups[ii]['is_private'],
            created: groups[ii]['created']
          });
        }
        packer.add(group_params);
        total_groups = page["num_groups"];
        if ($pager = _this.get_element("pager")) {
          pager_str = EternaUtils.get_pager(Math.floor(skip / size), Math.ceil(total_groups / size), function(pageindex) {
            var url_params;
            url_params = {
              skip: pageindex * size,
              size: size,
              sort: sort
            };
            if (search != null) {
              url_params['search'] = search;
            }
            if (sort != null) {
              url_params['sort'] = sort;
            }
            return "/web/group/?" + Utils.generate_parameter_string(url_params, true);
          });
          $pager.html(pager_str);
        }
        if ($search = _this.get_element("search")) {
          $search.attr("value", search);
          return $search.keyup(function(e) {
            var url;
            if (e.keyCode === KeyCode.KEYCODE_ENTER) {
              search = $search.attr("value");
              param_string['search'] = search;
              url = "/web/group/?" + Utils.generate_parameter_string(param_string, true);
              return Utils.redirect_to(url);
            }
          });
        }
      });
    };

    return BuilderGroups;

  })(Builder);

  this.BuilderMyGroups = (function(_super) {
    __extends(BuilderMyGroups, _super);

    function BuilderMyGroups() {
      _ref1 = BuilderMyGroups.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    BuilderMyGroups.prototype.on_build = function(block, $container, params) {
      var my_search, my_size, my_skip, my_sort,
        _this = this;
      my_skip = params['my_skip'];
      my_size = params['my_size'];
      my_search = params['my_search'];
      my_sort = params['my_sort'];
      if (!(my_sort != null)) {
        my_sort = params['my_sort'] = "date";
      }
      if (!(my_skip != null)) {
        my_skip = 0;
      }
      if (!(my_size != null)) {
        my_size = 6;
      }
      return PageData.get_my_groups(my_skip, my_size, my_search, my_sort, function(page) {
        var $groups, $pager, $search, founder_name, group_params, groups, ii, my_total_groups, name, packer, pager_str, param_string, _i, _ref2;
        param_string = {};
        param_string.my_size = my_size;
        param_string.my_search = my_search;
        param_string.my_sort = "date";
        params['date_sort_url'] = "/web/group/?" + Utils.generate_parameter_string(param_string);
        param_string.my_sort = "title";
        params['title_sort_url'] = "/web/group/?" + Utils.generate_parameter_string(param_string);
        groups = page["groups"];
        if (page['uid'] != null) {
          if (groups.length > 0) {
            params['my_group_valid'] = true;
          }
        } else {
          params['my_group_valid'] = false;
        }
        ThemeCompiler.compile_block(block, params, $container);
        $groups = _this.get_element("groups");
        packer = Packers($groups);
        group_params = [];
        my_total_groups = page['num_groups'].length;
        for (ii = _i = 0, _ref2 = groups.length - 1; _i <= _ref2; ii = _i += 1) {
          name = EternaUtils.format_summary(groups[ii]['name'], 10);
          founder_name = EternaUtils.format_summary(groups[ii]['founder_name'], 12);
          group_params.push({
            nid: groups[ii]['nid'],
            name: name,
            num_members: groups[ii]['num_members'],
            description: groups[ii]['description'],
            founder_uid: groups[ii]['founder_uid'],
            founder_name: founder_name,
            founder_picture: EternaUtils.get_user_picture(groups[ii]['founder_picture']),
            group_picture: groups[ii]['picture'],
            is_private: groups[ii]['is_private'],
            created: groups[ii]['created']
          });
        }
        packer.add(group_params);
        if ($pager = _this.get_element("my_pager")) {
          pager_str = EternaUtils.get_pager(Math.floor(my_skip / my_size), Math.ceil(my_total_groups / my_size), function(my_pageindex) {
            var url_params;
            url_params = {
              my_skip: my_pageindex * my_size,
              my_size: my_size,
              my_sort: my_sort
            };
            if (my_search != null) {
              url_params['my_search'] = my_search;
            }
            return "/web/group/?" + Utils.generate_parameter_string(url_params, true);
          });
          $pager.html(pager_str);
        }
        if ($search = _this.get_element("my_search")) {
          $search.attr("value", my_search);
          return $search.keyup(function(e) {
            var url;
            if (e.keyCode === KeyCode.KEYCODE_ENTER) {
              my_search = $search.attr("value");
              url = "/web/group/?" + Utils.generate_parameter_string({
                my_search: my_search
              }, true);
              return Utils.redirect_to(url);
            }
          });
        }
      });
    };

    return BuilderMyGroups;

  })(Builder);

  this.BuilderGroup = (function(_super) {
    __extends(BuilderGroup, _super);

    function BuilderGroup() {
      _ref2 = BuilderGroup.__super__.constructor.apply(this, arguments);
      return _ref2;
    }

    BuilderGroup.prototype.on_build = function(block, $container, params) {
      var nid, search, size, skip,
        _this = this;
      nid = params['nid'];
      skip = params['skip'];
      size = params['size'];
      search = params['search'];
      if (!(skip != null)) {
        skip = 0;
      }
      if (!(size != null)) {
        size = 10;
      }
      if (!(nid != null)) {
        Utils.display_error("nid not specified");
        return;
      }
      return PageData.get_group(nid, skip, size, search, function(page) {
        var $delete_group, $follow_group, $group_admins, $group_members, $group_pendings, $pager, $pending_group, $search, $sendmessage, $subscribe_group, $unfollow_group, $unsubscribe_group, accept_params, admins_params, group, group_admins, group_members, group_pendings, ii, input_params, members_params, packer, pager_str, param_string, pendings_params, reject_params, total_num_comments, uid, _i, _j, _k, _l, _ref3, _ref4, _ref5, _ref6;
        group = page['group'];
        param_string = {};
        param_string.size = size;
        param_string.search = search;
        input_params = {};
        input_params['name'] = group['name'];
        input_params['created'] = group['created'];
        input_params['score'] = group['score'];
        input_params['body'] = EternaUtils.format_body(group['body']);
        input_params['group_picture'] = group['picture'];
        input_params['is_admin'] = page['is_admin'];
        if (page['uid'] === group['founder_uid']) {
          input_params['is_founder'] = true;
        } else {
          input_params['is_founder'] = false;
        }
        if ((page['uid'] != null) && !input_params['is_founder']) {
          input_params['is_logged_in'] = true;
        } else {
          input_params['is_logged_in'] = false;
        }
        input_params['founder_uid'] = group['founder_uid'];
        input_params['founder_name'] = group['founder_name'];
        input_params['founder_picture'] = EternaUtils.get_user_picture(group['founder_picture']);
        input_params['is_private'] = group['is_private'];
        input_params['comments'] = page['comments'];
        input_params['nid'] = nid;
        input_params['num_members'] = group['num_members'];
        total_num_comments = page['total_num_comments'];
        if (page['is_member']) {
          input_params['acc_comments'] = true;
        } else if (page['uid'] === '48166') {
          input_params['acc_comments'] = true;
        } else {
          input_params['acc_comments'] = false;
        }
        input_params['is_group_admin'] = page['is_admin'];
        ThemeCompiler.compile_block(block, input_params, $container);
        group_members = page["group_members"];
        if (group_members != null) {
          $group_members = _this.get_element("group_members");
          packer = Packers($group_members);
          members_params = [];
          for (ii = _i = 0, _ref3 = group_members.length - 1; _i <= _ref3; ii = _i += 1) {
            members_params.push({
              uid: group_members[ii]['uid'],
              name: group_members[ii]['name'],
              picture: EternaUtils.get_user_picture(group_members[ii]['picture'])
            });
          }
          packer.add(members_params);
        }
        group_admins = page["group_admins"];
        if (group_admins != null) {
          $group_admins = _this.get_element("group_admins");
          packer = Packers($group_admins);
          admins_params = [];
          for (ii = _j = 0, _ref4 = group_admins.length - 1; _j <= _ref4; ii = _j += 1) {
            admins_params.push({
              uid: group_admins[ii]['uid'],
              name: group_admins[ii]['name'],
              picture: EternaUtils.get_user_picture(group_admins[ii]['picture'])
            });
          }
          packer.add(admins_params);
        }
        group_pendings = page["group_pendings"];
        if (group_pendings != null) {
          $group_pendings = _this.get_element("group_pendings");
          packer = Packers($group_pendings);
          pendings_params = [];
          for (ii = _k = 0, _ref5 = group_pendings.length - 1; _k <= _ref5; ii = _k += 1) {
            pendings_params.push({
              idx: ii,
              uid: group_pendings[ii]['uid'],
              name: group_pendings[ii]['name'],
              picture: EternaUtils.get_user_picture(group_pendings[ii]['picture'])
            });
          }
          packer.add(pendings_params);
          accept_params = [];
          reject_params = [];
          for (ii = _l = 0, _ref6 = group_pendings.length - 1; _l <= _ref6; ii = _l += 1) {
            if (accept_params[ii] = _this.get_element(ii + "_accept")) {
              accept_params[ii].click(function(event) {
                var pending_uid, uidx;
                Overlay.set_loading("replying..");
                Overlay.show();
                uidx = event.target.id.split("_accept")[0];
                pending_uid = group_pendings[uidx]['uid'];
                return Group.accept(pending_uid, nid, function(data) {
                  alert(data['error']);
                  Overlay.hide();
                  return Utils.redirect_to("/web/group/" + nid + "/");
                });
              });
            }
            if (reject_params[ii] = _this.get_element(ii + "_reject")) {
              reject_params[ii].click(function(event) {
                var pending_uid, uidx;
                Overlay.set_loading("replying..");
                Overlay.show();
                uidx = event.target.id.split("_reject")[0];
                pending_uid = group_pendings[uidx]['uid'];
                return Group.reject(pending_uid, nid, function(data) {
                  alert(data['error']);
                  Overlay.hide();
                  return Utils.redirect_to("/web/group/" + nid + "/");
                });
              });
            }
          }
        }
        if (page['is_member'] || page['is_pending']) {
          _this.show_unsubscribe();
        } else {
          _this.show_subscribe();
        }
        if (page['is_following']) {
          _this.show_unfollow();
        } else {
          _this.show_follow();
        }
        if ($pending_group = _this.get_element("pending_group")) {
          if (page['is_pending']) {
            $pending_group.show();
          } else {
            $pending_group.hide();
          }
        }
        uid = page['uid'];
        if ($subscribe_group = _this.get_element("subscribe_group")) {
          $subscribe_group.click(function() {
            Overlay.set_loading("replying..");
            Overlay.show();
            if (group['is_private'] === 'true') {
              if (confirm("You'll have to wait for approval")) {
                return Group.subscribe(uid, nid, group['is_private'], function(data) {
                  alert(data['error']);
                  if (data['subscribe_success']) {
                    _this.show_unsubscribe();
                  }
                  _this.show_follow();
                  Overlay.hide();
                  return Utils.redirect_to("/web/group/" + nid + "/");
                });
              }
            } else {
              return Group.subscribe(uid, nid, group['is_private'], function(data) {
                alert(data['error']);
                if (data['subscribe_success']) {
                  _this.show_unsubscribe();
                }
                if (data['follow_success']) {
                  _this.show_unfollow();
                }
                Overlay.hide();
                return Utils.redirect_to("/web/group/" + nid + "/");
              });
            }
          });
        }
        if ($unsubscribe_group = _this.get_element("unsubscribe_group")) {
          $unsubscribe_group.click(function() {
            if (!input_params['is_founder']) {
              Overlay.set_loading("replying..");
              Overlay.show();
              return Group.unsubscribe(uid, nid, function(data) {
                alert(data['error']);
                if (data['unfollow_success']) {
                  _this.show_follow();
                }
                if (data['unsubscribe_success']) {
                  _this.show_subscribe();
                }
                Overlay.hide();
                return Utils.redirect_to("/web/group/" + nid + "/");
              });
            } else {
              return alert("You cannot unsubscribe this group");
            }
          });
        }
        if ($follow_group = _this.get_element("follow_group")) {
          $follow_group.click(function() {
            Overlay.set_loading("replying..");
            Overlay.show();
            return Group.follow_group(uid, nid, function(data) {
              alert(data['error']);
              if (data['success']) {
                _this.show_unfollow();
              }
              return Overlay.hide();
            });
          });
        }
        if ($unfollow_group = _this.get_element("unfollow_group")) {
          $unfollow_group.click(function() {
            Overlay.set_loading("replying..");
            Overlay.show();
            return Group.unfollow_group(uid, nid, function(data) {
              if (data['success']) {
                _this.show_follow();
                alert("Successfully unfollowed this group!");
              } else {
                alert("Fail to unfollow this group. Please try again!");
              }
              return Overlay.hide();
            });
          });
        }
        if ($delete_group = _this.get_element("delete_group")) {
          $delete_group.click(function() {
            Overlay.set_loading("replying..");
            Overlay.show();
            Follow.expire_followers(nid, "group", function(data) {
              if (!data['success']) {
                return alert("Fail to unfollow the group.Try again.");
              }
            });
            return Group["delete"](nid, function(data) {
              if (!data['success']) {
                alert("Fail to delete. Try again");
              }
              Overlay.hide();
              return Utils.redirect_to("/web/group/");
            });
          });
        }
        if ($sendmessage = _this.get_element("sendmessage")) {
          $sendmessage.click(function() {
            var $overlay_slot;
            block = Blocks("overlay-messages");
            $overlay_slot = Overlay.get_slot("sendmessage");
            Overlay.load_overlay_content("sendmessage");
            Overlay.show();
            if (block['template_context_variables_'] === null) {
              return block.add_block($overlay_slot, {
                target_name: "all group members"
              });
            }
          });
        }
        if ($pager = _this.get_element("pager")) {
          pager_str = EternaUtils.get_pager(Math.floor(skip / size), Math.ceil(total_num_comments / size), function(pageindex) {
            var url_params;
            url_params = {
              skip: pageindex * size,
              size: size
            };
            if (search != null) {
              url_params['search'] = search;
            }
            return "/web/group/" + nid + "/?" + Utils.generate_parameter_string(url_params, true);
          });
          $pager.html(pager_str);
        }
        if ($search = _this.get_element("search")) {
          $search.attr("value", search);
          return $search.keyup(function(e) {
            var url;
            if (e.keyCode === KeyCode.KEYCODE_ENTER) {
              search = $search.attr("value");
              url = "/web/group/" + nid + "/?" + Utils.generate_parameter_string({
                search: search
              }, true);
              return Utils.redirect_to(url);
            }
          });
        }
      });
    };

    BuilderGroup.prototype.show_subscribe = function() {
      var $subscribe_group, $unsubscribe_group;
      if ($subscribe_group = this.get_element("subscribe_group")) {
        $subscribe_group.show();
      }
      if ($unsubscribe_group = this.get_element("unsubscribe_group")) {
        return $unsubscribe_group.hide();
      }
    };

    BuilderGroup.prototype.show_unsubscribe = function() {
      var $subscribe_group, $unsubscribe_group;
      if ($subscribe_group = this.get_element("subscribe_group")) {
        $subscribe_group.hide();
      }
      if ($unsubscribe_group = this.get_element("unsubscribe_group")) {
        return $unsubscribe_group.show();
      }
    };

    BuilderGroup.prototype.show_follow = function() {
      var $follow_group, $unfollow_group;
      if ($follow_group = this.get_element("follow_group")) {
        $follow_group.show();
      }
      if ($unfollow_group = this.get_element("unfollow_group")) {
        return $unfollow_group.hide();
      }
    };

    BuilderGroup.prototype.show_unfollow = function() {
      var $follow_group, $unfollow_group;
      if ($follow_group = this.get_element("follow_group")) {
        $follow_group.hide();
      }
      if ($unfollow_group = this.get_element("unfollow_group")) {
        return $unfollow_group.show();
      }
    };

    return BuilderGroup;

  })(Builder);

  this.BuilderOverlayMessages = (function(_super) {
    __extends(BuilderOverlayMessages, _super);

    function BuilderOverlayMessages() {
      _ref3 = BuilderOverlayMessages.__super__.constructor.apply(this, arguments);
      return _ref3;
    }

    BuilderOverlayMessages.prototype.on_build = function(block, $container, params) {
      var $send_button,
        _this = this;
      ThemeCompiler.compile_block(block, params, $container);
      if ($send_button = this.get_element("send-button")) {
        return $send_button.click(function() {
          var $_body, body, post_params;
          if ($_body = _this.get_element("body")) {
            body = $_body.attr("value");
            if (Utils.is_text_empty(body)) {
              Utils.display_error("Please enter the message");
              return;
            }
            post_params = {};
            post_params['group_nid'] = params['nid'];
            post_params['body'] = body;
            post_params['notification_type'] = "message";
            post_params['workbranch'] = Page.get_current_page_parameters()['workbranch'];
            post_params['action'] = "add";
            post_params['type'] = "messages";
            Overlay.set_loading("sending..");
            Overlay.show();
            AjaxManager.query("POST", Application.POST_URI, post_params, function(response) {
              return EternaUtils.process_response(response, function(data) {
                return _body.attr("value", "");
              });
            }, function(data) {
              return Utils.display_error("Could not send the message : " + data['errors']);
            });
            return Overlay.hide();
          }
        });
      }
    };

    return BuilderOverlayMessages;

  })(Builder);

  this.BuilderOverlayInviteMember = (function(_super) {
    __extends(BuilderOverlayInviteMember, _super);

    function BuilderOverlayInviteMember() {
      _ref4 = BuilderOverlayInviteMember.__super__.constructor.apply(this, arguments);
      return _ref4;
    }

    BuilderOverlayInviteMember.prototype.on_build = function(block, $container, params) {
      var $send_button,
        _this = this;
      ThemeCompiler.compile_block(block, params, $container);
      if ($send_button = this.get_element("send-button")) {
        return $send_button.click(function() {
          var $_body, $_to, body, nid, post_params, to;
          $_body = document.getElementById("invite-message");
          body = $_body.innerHTML;
          if ($_to = _this.get_element("to")) {
            to = $_to.attr("value");
            if (Utils.is_text_empty(to)) {
              Utils.display_error("Please enter the member's name");
              return;
            }
            nid = params['nid'];
            post_params = {};
            post_params['group_nid'] = params['nid'];
            post_params['target_names'] = to;
            post_params['body'] = body;
            post_params['notification_type'] = "message";
            post_params['workbranch'] = Page.get_current_page_parameters()['workbranch'];
            post_params['action'] = "add";
            post_params['type'] = "invite_member";
            Overlay.set_loading("sending..");
            Overlay.show();
            Group.invite_member(post_params, function(data) {
              return alert(data['error']);
            });
            return Overlay.hide();
          }
        });
      }
    };

    return BuilderOverlayInviteMember;

  })(Builder);

  this.BuilderOverlayAddAdmin = (function(_super) {
    __extends(BuilderOverlayAddAdmin, _super);

    function BuilderOverlayAddAdmin() {
      _ref5 = BuilderOverlayAddAdmin.__super__.constructor.apply(this, arguments);
      return _ref5;
    }

    BuilderOverlayAddAdmin.prototype.on_build = function(block, $container, params) {
      var $send_button,
        _this = this;
      ThemeCompiler.compile_block(block, params, $container);
      if ($send_button = this.get_element("send-button")) {
        return $send_button.click(function() {
          var $_body, $_to, body, nid, post_params, to;
          $_body = document.getElementById("add-message");
          body = $_body.innerHTML;
          if ($_to = _this.get_element("to")) {
            to = $_to.attr("value");
            if (Utils.is_text_empty(to)) {
              Utils.display_error("Please enter the member's name");
              return;
            }
            nid = params['nid'];
            post_params = {};
            post_params['group_nid'] = params['nid'];
            post_params['target_names'] = to;
            post_params['body'] = body;
            post_params['notification_type'] = "message";
            post_params['workbranch'] = Page.get_current_page_parameters()['workbranch'];
            post_params['action'] = "add";
            post_params['type'] = "add_admin";
            Overlay.set_loading("sending..");
            Overlay.show();
            Group.add_admin(post_params, function(data) {
              return alert(data['error']);
            });
            return Overlay.hide();
          }
        });
      }
    };

    return BuilderOverlayAddAdmin;

  })(Builder);

  this.BuilderGroupCreate = (function(_super) {
    __extends(BuilderGroupCreate, _super);

    function BuilderGroupCreate() {
      _ref6 = BuilderGroupCreate.__super__.constructor.apply(this, arguments);
      return _ref6;
    }

    BuilderGroupCreate.prototype.on_build = function(block, $container, params) {
      var $cancel, $create_group,
        _this = this;
      ThemeCompiler.compile_block(block, params, $container);
      if ($create_group = this.get_element("create-button")) {
        $create_group.click(function() {
          var $description, $group_profile, $private, $public, $title;
          $title = _this.get_element("group-title-input");
          if ($title.attr('value') === "") {
            alert("You have to write the title!!");
            return;
          }
          $description = _this.get_element("group-description-input");
          if ($description.attr('value') === "") {
            alert("You have to write to description!!");
            return;
          }
          $private = _this.get_element("private");
          $public = _this.get_element("public");
          if (!($private.attr('checked') || $public.attr('checked'))) {
            alert("You have to select a type");
            return;
          }
          Overlay.set_loading("replying..");
          Overlay.show();
          if ($group_profile = _this.get_element("group_profile")) {
            $group_profile.submit();
          }
          return Overlay.hide();
        });
      }
      if ($cancel = this.get_element("cancel-button")) {
        return $cancel.click(function() {
          return Utils.redirect_to("/web/group/");
        });
      }
    };

    return BuilderGroupCreate;

  })(Builder);

  this.BuilderGroupEdit = (function(_super) {
    __extends(BuilderGroupEdit, _super);

    function BuilderGroupEdit() {
      _ref7 = BuilderGroupEdit.__super__.constructor.apply(this, arguments);
      return _ref7;
    }

    BuilderGroupEdit.prototype.on_build = function(block, $container, params) {
      var nid,
        _this = this;
      nid = params['nid'];
      if (!(nid != null)) {
        Utils.display_error("nid not specified");
        return;
      }
      return PageData.get_group(nid, null, null, null, function(page) {
        var $add_admin, $cancel, $edit, $invite_member, group, input_params;
        group = page['group'];
        input_params = {};
        input_params['group_name'] = group['name'];
        input_params['group_description'] = EternaUtils.format_body(group['body']);
        input_params['group_picture'] = group['picture'];
        input_params['is_private'] = group['is_private'];
        input_params['nid'] = nid;
        ThemeCompiler.compile_block(block, input_params, $container);
        if ($edit = _this.get_element("edit-button")) {
          $edit.click(function() {
            var $group_profile;
            Overlay.set_loading("replying..");
            Overlay.show();
            if ($group_profile = _this.get_element("group_profile")) {
              $group_profile.submit();
            }
            return Overlay.hide();
          });
        }
        if ($cancel = _this.get_element("cancel-button")) {
          $cancel.click(function() {
            return Utils.redirect_to("/web/group/" + nid + "/");
          });
        }
        if ($invite_member = _this.get_element("invite-member")) {
          $invite_member.click(function() {
            var $overlay_slot;
            block = Blocks("overlay-invite-message");
            $overlay_slot = Overlay.get_slot("invite-member");
            Overlay.load_overlay_content("invite-member");
            Overlay.show();
            if (block['template_context_variables_'] === null) {
              return block.add_block($overlay_slot);
            }
          });
        }
        if ($add_admin = _this.get_element("add-admin")) {
          return $add_admin.click(function() {
            var $overlay_slot;
            block = Blocks("overlay-add-admin-message");
            $overlay_slot = Overlay.get_slot("add-admin");
            Overlay.load_overlay_content("add-admin");
            Overlay.show();
            if (block['template_context_variables_'] === null) {
              return block.add_block($overlay_slot);
            }
          });
        }
      }, function(data) {
        return alert(JSON.stringify(data));
      });
    };

    return BuilderGroupEdit;

  })(Builder);

}).call(this);
