// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1, _ref2,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.BuilderUser = (function(_super) {
    __extends(BuilderUser, _super);

    function BuilderUser() {
      _ref = BuilderUser.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    BuilderUser.prototype.on_build = function(block, $container, params) {
      var $logout, user,
        _this = this;
      user = Application.CURRENT_USER;
      params['uid'] = user['uid'];
      params['username'] = user["name"];
      params['userpicture'] = EternaUtils.get_user_picture(user['picture']);
      params['userrank'] = user["rank"];
      params['usermoney'] = user["points"] ? user['points'] : 0;
      ThemeCompiler.compile_block(block, params, $container);
      $logout = this.get_element("logout");
      if ($logout != null) {
        return $logout.click(function() {
          var location, url_parameters;
          Overlay.set_loading();
          Overlay.show();
          url_parameters = {
            workbranch: Application.WORKBRANCH,
            destination_url: String(window.location)
          };
          location = "/eterna_logout.php" + "?" + Utils.generate_parameter_string(url_parameters, true);
          return Utils.redirect_to(location);
        });
      }
    };

    return BuilderUser;

  })(Builder);

  this.BuilderLogin = (function(_super) {
    __extends(BuilderLogin, _super);

    function BuilderLogin() {
      _ref1 = BuilderLogin.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    BuilderLogin.prototype.on_build = function(block, $container, params) {
      var $login, $password, $username, e, incognito_body, incognito_data, input,
        _this = this;
      input = {};
      incognito_body = CookieManager.get_cookie("incognito_body");
      if (incognito_body != null) {
        try {
          incognito_data = JSON.parse(incognito_body);
          input.incognito_points = incognito_data['points'];
        } catch (_error) {
          e = _error;
          input = null;
        }
      }
      ThemeCompiler.compile_block(block, input, $container);
      $username = this.get_element("username");
      $password = this.get_element("password");
      $login = this.get_element("login");
      if (!$username || !$password || !$login) {
        Utils.display_error("Element missing in BuilderLogin");
        return;
      }
      $username.keyup(function(e) {
        if (e.keyCode === KeyCode.KEYCODE_ENTER) {
          return $login.click();
        }
      });
      $password.keyup(function(e) {
        if (e.keyCode === KeyCode.KEYCODE_ENTER) {
          return $login.click();
        }
      });
      return $login.click(function() {
        var login_params, password, username;
        username = $username.attr("value");
        password = $password.attr("value");
        $username.blur();
        $password.blur();
        if (Utils.is_text_empty(username)) {
          Utils.display_error("Please enter username");
          return;
        }
        if (Utils.is_text_empty(password)) {
          Utils.display_error("Please enter password");
        }
        Overlay.set_loading();
        Overlay.show();
        login_params = {};
        login_params['name'] = username;
        login_params['pass'] = password;
        login_params['type'] = "login";
        login_params['workbranch'] = Application.WORKBRANCH;
        return AjaxManager.query("POST", "/login/", login_params, function(ret) {
          var data;
          data = ret['data'];
          if (!data) {
            Utils.display_error("Regiser failed - no response");
            return;
          }
          if (data['success']) {
            return Utils.reload();
          } else {
            Utils.display_error("Register error : " + data["error"]);
            return Overlay.hide();
          }
        });
      });
    };

    return BuilderLogin;

  })(Builder);

  this.BuilderRegister = (function(_super) {
    __extends(BuilderRegister, _super);

    function BuilderRegister() {
      _ref2 = BuilderRegister.__super__.constructor.apply(this, arguments);
      return _ref2;
    }

    BuilderRegister.prototype.on_build = function(block, $container, params) {
      var $email, $nova_transfer, $password, $password_confirm, $password_transfer, $register, $username, $username_transfer, e, incognito_body, incognito_data, input, redirect_url, user,
        _this = this;
      input = {};
      incognito_body = CookieManager.get_cookie("incognito_body");
      if (incognito_body != null) {
        try {
          incognito_data = JSON.parse(incognito_body);
          input.incognito_points = incognito_data['points'];
        } catch (_error) {
          e = _error;
          input = null;
        }
      }
      redirect_url = "/web/";
      if (params['redirect_url'] != null) {
        redirect_url = params['redirect_url'];
      }
      ThemeCompiler.compile_block(block, input, $container);
      $username = this.get_element("username-input");
      $password = this.get_element("password-input");
      $password_confirm = this.get_element("password-confirm-input");
      $email = this.get_element("email-input");
      $register = this.get_element("register-button");
      setTimeout(function() {
        return grecaptcha.render("recaptcha-container", {
          "sitekey": "6LcFwUsUAAAAAOQ9szhauSNv2bJuBOUtw_pGrRnd",
          "theme": "white"
        });
      });
      if (!$username || !$password || !$password_confirm || !$email || !$register) {
        Utils.display_error("Element missing in BuilderRegister");
        return;
      }
      $username.keyup(function(e) {
        if (e.keyCode === KeyCode.KEYCODE_ENTER) {
          return $register.click();
        }
      });
      $password.keyup(function(e) {
        if (e.keyCode === KeyCode.KEYCODE_ENTER) {
          return $register.click();
        }
      });
      $password_confirm.keyup(function(e) {
        if (e.keyCode === KeyCode.KEYCODE_ENTER) {
          return $register.click();
        }
      });
      $email.keyup(function(e) {
        if (e.keyCode === KeyCode.KEYCODE_ENTER) {
          return $register.click();
        }
      });
      $register.click(function() {
        var captcha_response, email, login_params, password, password_confirm, username;
        username = $username.attr("value");
        password = $password.attr("value");
        password_confirm = $password_confirm.attr("value");
        email = $email.attr("value");
        captcha_response = grecaptcha.getResponse();
        $username.blur();
        $password.blur();
        $password_confirm.blur();
        $email.blur();
        if (Utils.is_text_empty(username)) {
          Utils.display_error("Please enter username");
          return;
        }
        if (Utils.is_text_empty(password)) {
          Utils.display_error("Please enter password");
          return;
        }
        if (password !== password_confirm) {
          Utils.display_error("Password and re-entered password doesn't match");
          return;
        }
        if (Utils.is_text_empty(captcha_response)) {
          Utils.display_error("Please complete the captcha");
          return;
        }
        Overlay.set_loading();
        Overlay.show();
        login_params = {};
        login_params['name'] = username;
        login_params['pass'] = password;
        login_params['mail'] = email;
        login_params['captcha_response'] = captcha_response;
        login_params['type'] = "create";
        login_params['workbranch'] = Application.WORKBRANCH;
        return AjaxManager.query("POST", "/login/", login_params, function(ret) {
          var data;
          data = ret['data'];
          if (!data) {
            Utils.display_error("Regiser failed - no response");
            return;
          }
          if (data['success']) {
            return Utils.redirect_to(redirect_url);
          } else {
            Utils.display_error("Register error : " + data["error"]);
            return Overlay.hide();
          }
        });
      });
      $nova_transfer = this.get_element("nova-transfer-button");
      if ($nova_transfer !== null) {
        $username_transfer = this.get_element("username-transfer-input");
        $password_transfer = this.get_element("password-transfer-input");
        user = Application.CURRENT_USER;
        if (user !== void 0) {
          $username_transfer.attr("value", user['name']);
          $password_transfer.attr("value", "12345678");
        }
        $username_transfer.keyup(function(e) {
          if (e.keyCode === KeyCode.KEYCODE_ENTER) {
            return $nova_transfer.click();
          }
        });
        $password_transfer.keyup(function(e) {
          if (e.keyCode === KeyCode.KEYCODE_ENTER) {
            return $nova_transfer.click();
          }
        });
        return $nova_transfer.click(function() {
          var login_params, password, username;
          username = $username_transfer.attr("value");
          password = $password_transfer.attr("value");
          $username_transfer.blur();
          $password_transfer.blur();
          if (Utils.is_text_empty(username)) {
            Utils.display_error("Please enter username");
            return;
          }
          if (Utils.is_text_empty(password)) {
            Utils.display_error("Please enter password");
            return;
          }
          Overlay.set_loading();
          Overlay.show();
          login_params = {};
          login_params['name'] = username;
          login_params['pass'] = password;
          login_params['type'] = "novatransfer";
          login_params['workbranch'] = Application.WORKBRANCH;
          return AjaxManager.query("POST", "/login/", login_params, function(ret) {
            var data;
            data = ret['data'];
            if (!data) {
              Utils.display_error("Nova transfer failed - no response");
              return;
            }
            if (data['success']) {
              return Utils.redirect_to(redirect_url);
            } else {
              Utils.display_error("Nova transfer error : " + data["error"]);
              return Overlay.hide();
            }
          });
        });
      }
    };

    return BuilderRegister;

  })(Builder);

}).call(this);
