// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.BuilderMe = (function(_super) {
    __extends(BuilderMe, _super);

    function BuilderMe() {
      _ref = BuilderMe.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    BuilderMe.prototype.on_build = function(block, $container, params) {
      var process_incognito,
        _this = this;
      process_incognito = (Application.CURRENT_USER != null) && ((Application.CURRENT_USER['points'] === null) || (parseInt(Application.CURRENT_USER['points']) === 0)) && (CookieManager.get_cookie("incognito_id") != null);
      if (process_incognito) {
        params['processing_incognito'] = true;
        ThemeCompiler.compile_block(block, params, $container);
        return PageData.process_incognito(function() {
          return Utils.reload();
        }, function() {
          Utils.display_error("Failed to reclaim your points. Please try again later");
          return _this.build_me(block, $container, params);
        });
      } else {
        return this.build_me(block, $container, params);
      }
    };

    BuilderMe.prototype.build_me = function(block, $container, params) {
      var size,
        _this = this;
      if (params['filter'] === void 0) {
        params['filter'] = "all";
      }
      params['all_url'] = "/web/?filter=all";
      params['notifications_url'] = "/web/?filter=notifications";
      params['news_url'] = "/web/?filter=news";
      params['blogs_url'] = "/web/?filter=blogs";
      if (Application.CURRENT_USER) {
        params['uid'] = Application.CURRENT_USER['uid'];
      }
      size = 4;
      if (!(params['size'] != null) && (params['sort'] != null) && params['sort'] === 'date') {
        size = 16;
      }
      return PageData.get_me(params['filter'], size, function(me_page) {
        var $ach_data, $achievement_roadmap, $achievements, $banner_lab_link, $lab_cards_map, $lab_member_panel, $lab_training_panel, $lab_training_roadmap, $loading, $newsfeed, $overlay_slot, $side_quest_roadmap, $start_lab_link, ach, achievements, achievements_params, active_node, aparams, current_lab, ii, jj, key, lab_todo, next_level, packer, roadmap, roadmap_nodes, roadmap_params, _i, _ref1;
        ThemeCompiler.compile_block(block, params, $container);
        $lab_member_panel = _this.get_element("lab-member-panel");
        $achievement_roadmap = _this.get_element("achievement-roadmap");
        $lab_cards_map = _this.get_element("lab-cards-map");
        $side_quest_roadmap = _this.get_element("side-quest-roadmap");
        $achievements = _this.get_element("achievements");
        $newsfeed = _this.get_element("newsfeed");
        if ((!$achievements && !$newsfeed) || (!$achievement_roadmap && !$lab_member_panel && !newsfeed)) {
          Utils.display_error("Element missing in BuilderMe");
          return;
        }
        if (current_lab = me_page['current_lab']) {
          if ($banner_lab_link = document.getElementById("banner-lab-link")) {
            $banner_lab_link.href = "/web/lab/" + current_lab + "/";
          }
          if (($lab_member_panel != null)) {
            if ($start_lab_link = _this.get_element("start-lab-link")) {
              $start_lab_link.attr("href", "/web/lab/" + current_lab + "/");
            }
          }
        }
        if ($lab_training_panel = _this.get_element("lab-training-panel")) {
          $lab_training_roadmap = _this.get_element("lab-training-roadmap");
          PageData.get_side_project_roadmap(function(data) {
            var $side_projects, ach_type, ii, node, packer, roadmap, roadmap_nodes, roadmap_params, _i, _ref1;
            if (($side_projects = data['achievement_roadmap'])) {
              packer = Packers($lab_training_roadmap);
              roadmap_params = [];
              roadmap = new Roadmap();
              roadmap.set_nodes($side_projects, false, ach_type = "side-quests");
              roadmap_nodes = roadmap.get_nodes();
              for (ii = _i = 0, _ref1 = roadmap_nodes.length - 1; _i <= _ref1; ii = _i += 1) {
                node = roadmap_nodes[ii];
                if (node.key.indexOf("side_quest") > -1) {
                  if (node.key.indexOf("switch") > -1) {
                    if (roadmap_params.length < 3) {
                      node.state = 'active';
                      roadmap_params.push(node);
                    }
                  }
                }
              }
              return packer.add(roadmap_params);
            }
          });
        }
        if (($achievement_roadmap != null) && ($ach_data = me_page['achievement_roadmap'])) {
          packer = Packers($achievement_roadmap);
          roadmap_params = [];
          roadmap = new Roadmap();
          roadmap.set_nodes($ach_data, false);
          roadmap_nodes = roadmap.get_nodes();
          active_node = null;
          for (ii = _i = 0, _ref1 = roadmap_nodes.length - 1; _i <= _ref1; ii = _i += 1) {
            if (roadmap_nodes[ii].key === "ten_tools") {
              if (roadmap_nodes[ii].state === "active") {
                active_node = ii;
              }
              roadmap_params.push(roadmap_nodes[ii]);
            }
          }
          next_level = roadmap_params.length + 1;
          lab_todo = {
            image: "/puzzle-progression/badges/badge_lab_unlocked.png",
            title: "Participate in real experiments",
            desc: "Participate in the current RNA design experiments",
            verb: "Explore",
            width: 128,
            height: 128,
            link: "/web/labs/explore/",
            key: "ten_tools",
            state: "inactive",
            node_key: "ten_tools_lab_access",
            level: next_level
          };
          if (Application.GLOBAL_THEME_PARAMETERS['is_lab_member'] === true) {
            lab_todo['state'] = "active";
            if (roadmap_params[roadmap_params.length - 1].state === "cleared") {
              active_node = roadmap_params.length;
            }
          }
          roadmap_params.push(lab_todo);
          packer.add(roadmap_params);
          _this.init_roadmap_slick(active_node);
          _this.show_roadmap_status(roadmap_params, active_node);
        }
        if (($side_quest_roadmap != null)) {
          $side_quest_roadmap.fadeTo(0, 0);
          if ($loading = _this.get_element("loading-side-projects")) {
            $loading.show();
          }
          PageData.get_side_project_roadmap(function(data) {
            var $side_projects, $side_quest_roadmap_panel, ach_type, node, _j, _ref2;
            if (($side_projects = data['achievement_roadmap'])) {
              packer = Packers($side_quest_roadmap);
              roadmap_params = [];
              roadmap = new Roadmap();
              roadmap.set_nodes($side_projects, false, ach_type = "side-quests");
              roadmap_nodes = roadmap.get_nodes();
              for (ii = _j = 0, _ref2 = roadmap_nodes.length - 1; _j <= _ref2; ii = _j += 1) {
                node = roadmap_nodes[ii];
                if (node.key.indexOf("side_quest") > -1) {
                  if (node.state === "active") {
                    roadmap_params.push(node);
                  } else if (node.state === "cleared" && node.level === node.maxlevel) {
                    roadmap_params.push(node);
                  } else if ((params['display_all_sp'] != null)) {
                    node.state = "active";
                    roadmap_params.push(node);
                  }
                }
              }
              if (roadmap_params.length > 0) {
                packer.add(roadmap_params);
                if ($loading = _this.get_element("loading-side-projects")) {
                  $loading.hide();
                }
                return $side_quest_roadmap.fadeTo(300, 1);
              } else {
                $side_quest_roadmap_panel = _this.get_element("side-quest-roadmap-panel");
                return $side_quest_roadmap_panel.hide();
              }
            }
          });
        }
        if (($achievements != null) && (achievements = me_page["achievements"])) {
          packer = Packers($achievements);
          achievements_params = [];
          jj = 0;
          for (key in achievements) {
            if (!__hasProp.call(achievements, key)) continue;
            ach = achievements[key];
            jj++;
            aparams = {};
            aparams["img"] = ach["image"];
            aparams["name"] = ach["title"];
            aparams["desc"] = ach["desc"];
            aparams["past"] = ach["past"];
            if (jj > 7) {
              break;
            }
            achievements_params.push(aparams);
          }
          packer.add(achievements_params);
        }
        _this.init_home_page_slick();
        if ($newsfeed != null) {
          _this.build_newsfeed(me_page, $newsfeed, params);
        }
        if (Application.CURRENT_USER['Survey'].indexOf("EULA_Agree") < 0) {
          block = Blocks("follow-survey-box");
          $overlay_slot = Overlay.get_slot("follow-survey-box-surveys");
          Overlay.load_overlay_content("follow-survey-box-surveys");
          Overlay.show();
          return block.add_block($overlay_slot, params);
        }
      });
    };

    BuilderMe.prototype.clear_notifications = function() {
      var $menu_item, post_params,
        _this = this;
      document.title = "Eterna - Invent Medicine";
      if ($menu_item = $("a#menu-item-newsfeed")) {
        $menu_item.removeClass("notification");
      }
      post_params = {};
      post_params['type'] = "notification_read";
      return AjaxManager.query("POST", Application.POST_URI, post_params, function(response) {
        return EternaUtils.process_response(response, function(data) {});
      });
    };

    BuilderMe.prototype.build_newsfeed = function(me_page, $newsfeed, params) {
      var $all, $blogs, $groups, $messages, $more_message, $my_labs_statistics, $newsmyfeeds, $rewards, blogs_data, groups_data, me, my_labs_statistics, mylab, newsfeed_data, notis_data, packer, pageindex, rewards_data, status, _i, _len,
        _this = this;
      this.clear_notifications();
      pageindex = 1;
      if ((params['sort'] != null) && params['sort'] === 'date') {
        status = this.newsfeed_chronology_generate(me_page, $newsfeed, pageindex);
      } else {
        if (notis_data = me_page["notifications"]) {
          this.notification_generate(notis_data, $newsfeed);
        }
        if (newsfeed_data = me_page["newsfeeds"]) {
          this.news_generate(newsfeed_data, $newsfeed);
        }
        if (blogs_data = me_page["blogslist"]) {
          this.blogs_generate(blogs_data, $newsfeed);
        }
        if (rewards_data = me_page["rewards"]) {
          this.rewards_generate(rewards_data, $newsfeed);
        }
        if (groups_data = me_page["groups"]) {
          this.groups_generate(groups_data, $newsfeed);
        }
      }
      if (my_labs_statistics = me_page["my_labs_statistics"]) {
        if ($my_labs_statistics = this.get_element("my-labs-statistics")) {
          packer = Packers($my_labs_statistics);
          for (_i = 0, _len = my_labs_statistics.length; _i < _len; _i++) {
            mylab = my_labs_statistics[_i];
            mylab['thumbnail'] = EternaUtils.get_puzzle_middle_thumbnail(mylab['nid']);
          }
          packer.add(my_labs_statistics);
        }
      } else {
        if ($my_labs_statistics = this.get_element("my-labs")) {
          $my_labs_statistics.css("display", "none");
        }
      }
      me = this;
      if ($more_message = this.get_element("more-message")) {
        $more_message.click(function() {
          var $more_loading,
            _this = this;
          $more_loading = me.get_element("more-loading");
          $more_loading.show();
          if (params['filter'] === "all" && (params['sort'] != null) && params['sort'] === 'date') {
            return PageData.get_newsfeed(0, params['filter'], (++pageindex) * 16, function(data) {
              $newsfeed = me.get_element("newsfeed");
              status = me.newsfeed_chronology_generate(data, $newsfeed, pageindex);
              if (status === false) {
                $more_message.hide();
              } else {
                $more_message.show();
              }
              return $more_loading.hide();
            });
          } else {
            return PageData.get_newsfeed(pageindex++, params['filter'], 4, function(data) {
              var bl_data, go_data, ne_data, no_data, re_data;
              $newsfeed = me.get_element("newsfeed");
              if (no_data = data["notifications"]) {
                me.notification_generate(no_data, $newsfeed);
              }
              if (ne_data = data["newsfeeds"]) {
                me.news_generate(ne_data, $newsfeed);
              }
              if (bl_data = data["blogslist"]) {
                me.blogs_generate(bl_data, $newsfeed);
              }
              if (re_data = data["rewards"]) {
                me.rewards_generate(re_data, $newsfeed);
              }
              if (go_data = data["groups"]) {
                me.groups_generate(go_data, $newsfeed);
              }
              if (!no_data && !ne_data && !bl_data && !re_data && !go_data) {
                $more_message.hide();
              } else {
                $more_message.show();
              }
              return $more_loading.hide();
            });
          }
        });
      }
      if ($all = this.get_element("all")) {
        $all.click(function() {
          params['filter'] = "all";
          if ((params['sort'] != null) && params['sort'] === 'date') {
            me.set_clickable(params['filter']);
            $newsfeed.html("");
            return me.build_newsfeed(me_page, $newsfeed, params);
          } else {
            pageindex = 1;
            return me.filter_clicked("all");
          }
        });
      }
      if ($messages = this.get_element("messages")) {
        $messages.click(function() {
          pageindex = 1;
          me.filter_clicked("notifications");
          params['filter'] = "notifications";
          return params['size'] = "4";
        });
      }
      if ($newsmyfeeds = this.get_element("news")) {
        $newsmyfeeds.click(function() {
          pageindex = 1;
          me.filter_clicked("news");
          params['filter'] = "news";
          return params['size'] = "4";
        });
      }
      if ($blogs = this.get_element("blogs")) {
        $blogs.click(function() {
          pageindex = 1;
          me.filter_clicked("blogs");
          params['filter'] = "blogs";
          return params['size'] = "4";
        });
      }
      if ($rewards = this.get_element("rewards")) {
        $rewards.click(function() {
          pageindex = 1;
          me.filter_clicked("rewards");
          params['filter'] = "rewards";
          return params['size'] = "4";
        });
      }
      if ($groups = this.get_element("groups")) {
        return $groups.click(function() {
          pageindex = 1;
          me.filter_clicked("groups");
          params['filter'] = "groups";
          return params['size'] = "4";
        });
      }
    };

    BuilderMe.prototype.survey_clicked = function(y) {
      var _this = this;
      if ($("#agree_button").prop("disabled") === false) {
        Me.update_survey(Application.CURRENT_USER['uid'], "EULA_Agree", function(data) {});
        return Overlay.hide();
      }
    };

    BuilderMe.prototype.survey_clicked_no = function(y) {
      var _this = this;
      Me.update_survey(Application.CURRENT_USER['uid'], "No", function(data) {});
      return Overlay.hide();
    };

    BuilderMe.prototype.filter_clicked = function(filter) {
      var $more_loading, $more_message, $newsfeed,
        _this = this;
      $newsfeed = this.get_element("newsfeed");
      $newsfeed.html("");
      $more_loading = this.get_element("more-loading");
      $more_loading.show();
      $more_message = this.get_element("more-message");
      $more_message.show();
      return PageData.get_newsfeed(0, filter, 4, function(data) {
        var bl_data, go_data, ne_data, no_data, re_data;
        if (no_data = data['notifications']) {
          _this.notification_generate(no_data, $newsfeed);
        }
        if (ne_data = data['newsfeeds']) {
          _this.news_generate(ne_data, $newsfeed);
        }
        if (bl_data = data['blogslist']) {
          _this.blogs_generate(bl_data, $newsfeed);
        }
        if (re_data = data['rewards']) {
          _this.rewards_generate(re_data, $newsfeed);
        }
        if (go_data = data['groups']) {
          _this.groups_generate(go_data, $newsfeed);
        }
        _this.set_clickable(filter);
        return $more_loading.hide();
      });
    };

    BuilderMe.prototype.set_clickable = function(filter) {
      var $all, $blogs, $groups, $messages, $news, $rewards, style;
      $all = this.get_element("all");
      $messages = this.get_element("messages");
      $news = this.get_element("news");
      $blogs = this.get_element("blogs");
      $rewards = this.get_element("rewards");
      $groups = this.get_element("groups");
      $all.attr("style", "");
      $messages.attr("style", "");
      $news.attr("style", "");
      $blogs.attr("style", "");
      $rewards.attr("style", "");
      $groups.attr("style", "");
      style = "font-weight: bold; text-decoration:underline;";
      if (filter === "all") {
        $all.attr("style", style);
      }
      if (filter === "notifications") {
        $messages.attr("style", style);
      }
      if (filter === "news") {
        $news.attr("style", style);
      }
      if (filter === "blogs") {
        $blogs.attr("style", style);
      }
      if (filter === "rewards") {
        $rewards.attr("style", style);
      }
      if (filter === "groups") {
        return $groups.attr("style", style);
      }
    };

    BuilderMe.prototype.newsfeed_chronology_generate = function(me_page, $newsfeed, pageindex) {
      var $mark_as_read, $reply_button, block, blogs_data, body, feed_chrono, feed_data, feed_item, groups_data, ii, jj, message_array, message_obj, msg_obj, newsfeed_data, nitems, notification, notis_data, nskip, rewards_data, _i, _j, _k, _l, _len, _len1, _m, _n, _o, _p, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6;
      feed_data = [];
      nitems = pageindex * 16;
      nskip = (pageindex - 1) * 16;
      if (nskip > 0) {
        nskip++;
      }
      if (notis_data = me_page["notifications"]) {
        for (_i = 0, _len = notis_data.length; _i < _len; _i++) {
          notification = notis_data[_i];
          message_array = notification['message'];
          for (jj = _j = 0, _ref1 = message_array.length - 1; 0 <= _ref1 ? _j <= _ref1 : _j >= _ref1; jj = 0 <= _ref1 ? ++_j : --_j) {
            msg_obj = this.parse_notification_message(notification, message_array, jj);
            msg_obj['timestamp'] = parseInt(msg_obj['timestamp']);
            msg_obj['block_type'] = "newsfeed-noti";
            feed_data.push(msg_obj);
            if (jj >= nitems) {
              break;
            }
          }
        }
      }
      if (newsfeed_data = me_page["newsfeeds"]) {
        for (ii = _k = 0, _ref2 = newsfeed_data.length - 1; _k <= _ref2; ii = _k += 1) {
          body = EternaUtils.format_summary(newsfeed_data[ii]['body'], 250);
          feed_data.push({
            nid: newsfeed_data[ii]['nid'],
            title: newsfeed_data[ii]['title'],
            body: body,
            sticky: parseInt(newsfeed_data[ii]['sticky']) > 0,
            timestamp: parseInt(newsfeed_data[ii]['timestamp']),
            block_type: "newsfeed-news"
          });
          if (ii >= nitems) {
            break;
          }
        }
      }
      if (blogs_data = me_page["blogslist"]) {
        for (ii = _l = 0, _ref3 = blogs_data.length - 1; _l <= _ref3; ii = _l += 1) {
          body = EternaUtils.format_summary(blogs_data[ii]['body'], 250);
          feed_data.push({
            nid: blogs_data[ii]['nid'],
            title: blogs_data[ii]['title'],
            body: body,
            sticky: parseInt(blogs_data[ii]['sticky']) > 0,
            timestamp: parseInt(blogs_data[ii]['timestamp']),
            block_type: "blogs-list"
          });
          if (ii >= nitems) {
            break;
          }
        }
      }
      if (rewards_data = me_page["rewards"]) {
        for (ii = _m = 0, _ref4 = rewards_data.length - 1; _m <= _ref4; ii = _m += 1) {
          rewards_data[ii]['timestamp'] = parseInt(rewards_data[ii]['timestamp']);
          rewards_data[ii]['block_type'] = "newsfeed-reward";
          feed_data.push(rewards_data[ii]);
          if (ii >= nitems) {
            break;
          }
        }
      }
      if (groups_data = me_page["groups"]) {
        for (_n = 0, _len1 = groups_data.length; _n < _len1; _n++) {
          notification = groups_data[_n];
          message_array = notification['message'];
          for (jj = _o = 0, _ref5 = message_array.length - 1; _o <= _ref5; jj = _o += 1) {
            message_obj = this.parse_groups_message(notification, message_array, jj);
            message_obj['timestamp'] = parseInt(message_obj['timestamp']);
            message_obj['block_type'] = "newsfeed-groups";
            feed_data.push(message_obj);
            if (jj >= nitems) {
              break;
            }
          }
        }
      }
      if (feed_data.length < 1) {
        return false;
      }
      feed_chrono = feed_data.slice(0);
      feed_chrono.sort(function(a, b) {
        if (a.timestamp > b.timestamp) {
          return -1;
        }
        if (a.timestamp < b.timestamp) {
          return 1;
        }
        return 0;
      });
      if (nitems > feed_chrono.length) {
        nitems = feed_chrono.length;
      }
      for (ii = _p = nskip, _ref6 = nitems - 1; _p <= _ref6; ii = _p += 1) {
        block = Blocks(feed_chrono[ii]['block_type']);
        feed_item = block.add_block($newsfeed, feed_chrono[ii]);
        if (feed_chrono[ii]['block_type'] === "newsfeed-noti") {
          notification = feed_chrono[ii];
          if ($reply_button = feed_item.get_element("reply-button")) {
            (function(notification) {
              return $reply_button.click(function() {
                var $reply_body, content, nid, target_uid,
                  _this = this;
                nid = notification['nid'];
                if (notification['target_uid'] === Application.CURRENT_USER['uid']) {
                  target_uid = notification['target2_uid'];
                } else {
                  target_uid = notification['target_uid'];
                }
                if ($reply_body = $("." + nid).find("#reply-body")) {
                  content = Utils.markup(Utils.to_html($reply_body.attr("value")));
                  Overlay.set_loading("replying..");
                  Overlay.show();
                  return Me.reply(target_uid, content, nid, function(data) {
                    if (data['success']) {
                      return window.location.reload(true);
                    } else {
                      Utils.display_error("Could not perform notification action : " + data['error']);
                      return Overlay.hide();
                    }
                  });
                }
              });
            })(notification);
          }
          if ($mark_as_read = feed_item.get_element("mark-as-read")) {
            (function() {
              return $mark_as_read.click(function() {
                var noti_count;
                noti_count = Application.GLOBAL_THEME_PARAMETERS['noti_count'];
                return Application.GLOBAL_THEME_PARAMETERS['noti_count'] = noti_count - 1;
              });
            })();
          }
        }
      }
      return true;
    };

    BuilderMe.prototype.news_generate = function(newsfeed_data, $newsfeed) {
      var body, ii, news_block, _i, _ref1, _results;
      news_block = Blocks("newsfeed-news");
      _results = [];
      for (ii = _i = 0, _ref1 = newsfeed_data.length - 1; _i <= _ref1; ii = _i += 1) {
        body = EternaUtils.format_summary(newsfeed_data[ii]['body'], 250);
        _results.push(news_block.add_block($newsfeed, {
          nid: newsfeed_data[ii]['nid'],
          title: newsfeed_data[ii]['title'],
          body: body,
          sticky: parseInt(newsfeed_data[ii]['sticky']) > 0
        }));
      }
      return _results;
    };

    BuilderMe.prototype.blogs_generate = function(blogs_data, $newsfeed) {
      var blogs_block, body, ii, _i, _ref1, _results;
      blogs_block = Blocks("blogs-list");
      _results = [];
      for (ii = _i = 0, _ref1 = blogs_data.length - 1; _i <= _ref1; ii = _i += 1) {
        body = EternaUtils.format_summary(blogs_data[ii]['body'], 250);
        _results.push(blogs_block.add_block($newsfeed, {
          nid: blogs_data[ii]['nid'],
          title: blogs_data[ii]['title'],
          body: body,
          sticky: parseInt(blogs_data[ii]['sticky']) > 0
        }));
      }
      return _results;
    };

    BuilderMe.prototype.rewards_generate = function(rewards_data, $newsfeed) {
      var ii, reward_block, _i, _ref1, _results;
      reward_block = Blocks("newsfeed-reward");
      _results = [];
      for (ii = _i = 0, _ref1 = rewards_data.length - 1; _i <= _ref1; ii = _i += 1) {
        _results.push(reward_block.add_block($newsfeed, rewards_data[ii]));
      }
      return _results;
    };

    BuilderMe.prototype.parse_groups_message = function(notification, message_array, index) {
      var img, message, msg_obj, node, node_type, sender_name, sender_uid, target_name, target_uid, time, timestring, type;
      message = message_array[index];
      sender_uid = message['sender'];
      time = new Date(message['created'] * 1000);
      timestring = time.toDateString();
      if (sender_uid === notification['target_uid']) {
        img = EternaUtils.get_user_picture(notification['target_picture']);
        sender_name = notification['target_name'];
        target_name = notification['target2_name'];
        target_uid = notification['target2_uid'];
      } else {
        img = EternaUtils.get_user_picture(notification['target2_picture']);
        sender_name = notification['target2_name'];
        target_name = notification['target_name'];
        target_uid = notification['target_uid'];
      }
      type = message['type'];
      msg_obj = {};
      msg_obj["nid"] = notification['nid'];
      msg_obj["img"] = img;
      msg_obj["created_time"] = timestring;
      msg_obj["timestamp"] = message['created'];
      if (type === "comment") {
        msg_obj["ids"] = sender_name;
        msg_obj["body"] = message['content']['body'];
        if (node = message['content']['node']) {
          node_type = node['node_type'];
          msg_obj['node_id'] = node['id'];
          msg_obj['node_url'] = "/web/group/" + msg_obj['node_id'] + "/";
          msg_obj['node_title'] = node['title'];
          msg_obj['node_type'] = node_type;
          msg_obj['node_comment'] = true;
        }
      } else if (type === "group_message") {
        if (message['content']['group'] != null) {
          msg_obj["ids"] = "Group Message from " + message['content']['group'];
          msg_obj["body"] = message['content']['body'];
        } else {
          msg_obj["ids"] = sender_name + "&nbsp;&rarr;&nbsp;" + target_name;
          msg_obj["body"] = message['content'];
        }
      }
      return msg_obj;
    };

    BuilderMe.prototype.groups_generate = function(groups_data, $newsfeed) {
      var groups_block, jj, message_array, message_obj, notification, _i, _len, _results;
      if (groups_data != null) {
        groups_block = Blocks("newsfeed-groups");
        _results = [];
        for (_i = 0, _len = groups_data.length; _i < _len; _i++) {
          notification = groups_data[_i];
          message_array = notification['message'];
          _results.push((function() {
            var _j, _ref1, _results1;
            _results1 = [];
            for (jj = _j = 0, _ref1 = message_array.length - 1; 0 <= _ref1 ? _j <= _ref1 : _j >= _ref1; jj = 0 <= _ref1 ? ++_j : --_j) {
              message_obj = this.parse_groups_message(notification, message_array, jj);
              _results1.push(groups_block.add_block($newsfeed, message_obj));
            }
            return _results1;
          }).call(this));
        }
        return _results;
      }
    };

    BuilderMe.prototype.parse_notification_message = function(notification, message_array, index) {
      var content, img, message, msg_obj, node, node_type, puzzle, sender_name, sender_uid, target_name, target_uid, time, timestring, type;
      message = message_array[index];
      sender_uid = message['sender'];
      time = new Date(message['created'] * 1000);
      timestring = time.toDateString();
      if (sender_uid === notification['target_uid']) {
        img = EternaUtils.get_user_picture(notification['target_picture']);
        sender_name = notification['target_name'];
        target_name = notification['target2_name'];
        target_uid = notification['target2_uid'];
      } else {
        img = EternaUtils.get_user_picture(notification['target2_picture']);
        sender_name = notification['target2_name'];
        target_name = notification['target_name'];
        target_uid = notification['target_uid'];
      }
      type = message['type'];
      msg_obj = {};
      msg_obj["nid"] = notification['nid'];
      msg_obj["target_uid"] = notification['target_uid'];
      msg_obj["target2_uid"] = notification['target2_uid'];
      msg_obj["img"] = img;
      msg_obj["created_time"] = timestring;
      msg_obj["timestamp"] = message['created'];
      if (type === "message") {
        msg_obj["ids"] = "<a href=\"/web/player/" + sender_uid + "/\">" + sender_name + "</a>" + "&nbsp;&rarr;&nbsp;" + "<a href=\"/web/player/" + target_uid + "/\">" + target_name + "</a>";
        msg_obj["body"] = message['content'];
        if (index === message_array.length - 1) {
          msg_obj["show_reply_button"] = true;
          msg_obj["can_reply"] = true;
        } else {
          msg_obj["display"] = "none";
        }
      } else if (type === "comment") {
        msg_obj["ids"] = "<a href=\"/web/player/" + sender_uid + "/\">" + sender_name + "</a>";
        msg_obj["body"] = message['content']['body'];
        msg_obj["body"] = EternaUtils.format_comment_mentions(msg_obj["body"]);
        if (puzzle = message['content']['puzzle']) {
          message['content']['node'] = {};
          message['content']['node']['id'] = puzzle['id'];
          message['content']['node']['title'] = puzzle['title'];
          message['content']['node']['node_type'] = "puzzle";
        }
        if (node = message['content']['node']) {
          msg_obj['node_id'] = node['id'];
          msg_obj['node_title'] = node['title'];
          node_type = node['node_type'];
          msg_obj['node_type'] = node_type;
          if (node_type === "puzzle") {
            msg_obj['node_url'] = "/web/puzzle/" + msg_obj['node_id'] + "/";
          }
          if (node_type === "lab") {
            msg_obj['node_url'] = "/web/lab/" + msg_obj['node_id'] + "/";
          }
          if (node_type === "news") {
            msg_obj['node_url'] = "/web/news/" + msg_obj['node_id'] + "/";
          }
          if (node_type === "eterna_group") {
            msg_obj['node_url'] = "/web/group/" + msg_obj['node_id'] + "/";
          }
          if (node_type === "blog") {
            msg_obj['node_url'] = "/web/blog/" + msg_obj['node_id'] + "/";
          }
          if (node_type === "solution") {
            msg_obj['node_url'] = "/game/browse/" + node['puzzle_id'] + "/?filter1=Id&filter1_arg1=" + msg_obj['node_id'] + "&filter1_arg2=" + msg_obj['node_id'];
          }
          msg_obj['node_comment'] = true;
          if (message['content']['mention_alert'] != null) {
            msg_obj['mention_alert'] = true;
          }
          if (message['content']['moderator_alert'] != null) {
            msg_obj['moderator_alert'] = true;
          }
        }
      } else if (type === "commentnote") {
        msg_obj["ids"] = "<a href=\"/web/player/" + sender_uid + "/\">" + sender_name + "</a>";
        content = message['content'];
        if (content['node_type'] === "puzzle") {
          msg_obj["body"] = "";
          msg_obj['puzzle'] = true;
          msg_obj["puzzle_id"] = content["nid"];
          msg_obj["puzzle_title"] = content["title"];
        } else if (content['node_type'] === "solution") {
          msg_obj["body"] = "commented on the lab design";
        }
      }
      return msg_obj;
    };

    BuilderMe.prototype.notification_generate = function(notis_data, $newsfeed) {
      var $mark_as_read, $reply_button, jj, message_array, msg_obj, noti, noti_block, notification, _i, _len, _results;
      if (notis_data != null) {
        noti_block = Blocks("newsfeed-noti");
        _results = [];
        for (_i = 0, _len = notis_data.length; _i < _len; _i++) {
          notification = notis_data[_i];
          message_array = notification['message'];
          _results.push((function() {
            var _j, _ref1, _results1;
            _results1 = [];
            for (jj = _j = 0, _ref1 = message_array.length - 1; 0 <= _ref1 ? _j <= _ref1 : _j >= _ref1; jj = 0 <= _ref1 ? ++_j : --_j) {
              msg_obj = this.parse_notification_message(notification, message_array, jj);
              noti = noti_block.add_block($newsfeed, msg_obj);
              if ($reply_button = noti.get_element("reply-button")) {
                (function(notification) {
                  return $reply_button.click(function() {
                    var $reply_body, content, nid, target_uid,
                      _this = this;
                    nid = notification['nid'];
                    if (notification['target_uid'] === Application.CURRENT_USER['uid']) {
                      target_uid = notification['target2_uid'];
                    } else {
                      target_uid = notification['target_uid'];
                    }
                    if ($reply_body = $("." + nid).find("#reply-body")) {
                      content = Utils.markup(Utils.to_html($reply_body.attr("value")));
                      Overlay.set_loading("replying..");
                      Overlay.show();
                      return Me.reply(target_uid, content, nid, function(data) {
                        if (data['success']) {
                          return window.location.reload(true);
                        } else {
                          Utils.display_error("Could not perform notification action : " + data['error']);
                          return Overlay.hide();
                        }
                      });
                    }
                  });
                })(notification);
              }
              if ($mark_as_read = noti.get_element("mark-as-read")) {
                _results1.push((function(notification) {
                  return $mark_as_read.click(function() {
                    var noti_count;
                    noti_count = Application.GLOBAL_THEME_PARAMETERS['noti_count'];
                    return Application.GLOBAL_THEME_PARAMETERS['noti_count'] = noti_count - 1;
                  });
                })(notification));
              } else {
                _results1.push(void 0);
              }
            }
            return _results1;
          }).call(this));
        }
        return _results;
      }
    };

    BuilderMe.prototype.show_roadmap_status = function(roadmap_params, active_node) {
      var $bar, $curr_bar, $curr_thumbnail, $prev_bar, $thumbnail, $title, curr_ach, curr_link, ii, prev_ach_title, progress, puzlink, search, span_n, span_title, title, _i, _j, _ref1,
        _this = this;
      if (active_node === null) {
        return;
      }
      if (!(roadmap_params != null) || roadmap_params.length < 1) {
        return;
      }
      curr_ach = parseInt(roadmap_params[active_node].level);
      progress = roadmap_params[active_node].progress;
      if ((curr_ach != null) && (Application.GLOBAL_THEME_PARAMETERS['is_lab_member'] !== true)) {
        if ($title = this.get_element("status_tracker_header")) {
          if (curr_ach < 9) {
            span_n = "<span class='tool-count-box'>";
            span_n += 10 - curr_ach + 1;
            span_n += "</span>";
            $title.html("Earn " + span_n + " more tools to start real experiments");
          } else {
            span_n = "<span class='tool-count-box'>1</span>";
            $title.html("Earn " + span_n + " more tool to start real experiments");
          }
        }
      }
      if (curr_ach != null) {
        for (ii = _i = 0, _ref1 = curr_ach - 1; _i <= _ref1; ii = _i += 1) {
          if ($thumbnail = this.get_element("status_thumbnail_" + ii)) {
            $thumbnail.removeClass("deactive_thumbnail").addClass("cleared_thumbnail");
            if (ii > 0) {
              prev_ach_title = roadmap_params[ii - 1].title;
              search = "%5B" + prev_ach_title + "%5D";
              search = search.replace(/\s/g, "%20");
              puzlink = "/web/progression/?size=24&search=" + search + "&sort=date";
              span_title = "<span>" + prev_ach_title + "</span>";
            }
          }
          if ($bar = this.get_element("status_bar_" + ii)) {
            $bar.css('background-color', '#3192ac');
          }
        }
        if ($curr_thumbnail = this.get_element("status_thumbnail_" + curr_ach)) {
          curr_link = roadmap_params[active_node].link;
          span_title = "<span>" + roadmap_params[active_node].title + "</span>";
          $curr_thumbnail.removeClass("deactive_thumbnail").addClass("active_thumbnail");
        }
        if ($prev_bar = this.get_element("status_bar_" + curr_ach)) {
          $prev_bar.removeClass("long_progress_bar").addClass("prev_progress_bar");
          $prev_bar.css('background-color', '#3192ac');
        }
        if ($curr_bar = this.get_element("status_bar_" + curr_ach)) {
          $curr_bar.removeClass("long_progress_bar").addClass("curr_progress_bar");
          if (progress >= 100) {
            $curr_bar.css('background-color', '#3192AC');
          } else {
            $curr_bar.css('background', 'linear-gradient(left, #3192ac +' + progress + '%,#cccccc ' + progress + '%)');
            $curr_bar.css('background', '-webkit-linear-gradient(left, #3192ac +' + progress + '%,#cccccc ' + progress + '%)');
            $curr_bar.css('background', '-moz-linear-gradient(left, #3192ac +' + progress + '%,#cccccc ' + progress + '%)');
            $curr_bar.css('background', '-o-linear-gradient(left, #3192ac +' + progress + '%,#cccccc ' + progress + '%)');
          }
        }
      }
      for (ii = _j = 1; _j <= 10; ii = _j += 1) {
        if ($thumbnail = this.get_element("status_thumbnail_" + ii)) {
          title = roadmap_params[ii - 1].title;
          $thumbnail.html("<a href='#status_tracker_header' class='info-title'><span>" + title + "</span>" + $thumbnail.html() + "</a>");
        }
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 1)) {
        $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 0);
        });
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 2)) {
        $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 1);
        });
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 3)) {
        $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 2);
        });
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 4)) {
        $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 3);
        });
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 5)) {
        $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 4);
        });
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 6)) {
        $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 5);
        });
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 7)) {
        $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 6);
        });
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 8)) {
        $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 7);
        });
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 9)) {
        $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 8);
        });
      }
      if ($thumbnail = this.get_element("status_thumbnail_" + 10)) {
        return $thumbnail.on("mouseenter", function() {
          return $('.achievement-roadmap').slick('slickGoTo', 9);
        });
      }
    };

    BuilderMe.prototype.init_home_page_slick = function() {
      return $('.home-page-slick').slick({
        variableWidth: true,
        infinite: true,
        slidesToScroll: 1,
        autoplay: true,
        autoplaySpeed: 7000,
        pauseOnFocus: true,
        pauseOnHover: true,
        initialSlide: 0,
        centerMode: true,
        dots: true
      });
    };

    BuilderMe.prototype.init_roadmap_slick = function(active_node) {
      var init_slide, this2,
        _this = this;
      init_slide = active_node;
      if (init_slide < 0) {
        init_slide = 0;
      }
      $('.achievement-roadmap').slick({
        variableWidth: true,
        infinite: false,
        slidesToScroll: 1,
        initialSlide: init_slide,
        centerMode: true,
        centerPadding: '40px',
        speed: 400
      });
      $('.slick-slide').css({
        'width': '230px',
        'padding': '5px'
      });
      $('.slick-slider').css({
        'width': '720px',
        'height': '327px'
      });
      $('.slick-arrow').css({
        'z-index': '2000'
      });
      $('.slick-prev').css({
        'left': '330px',
        top: '115%'
      });
      $('.slick-next').css({
        'right': '330px',
        top: '115%'
      });
      $('.achievement-roadmap').slick('slickGoTo', init_slide, true);
      this2 = this;
      this2.init_achievement_descriptions();
      return $('.achievement-roadmap').on("afterChange", function(event, slick, currentSlide) {
        return this2.init_achievement_descriptions();
      });
    };

    BuilderMe.prototype.init_achievement_descriptions = function(currentSlide) {
      var $info, nextSlide, prevSlide;
      currentSlide = $('.achievement-roadmap').slick('slickCurrentSlide');
      if ($info = $("[data-slick-index='" + currentSlide + "']").find(".info-description-left")) {
        $info.removeClass("info-description-left").addClass("info-description");
      }
      prevSlide = parseInt(currentSlide) - 1;
      if ($info = $("[data-slick-index='" + prevSlide + "']").find(".info-description-left")) {
        $info.removeClass("info-description-left").addClass("info-description");
      }
      nextSlide = parseInt(currentSlide) + 1;
      if ($info = $("[data-slick-index='" + nextSlide + "']").find(".info-description")) {
        return $info.removeClass("info-description").addClass("info-description-left");
      }
    };

    BuilderMe.prototype.agree_check = function() {
      if ($("#agree_13").attr("checked") && $("#agree_terms").attr("checked") && $("#agree_respect").attr("checked")) {
        $("#agree_button").prop("disabled", false);
        $("#agree_button").css("cursor", "pointer");
        $("#agree_button").removeClass("gray-button");
        return $("#agree_button").addClass("green-button");
      } else if ($("#agree_button").prop("disabled") === false) {
        $("#agree_button").prop("disabled", true);
        $("#agree_button").css("cursor", "default");
        $("#agree_button").removeClass("green-button");
        return $("#agree_button").addClass("gray-button");
      }
    };

    return BuilderMe;

  })(Builder);

  this.BuilderFollowOverlay = (function(_super) {
    __extends(BuilderFollowOverlay, _super);

    function BuilderFollowOverlay() {
      _ref1 = BuilderFollowOverlay.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    BuilderFollowOverlay.prototype.on_build = function(block, $container, params) {
      ThemeCompiler.compile_block(block, params, $container);
      return this.generate_follow(params['title'], params['follow_type'], this.get_element("follow_info"));
    };

    BuilderFollowOverlay.prototype.generate_follow = function(block_title, follow_type, $follow_info) {
      var $loading,
        _this = this;
      $loading = this.get_element("loading");
      $loading.show();
      return Follow.get_follows(follow_type, function(follows) {
        var follow, follow_info, follow_params, packer, _i, _len;
        follows = follows['follows'];
        $follow_info.html("");
        if (follows.length === 0) {
          $follow_info.html("No " + block_title);
        } else {
          packer = Packers($follow_info);
          follow_params = [];
          for (_i = 0, _len = follows.length; _i < _len; _i++) {
            follow = follows[_i];
            follow_info = follow['followee_info'];
            if (follow_type === "puzzles") {
              follow_params.push({
                puzzle_title: follow_info['title'],
                puzzle_id: follow['id']
              });
            }
            if (follow_type === "users") {
              follow_params.push({
                user_name: follow_info['name'],
                user_picture: EternaUtils.get_user_picture(follow_info['picture']),
                uid: follow['id']
              });
            }
            if (follow_type === "groups") {
              follow_params.push({
                group_title: follow_info['title'],
                group_id: follow['id']
              });
            }
          }
          packer.add(follow_params);
        }
        return $loading.hide();
      }, function(error) {
        return alert(error);
      });
    };

    return BuilderFollowOverlay;

  })(Builder);

}).call(this);
