// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1, _ref2, _ref3,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.BuilderNewsPage = (function(_super) {
    __extends(BuilderNewsPage, _super);

    function BuilderNewsPage() {
      _ref = BuilderNewsPage.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    BuilderNewsPage.prototype.on_build = function(block, $container, params) {
      var nid,
        _this = this;
      Application.track_google_analytics_event("news", "open", "");
      nid = params['nid'];
      if (!(nid != null)) {
        Utils.display_error("nid not specified");
        return;
      }
      return PageData.get_news(nid, function(page) {
        var $follow, $unfollow, input_params, news;
        news = page['news'];
        input_params = {};
        input_params['title'] = news['title'];
        input_params['created'] = news['created'];
        input_params['body'] = EternaUtils.format_body(news['body']);
        input_params['comments'] = page['comments'];
        input_params['nid'] = nid;
        ThemeCompiler.compile_block(block, input_params, $container);
        if ((page['follow'] != null) && (page['follow'][0] != null)) {
          _this.show_unfollow();
        } else {
          _this.show_follow();
        }
        if ($follow = _this.get_element("follow")) {
          $follow.click(function() {
            Overlay.set_loading("");
            Overlay.show();
            return Follow.follow(nid, "node", null, function(data) {
              if (data['success']) {
                _this.show_unfollow();
              } else {
                alert("Follow fail");
              }
              return Overlay.hide();
            });
          });
        }
        if ($unfollow = _this.get_element("unfollow")) {
          return $unfollow.click(function() {
            Overlay.set_loading("");
            Overlay.show();
            return Follow.expire_follow(nid, "node", function(data) {
              if (data['success']) {
                _this.show_follow();
              } else {
                alert("Unfollow fail");
              }
              return Overlay.hide();
            });
          });
        }
      });
    };

    BuilderNewsPage.prototype.show_follow = function() {
      var $follow, $unfollow;
      if ($follow = this.get_element("follow")) {
        $follow.show();
      }
      if ($unfollow = this.get_element("unfollow")) {
        return $unfollow.hide();
      }
    };

    BuilderNewsPage.prototype.show_unfollow = function() {
      var $follow, $unfollow;
      if ($follow = this.get_element("follow")) {
        $follow.hide();
      }
      if ($unfollow = this.get_element("unfollow")) {
        return $unfollow.show();
      }
    };

    BuilderNewsPage.prototype.hide_follows = function() {
      var $follow, $unfollow;
      if ($follow = this.get_element("follow")) {
        $follow.hide();
      }
      if ($unfollow = this.get_element("unfollow")) {
        return $unfollow.hide();
      }
    };

    return BuilderNewsPage;

  })(Builder);

  this.BuilderNewsList = (function(_super) {
    __extends(BuilderNewsList, _super);

    function BuilderNewsList() {
      _ref1 = BuilderNewsList.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    BuilderNewsList.prototype.on_build = function(block, $container, params) {
      var search, size, skip,
        _this = this;
      skip = params['skip'];
      size = params['size'];
      search = params['search'];
      if (!(skip != null)) {
        skip = 0;
      }
      if (!(size != null)) {
        size = 20;
      }
      if (Utils.is_text_empty(search)) {
        search = null;
      }
      return PageData.get_newslist(skip, size, search, function(page) {
        var $newslist, $pager, $search, body, ii, news_params, newslist, packer, pager_str, total_news, _i, _ref2;
        newslist = page["newslist"];
        ThemeCompiler.compile_block(block, params, $container);
        $newslist = _this.get_element("newslist");
        packer = Packers($newslist);
        news_params = [];
        for (ii = _i = 0, _ref2 = newslist.length - 1; _i <= _ref2; ii = _i += 1) {
          body = EternaUtils.format_summary(newslist[ii]['body'], 180);
          news_params.push({
            nid: newslist[ii]['nid'],
            title: newslist[ii]['title'] + " (" + newslist[ii]['commentcount'] + ")",
            body: body,
            created: newslist[ii]['created'],
            sticky: parseInt(newslist[ii]['sticky']) > 0
          });
        }
        packer.add(news_params);
        total_news = page["num_news"];
        if ($pager = _this.get_element("pager")) {
          pager_str = EternaUtils.get_pager(Math.floor(skip / size), Math.ceil(total_news / size), function(pageindex) {
            var url_params;
            url_params = {
              skip: pageindex * size,
              size: size
            };
            if (search != null) {
              url_params['search'] = search;
            }
            return "/web/news/?" + Utils.generate_parameter_string(url_params, true);
          });
          $pager.html(pager_str);
        }
        if ($search = _this.get_element("search")) {
          $search.attr("value", search);
          return $search.keyup(function(e) {
            var url;
            if (e.keyCode === KeyCode.KEYCODE_ENTER) {
              search = $search.attr("value");
              url = "/web/news/?" + Utils.generate_parameter_string({
                search: search
              }, true);
              return Utils.redirect_to(url);
            }
          });
        }
      });
    };

    return BuilderNewsList;

  })(Builder);

  this.BuilderRecentNews = (function(_super) {
    __extends(BuilderRecentNews, _super);

    function BuilderRecentNews() {
      _ref2 = BuilderRecentNews.__super__.constructor.apply(this, arguments);
      return _ref2;
    }

    BuilderRecentNews.prototype.on_build = function(block, $container, params) {
      var _this = this;
      return PageData.get_newslist(0, 3, null, function(page) {
        var $newslist, ii, news_params, newslist, packer, _i, _ref3;
        newslist = page["newslist"];
        ThemeCompiler.compile_block(block, params, $container);
        if ($newslist = _this.get_element("newslist")) {
          packer = Packers($newslist);
          news_params = [];
          for (ii = _i = 0, _ref3 = newslist.length - 1; _i <= _ref3; ii = _i += 1) {
            news_params.push({
              nid: newslist[ii]['nid'],
              title: newslist[ii]['title'],
              created: newslist[ii]['created']
            });
          }
          return packer.add(news_params);
        }
      });
    };

    return BuilderRecentNews;

  })(Builder);

  this.BuilderRecents = (function(_super) {
    __extends(BuilderRecents, _super);

    function BuilderRecents() {
      _ref3 = BuilderRecents.__super__.constructor.apply(this, arguments);
      return _ref3;
    }

    BuilderRecents.prototype.on_build = function(block, $container, params) {
      var _this = this;
      return PageData.get_recents(function(page) {
        var $newslist, bloglist, ii, news_params, newslist, packer, _i, _j, _ref4, _ref5;
        newslist = page["news"];
        bloglist = page['blogs'];
        ThemeCompiler.compile_block(block, params, $container);
        if ($newslist = _this.get_element("newslist")) {
          packer = Packers($newslist);
          news_params = [];
          for (ii = _i = 0, _ref4 = newslist.length - 1; _i <= _ref4; ii = _i += 1) {
            news_params.push({
              nid: newslist[ii]['nid'],
              title: newslist[ii]['title'],
              created: newslist[ii]['created'],
              type: 'news'
            });
          }
          for (ii = _j = 0, _ref5 = bloglist.length - 1; _j <= _ref5; ii = _j += 1) {
            news_params.push({
              nid: bloglist[ii]['nid'],
              title: bloglist[ii]['title'],
              created: bloglist[ii]['created'],
              type: 'blog'
            });
          }
          return packer.add(news_params);
        }
      });
    };

    return BuilderRecents;

  })(Builder);

}).call(this);
