// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1, _ref2, _ref3, _ref4,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.BuilderPuzzlePage = (function(_super) {
    __extends(BuilderPuzzlePage, _super);

    function BuilderPuzzlePage() {
      _ref = BuilderPuzzlePage.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    BuilderPuzzlePage.prototype.on_build = function(block, $container, params) {
      var nid,
        _this = this;
      nid = params['nid'];
      if (!(nid != null)) {
        Utils.display_error("nid not specified");
        return;
      }
      Application.track_google_analytics_event("puzzle", "open", "");
      return PageData.get_puzzle(nid, function(page) {
        return _this.process_pagebuild(block, $container, params, nid, page);
      });
    };

    BuilderPuzzlePage.prototype.process_pagebuild = function(block, $container, params, nid, page) {
      var $create_image, $follow_puzzle, $playpuzzle, $run_script, $sec_struct, $shape, $structure_notation, $tutorial_link, $unfollow_puzzle, cleared, ii, input_params, is_player_puzzle, notation_block, puzzle, solved_by_bot, switch_struct_data, _i, _j, _k, _ref1, _ref2, _ref3, _ref4,
        _this = this;
      puzzle = page['puzzle'];
      cleared = page['cleared'];
      input_params = {};
      input_params['nid'] = nid;
      input_params['title'] = puzzle['title'];
      input_params['thumbnail'] = EternaUtils.get_puzzle_middle_thumbnail(puzzle['id']);
      input_params['num_cleared'] = puzzle['num-cleared'] != null ? puzzle['num-cleared'] : 0;
      input_params['reward'] = puzzle['reward'];
      input_params['body'] = EternaUtils.format_body(puzzle['body']);
      input_params['comments'] = page['comments'];
      input_params['created'] = puzzle['created'];
      if (Application.CURRENT_USER != null) {
        input_params['can_modify'] = Application.CURRENT_USER['uid'] === puzzle['uid'];
      }
      if (cleared != null) {
        for (ii = _i = 0, _ref1 = cleared.length - 1; _i <= _ref1; ii = _i += 1) {
          if (cleared[ii]['nid'] === nid) {
            input_params['cleared'] = true;
            break;
          }
        }
      }
      if (is_player_puzzle = parseInt(puzzle['made-by-player']) > 0) {
        input_params['is_player_puzzle'] = is_player_puzzle;
        solved_by_bot = puzzle['solved-by-bot'];
        input_params['username'] = puzzle['username'];
        input_params['userpicture'] = EternaUtils.get_user_picture(puzzle['userpicture']);
        if (false) {
          if (/InfoRNA_/i.exec(solved_by_bot)) {
            if (/InfoRNA_failure/i.exec(solved_by_bot) || /InfoRNA_timeout/i.exec(solved_by_bot)) {
              input_params["failed_by_inforna"] = true;
            } else {
              input_params["solved_by_inforna"] = true;
            }
          }
          if (/ViennaRNA_/i.exec(solved_by_bot)) {
            if (/ViennaRNA_failure/i.exec(solved_by_bot) || /ViennaRNA_timeout/i.exec(solved_by_bot)) {
              input_params["failed_by_vienna"] = true;
            } else {
              input_params["solved_by_vienna"] = true;
            }
          }
          if (/RNASSD_/i.exec(solved_by_bot)) {
            if (/RNASSD_failure/i.exec(solved_by_bot) || /RNASSD_timeout/i.exec(solved_by_bot)) {
              input_params["failed_by_rnassd"] = true;
            } else {
              input_params["solved_by_rnassd"] = true;
            }
          }
        }
      }
      ThemeCompiler.compile_block(block, input_params, $container);
      if ($structure_notation = this.get_element("structure_notation")) {
        notation_block = Blocks("notation");
        if (puzzle['switch_struct']) {
          switch_struct_data = puzzle['switch_struct'];
          for (ii = _j = 0, _ref2 = switch_struct_data.length - 1; _j <= _ref2; ii = _j += 1) {
            notation_block.add_block($structure_notation, {
              secstruct: switch_struct_data[ii]
            });
          }
          for (ii = _k = 0, _ref3 = switch_struct_data.length - 1; _k <= _ref3; ii = _k += 1) {
            $structure_notation.append('<div id="shape-' + ii + '"></div>');
            if ($shape = this.get_element("shape-" + ii)) {
              $sec_struct = switch_struct_data[0];
            }
          }
        } else {
          notation_block.add_block($structure_notation, {
            secstruct: puzzle['secstruct']
          });
          $structure_notation.append('<div id="shape"></div>');
          if ($shape = this.get_element("shape")) {
            $sec_struct = puzzle['secstruct'];
          }
        }
      }
      if ((_ref4 = Application.CURRENT_USER['uid']) === "48166" || _ref4 === "130245" || _ref4 === "158495") {
        this.show_create_image();
      }
      if ($create_image = this.get_element("create_image")) {
        $create_image.click(function() {
          Overlay.set_loading("creating..");
          Overlay.show();
          PageData.create_puzzle_image(nid, $sec_struct, function(data) {
            if (data['success'] === false) {
              return alert("Create image fail!");
            } else {
              return alert("Image created!");
            }
          });
          return Overlay.hide();
        });
      }
      if ($tutorial_link = this.get_element("tutorial-link")) {
        $tutorial_link.hide();
        PageData.get_puzzle_tutscripts(nid, function(page) {
          if (page['tutscripts'] != null) {
            if (page['tutscripts'][0] != null) {
              return $tutorial_link.show();
            }
          }
        });
      }
      if ((page['follow'] != null) && (page['follow'][0] != null)) {
        input_params['is_already_followed'] = true;
        this.show_unfollow();
      } else {
        input_params['is_already_followed'] = false;
        this.show_follow();
      }
      if ($follow_puzzle = this.get_element("follow_puzzle")) {
        $follow_puzzle.click(function() {
          Overlay.set_loading("replying..");
          Overlay.show();
          return Follow.follow(nid, "node", null, function(data) {
            if (data['success']) {
              _this.show_unfollow();
            } else {
              alert("Follow fail!!");
            }
            return Overlay.hide();
          });
        });
      }
      if ($unfollow_puzzle = this.get_element("unfollow_puzzle")) {
        $unfollow_puzzle.click(function() {
          Overlay.set_loading("replying..");
          Overlay.show();
          return Follow.expire_follow(nid, "node", function(data) {
            if (data['success']) {
              _this.show_follow();
            } else {
              alert("Unfollow fail!!");
            }
            return Overlay.hide();
          });
        });
      }
      if ($run_script = this.get_element("run_script")) {
        $run_script.click(function() {
          var $overlay_slot;
          block = Blocks("overlay-runscript");
          $overlay_slot = Overlay.get_slot("runscript");
          Overlay.load_overlay_content("runscript");
          Overlay.show();
          if (block['template_context_variables_'] === null) {
            return block.add_block($overlay_slot, {
              nid: input_params['nid'],
              secstruct: input_params['secstruct']
            });
          }
        });
      }
      if ($playpuzzle = this.get_element("playpuzzle")) {
        return $playpuzzle.click(function() {
          Application.track_google_analytics_event("puzzle", "play", "");
          return Utils.redirect_to("/game/puzzle/" + input_params['nid']);
        });
      }
    };

    BuilderPuzzlePage.prototype.show_create_image = function() {
      var $create_image;
      if ($create_image = this.get_element("create_image")) {
        return $create_image.show();
      }
    };

    BuilderPuzzlePage.prototype.show_follow = function() {
      var $follow_puzzle, $unfollow_puzzle;
      if ($follow_puzzle = this.get_element("follow_puzzle")) {
        $follow_puzzle.show();
      }
      if ($unfollow_puzzle = this.get_element("unfollow_puzzle")) {
        return $unfollow_puzzle.hide();
      }
    };

    BuilderPuzzlePage.prototype.show_unfollow = function() {
      var $follow_puzzle, $unfollow_puzzle;
      if ($follow_puzzle = this.get_element("follow_puzzle")) {
        $follow_puzzle.hide();
      }
      if ($unfollow_puzzle = this.get_element("unfollow_puzzle")) {
        return $unfollow_puzzle.show();
      }
    };

    return BuilderPuzzlePage;

  })(Builder);

  this.BuilderPuzzle = (function(_super) {
    __extends(BuilderPuzzle, _super);

    function BuilderPuzzle() {
      _ref1 = BuilderPuzzle.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    BuilderPuzzle.prototype.on_build = function(block, $container, params) {
      var input_params, is_player_puzzle, solved_by_bot;
      input_params = {};
      input_params['id'] = params['id'];
      input_params['title'] = params['title'];
      input_params['cleared'] = params['cleared'];
      input_params['thumbnail'] = EternaUtils.get_puzzle_middle_thumbnail(params['id']);
      input_params['num_cleared'] = params['num-cleared'] != null ? params['num-cleared'] : 0;
      input_params['reward'] = params['reward'];
      input_params['play_direct'] = params['type'] === "Basic" || params['type'] === "SwitchBasic";
      if (is_player_puzzle = parseInt(params['made-by-player']) > 0) {
        input_params['is_player_puzzle'] = is_player_puzzle;
        solved_by_bot = params['solved-by-bot'];
        input_params['username'] = params['username'];
        input_params['userpicture'] = EternaUtils.get_user_picture(params['userpicture']);
        if (false) {
          if (/InfoRNA_/i.exec(solved_by_bot)) {
            if (/InfoRNA_failure/i.exec(solved_by_bot) || /InfoRNA_timeout/i.exec(solved_by_bot)) {
              input_params["failed_by_inforna"] = true;
            } else {
              input_params["solved_by_inforna"] = true;
            }
          }
          if (/ViennaRNA_/i.exec(solved_by_bot)) {
            if (/ViennaRNA_failure/i.exec(solved_by_bot) || /ViennaRNA_timeout/i.exec(solved_by_bot)) {
              input_params["failed_by_vienna"] = true;
            } else {
              input_params["solved_by_vienna"] = true;
            }
          }
          if (/RNASSD_/i.exec(solved_by_bot)) {
            if (/RNASSD_failure/i.exec(solved_by_bot) || /RNASSD_timeout/i.exec(solved_by_bot)) {
              input_params["failed_by_rnassd"] = true;
            } else {
              input_params["solved_by_rnassd"] = true;
            }
          }
        }
      }
      return ThemeCompiler.compile_block(block, input_params, $container);
    };

    return BuilderPuzzle;

  })(Builder);

  this.BuilderPuzzles = (function(_super) {
    __extends(BuilderPuzzles, _super);

    function BuilderPuzzles() {
      _ref2 = BuilderPuzzles.__super__.constructor.apply(this, arguments);
      return _ref2;
    }

    BuilderPuzzles.prototype.on_build = function(block, $container, params) {
      var search, send_params, size, skip, sort, type,
        _this = this;
      type = params['type'];
      skip = params['skip'];
      size = params['size'];
      sort = params['sort'];
      search = params['search'];
      if (!(sort != null)) {
        if (type === "playerpuzzles") {
          sort = params['sort'] = "date";
        } else {
          sort = params['sort'] = "reward";
        }
      }
      if (!(skip != null)) {
        skip = 0;
      }
      if (!(size != null)) {
        size = 24;
      }
      if (type === "tutorials") {
        return PageData.get_tutorials(function(page) {
          return _this.build_puzzles(block, $container, params, page);
        });
      } else if (type === "switch-tutorials") {
        return PageData.get_switch_tutorials(function(page) {
          return _this.build_puzzles(block, $container, params, page);
        });
      } else if (type === "challenges") {
        send_params = {};
        send_params['single'] = params['single'];
        send_params['switch'] = params['switch'];
        send_params['notcleared'] = params['notcleared'];
        if (params['notcleared']) {
          if (Application.CURRENT_USER != null) {
            send_params['uid'] = Application.CURRENT_USER['uid'];
          }
        }
        return PageData.get_challenges(skip, size, sort, search, send_params, function(page) {
          return _this.build_puzzles(block, $container, params, page);
        });
      } else if (type === "playerpuzzles") {
        send_params = {};
        send_params['single'] = params['single'];
        send_params['switch'] = params['switch'];
        send_params['vienna'] = params['vienna'];
        send_params['rnassd'] = params['rnassd'];
        send_params['inforna'] = params['inforna'];
        send_params['notcleared'] = params['notcleared'];
        if (params['notcleared']) {
          if (Application.CURRENT_USER != null) {
            send_params['uid'] = Application.CURRENT_USER['uid'];
          }
        }
        return PageData.get_player_puzzles(skip, size, sort, search, send_params, function(page) {
          return _this.build_puzzles(block, $container, params, page);
        });
      } else if (type === "progression") {
        send_params = {};
        send_params['notcleared'] = params['notcleared'];
        return PageData.get_progression_puzzles(skip, size, sort, search, send_params, function(page) {
          return _this.build_puzzles(block, $container, params, page);
        });
      }
    };

    BuilderPuzzles.prototype.build_puzzles = function(block, $container, params, page) {
      var $inforna, $notcleared, $pager, $puzzles, $rnassd, $search, $single, $switch, $vienna, cleared, cleared_puzzles, ii, jj, num_puzzles, packer, pager_str, param_string, puzzle_params, puzzleid, puzzles, search, size, skip, sort, total_puzzles, type, _i, _j, _ref3, _ref4,
        _this = this;
      type = params['type'];
      skip = params['skip'];
      size = params['size'];
      sort = params['sort'];
      search = params['search'];
      if (Application.CURRENT_USER != null) {
        if (Application.CURRENT_USER['points'] != null) {
          if (parseInt(Application.CURRENT_USER['points']) >= 20000) {
            params['puzzle_creatable'] = true;
          }
        }
      }
      param_string = {};
      param_string.size = size;
      param_string.search = search;
      param_string.single = params['single'] ? params['single'] : void 0;
      param_string["switch"] = params['switch'] ? params['switch'] : void 0;
      param_string.vienna = params['vienna'] ? params['vienna'] : void 0;
      param_string.rnassd = params['rnassd'] ? params['rnassd'] : void 0;
      param_string.inforna = params['inforna'] ? params['inforna'] : void 0;
      param_string.notcleared = params['notcleared'] ? params['notcleared'] : void 0;
      param_string.sort = "date";
      params['date_sort_url'] = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
      param_string.sort = "reward";
      params['reward_sort_url'] = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
      param_string.sort = "solved";
      params['solved_sort_url'] = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
      param_string.sort = "length";
      params['length_sort_url'] = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
      param_string.sort = params['sort'];
      if (!(skip != null)) {
        skip = 0;
      }
      if (!(size != null)) {
        size = 24;
      }
      puzzles = page["puzzles"];
      num_puzzles = page["num_puzzles"];
      cleared_puzzles = page["cleared"];
      ThemeCompiler.compile_block(block, params, $container);
      $puzzles = this.get_element("puzzles");
      packer = Packers($puzzles);
      puzzle_params = [];
      for (ii = _i = 0, _ref3 = puzzles.length - 1; _i <= _ref3; ii = _i += 1) {
        puzzleid = puzzles[ii]['id'];
        cleared = false;
        if (cleared_puzzles != null) {
          for (jj = _j = 0, _ref4 = cleared_puzzles.length - 1; _j <= _ref4; jj = _j += 1) {
            if (puzzleid === cleared_puzzles[jj]['nid']) {
              cleared = true;
              break;
            }
          }
        }
        puzzles[ii]['cleared'] = cleared;
        puzzle_params.push(puzzles[ii]);
      }
      packer.add(puzzle_params);
      total_puzzles = page["num_puzzles"];
      if ($pager = this.get_element("pager")) {
        pager_str = EternaUtils.get_pager(Math.floor(skip / size), Math.ceil(total_puzzles / size), function(pageindex) {
          var url_params;
          url_params = {
            skip: pageindex * size,
            size: size,
            sort: sort,
            single: params['single'],
            "switch": params['switch'],
            vienna: params['vienna'],
            rnassd: params['rnassd'],
            inforna: params['inforna'],
            notcleared: params['notcleared']
          };
          if (search != null) {
            url_params['search'] = search;
          }
          return "/web/" + type + "/?" + Utils.generate_parameter_string(url_params, true);
        });
        $pager.html(pager_str);
      }
      if ($search = this.get_element("search")) {
        $search.attr("value", search);
        $search.keyup(function(e) {
          var url;
          if (e.keyCode === KeyCode.KEYCODE_ENTER) {
            search = $search.attr("value");
            param_string.search = search;
            url = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
            return Utils.redirect_to(url);
          }
        });
      }
      if ($single = this.get_element("single")) {
        if (params['single'] === "checked") {
          $single.attr("checked", true);
        }
        $single.click(function() {
          var url;
          if (params['single'] !== "checked") {
            param_string.single = "checked";
          } else {
            param_string.single = void 0;
          }
          url = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
          return Utils.redirect_to(url);
        });
      }
      if ($switch = this.get_element("switch")) {
        if (params['switch'] === "checked") {
          $switch.attr("checked", true);
        }
        $switch.click(function() {
          var url;
          if (params['switch'] !== "checked") {
            param_string["switch"] = "checked";
          } else {
            param_string["switch"] = void 0;
          }
          url = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
          return Utils.redirect_to(url);
        });
      }
      if ($vienna = this.get_element("vienna")) {
        if (params['vienna'] === "fail") {
          $vienna.attr("checked", true);
        }
        $vienna.click(function() {
          var url;
          if (params['vienna'] !== "fail") {
            param_string.vienna = "fail";
          } else {
            param_string.vienna = void 0;
          }
          url = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
          return Utils.redirect_to(url);
        });
      }
      if ($rnassd = this.get_element("rnassd")) {
        if (params['rnassd'] === "fail") {
          $rnassd.attr("checked", true);
        }
        $rnassd.click(function() {
          var url;
          if (params['rnassd'] !== "fail") {
            param_string.rnassd = "fail";
          } else {
            param_string.rnassd = void 0;
          }
          url = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
          return Utils.redirect_to(url);
        });
      }
      if ($inforna = this.get_element("inforna")) {
        if (params['inforna'] === "fail") {
          $inforna.attr("checked", true);
        }
        $inforna.click(function() {
          var url;
          if (params['inforna'] !== "fail") {
            param_string.inforna = "fail";
          } else {
            param_string.inforna = void 0;
          }
          url = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
          return Utils.redirect_to(url);
        });
      }
      if ($notcleared = this.get_element("notcleared")) {
        if (params['notcleared'] === "true") {
          $notcleared.attr("checked", true);
        }
        return $notcleared.click(function() {
          var url;
          if (params['notcleared'] !== "true") {
            param_string.notcleared = "true";
          } else {
            param_string.notcleared = void 0;
          }
          url = "/web/" + type + "/?" + Utils.generate_parameter_string(param_string);
          return Utils.redirect_to(url);
        });
      }
    };

    return BuilderPuzzles;

  })(Builder);

  this.BuilderPuzzlePageEdit = (function(_super) {
    __extends(BuilderPuzzlePageEdit, _super);

    function BuilderPuzzlePageEdit() {
      _ref3 = BuilderPuzzlePageEdit.__super__.constructor.apply(this, arguments);
      return _ref3;
    }

    BuilderPuzzlePageEdit.prototype.on_build = function(block, $container, params) {
      var nid,
        _this = this;
      nid = params['nid'];
      if (!(nid != null)) {
        Utils.display_error("nid not specified");
        return;
      }
      return PageData.get_puzzle(nid, function(page) {
        var $edit, puzzle, url;
        puzzle = page['puzzle'];
        if (Application.CURRENT_USER['uid'] !== puzzle['uid']) {
          alert("Can't modify this puzzle");
          url = "/web/puzzle/" + nid + "/";
          Utils.redirect_to(url);
          return;
        }
        BuilderPuzzlePage.prototype.process_pagebuild(block, $container, params, nid, page);
        if ($edit = _this.get_element("citylights")) {
          return $edit.click(function() {
            var $description, $title, description, puzzle_param, title;
            $title = _this.get_element("title");
            $description = _this.get_element("description");
            title = $title.val();
            description = $description.val();
            if (title === "" || description === "") {
              alert("Please put title or description");
              return;
            }
            puzzle_param = {};
            puzzle_param['title'] = title;
            puzzle_param['description'] = description;
            Overlay.show();
            return PageData.edit_puzzle(nid, puzzle_param, function(data) {
              Overlay.hide();
              if (data['success']) {
                url = "/web/puzzle/" + nid + "/";
                return Utils.redirect_to(url);
              } else {
                return alert("Puzzle edit fail!!");
              }
            });
          });
        }
      });
    };

    return BuilderPuzzlePageEdit;

  })(Builder);

  this.BuilderRunScriptOverlay = (function(_super) {
    __extends(BuilderRunScriptOverlay, _super);

    function BuilderRunScriptOverlay() {
      _ref4 = BuilderRunScriptOverlay.__super__.constructor.apply(this, arguments);
      return _ref4;
    }

    BuilderRunScriptOverlay.prototype.on_build = function(block, $container, params) {
      ThemeCompiler.compile_block(block, params, $container);
      return this.show_listoverlay(params);
    };

    BuilderRunScriptOverlay.prototype.show_listoverlay = function(params) {
      var $morescripts, search, secstruct, size,
        _this = this;
      this.skip = params['skip'];
      size = params['size'];
      search = "Puzzle Solving";
      secstruct = params['secstruct'];
      if (!(typeof skip !== "undefined" && skip !== null)) {
        this.skip = 0;
      }
      if (!(size != null)) {
        size = 10;
      }
      this.initialize_scripts(this.skip, size, search, secstruct);
      if ($morescripts = this.get_element("morescripts")) {
        return $morescripts.click(function() {
          _this.skip += size;
          return _this.initialize_scripts(_this.skip, size, search, secstruct);
        });
      }
    };

    BuilderRunScriptOverlay.prototype.initialize_scripts = function(skip, size, search, secstruct) {
      var $loading, $script_lists_container,
        _this = this;
      if ($script_lists_container = this.get_element("script_lists")) {
        if ($loading = this.get_element("loading")) {
          $loading.show();
        }
        return Script.get_script_lists(skip, size, search, function(data) {
          var block, builderscript, i, id, scripts, timeout, _fn, _i, _ref5;
          if (skip > data['total_script']) {
            $loading.hide();
            return;
          }
          block = Blocks("script-lists-overlay");
          scripts = data['lists'];
          _this.set_script_lists(block, $script_lists_container, scripts);
          builderscript = new BuilderScriptPage;
          builderscript.initialize_flash();
          builderscript.initialize_pervasives();
          timeout = 10;
          _fn = function(id) {
            return $("#" + id).click(function() {
              var $result, $timeout, Error, Lib, func, result, t;
              if ($timeout = _this.get_element("timeout")) {
                t = $timeout.attr('value');
                if (t !== '' && !(/[^0-9]+/.test(t))) {
                  timeout = t;
                }
              }
              if ($result = _this.get_element("result")) {
                try {
                  $result.attr('value', '');
                  Lib = new Library();
                  secstruct = secstruct;
                  func = Lib.EternaScriptSource(id);
                  func = builderscript.insert_timeout(func, timeout);
                  func = eval(func);
                  return result = func(secstruct);
                } catch (_error) {
                  Error = _error;
                  return result = Error;
                } finally {
                  $result.attr('value', result);
                }
              }
            });
          };
          for (i = _i = 0, _ref5 = scripts.length - 1; 0 <= _ref5 ? _i <= _ref5 : _i >= _ref5; i = 0 <= _ref5 ? ++_i : --_i) {
            id = scripts[i]['nid'];
            _fn(id);
          }
          return $loading.hide();
        });
      }
    };

    return BuilderRunScriptOverlay;

  })(this.BuilderScriptListsPage);

}).call(this);
