// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.BuilderRoadmap = (function(_super) {
    __extends(BuilderRoadmap, _super);

    function BuilderRoadmap() {
      _ref = BuilderRoadmap.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    BuilderRoadmap.prototype.on_build = function(block, $container, params) {
      var user,
        _this = this;
      user = Application.CURRENT_USER;
      return PageData.get_achievement_roadmap(function(page) {
        var $node, $path, $roadmap, achievements, active_block, builder, canvas_width, cleared_block, end_x, end_y, height_max, height_walker, ii, inactive_block, iter, jj, margin_h, margin_w, mid_y, node, parent, path_class, path_r, rendered, roadmap, roadmap_nodes, start_count, start_x, start_y, to_render, total_width, width_walker, x_diff, x_rand, _i, _j, _k, _l, _ref1, _ref2, _ref3, _ref4;
        achievements = page['achievement_roadmap'];
        roadmap = new Roadmap();
        if ((params != null) && (params['ach_type'] != null)) {
          roadmap.set_nodes(achievements, true, params['ach_type']);
        } else {
          roadmap.set_nodes(achievements);
        }
        ThemeCompiler.compile_block(block, params, $container);
        if ($roadmap = _this.get_element("roadmap")) {
          rendered = [];
          roadmap_nodes = roadmap.get_nodes();
          height_walker = 0;
          iter = 0;
          active_block = Blocks("roadmap-box-active");
          inactive_block = Blocks("roadmap-box-inactive");
          cleared_block = Blocks("roadmap-box-cleared");
          canvas_width = 900;
          margin_w = 60;
          margin_h = 100;
          path_r = 4;
          while (rendered.length < roadmap_nodes.length) {
            iter++;
            if (iter > 1000) {
              Utils.display_error("Something is wrong with rendering loop " + JSON.stringify(rendered));
              break;
            }
            to_render = [];
            total_width = 0;
            for (ii = _i = 0, _ref1 = roadmap_nodes.length - 1; _i <= _ref1; ii = _i += 1) {
              node = roadmap_nodes[ii];
              if (rendered.indexOf(node.node_key) >= 0) {
                continue;
              }
              if (!(node.prereq != null) || (rendered.indexOf(node.prereq) >= 0)) {
                total_width += node.width;
                to_render.push(node);
              }
            }
            if (to_render.length > 0) {
              width_walker = (canvas_width - (total_width + (to_render.length - 1) * margin_w)) / 2.0;
              height_max = 0;
              for (ii = _j = 0, _ref2 = to_render.length - 1; _j <= _ref2; ii = _j += 1) {
                node = to_render[ii];
                block = active_block;
                if (node.state === "inactive") {
                  block = inactive_block;
                } else if (node.state === "cleared") {
                  block = cleared_block;
                }
                node.x = width_walker;
                node.y = height_walker;
                builder = block.add_block($roadmap, node);
                $node = builder.get_container();
                $node.css("position", "absolute");
                $node.css("z-index", 1);
                $node.css("top", height_walker + "px");
                $node.css("left", width_walker + "px");
                $node.css("width", node.width + "px");
                $node.css("height", node.height + "px");
                rendered.push(node.node_key);
                width_walker += node.width + margin_w;
                height_max = Math.max(height_max, node.height);
              }
              height_walker += height_max + margin_h;
            }
          }
          for (ii = _k = 0, _ref3 = roadmap_nodes.length - 1; _k <= _ref3; ii = _k += 1) {
            node = roadmap_nodes[ii];
            if ((node.prereq != null)) {
              parent = null;
              for (jj = _l = 0, _ref4 = roadmap_nodes.length - 1; _l <= _ref4; jj = _l += 1) {
                if (roadmap_nodes[jj].node_key === node.prereq) {
                  parent = roadmap_nodes[jj];
                  break;
                }
              }
              if (!(parent != null)) {
                continue;
              }
              start_count = 0;
              if (parent.start_count) {
                start_count = parent.start_count;
                parent.start_count++;
              } else {
                parent.start_count = 1;
              }
              x_rand = 0;
              if (start_count > 0) {
                if (start_count % 2 === 0) {
                  x_rand = -path_r * (3 + Math.floor(start_count / 2));
                } else {
                  x_rand = path_r * (3 + Math.floor(start_count / 2));
                }
              }
              end_x = node.x + node.width / 2 + x_rand;
              end_y = node.y;
              start_x = parent.x + parent.width / 2 + x_rand;
              start_y = parent.y + parent.height;
              mid_y = (start_y + end_y) / 2;
              path_class = "roadmap-active-path";
              if (node.state === "inactive") {
                path_class = "roadmap-inactive-path";
              }
              x_diff = Math.abs(end_x - start_x);
              if (x_diff > 1) {
                $path = $("<div style='position:absolute;'>");
                $path.addClass(path_class);
                $path.css("z-index", 0);
                $path.css("left", start_x - path_r);
                $path.css("top", start_y + path_r);
                $path.css("width", path_r * 2);
                $path.css("height", mid_y - start_y);
                $roadmap.append($path);
                $path = $("<div style='position:absolute;'>");
                $path.addClass(path_class);
                $path.css("left", Math.min(end_x, start_x) + path_r);
                $path.css("top", mid_y - path_r);
                $path.css("width", x_diff - path_r * 2);
                $path.css("height", path_r * 2);
                $roadmap.append($path);
                $path = $("<div style='position:absolute;'>");
                $path.addClass(path_class);
                $path.css("left", end_x - path_r);
                $path.css("top", mid_y - path_r);
                $path.css("width", path_r * 2);
                $path.css("height", end_y - mid_y);
                $roadmap.append($path);
              } else {
                $path = $("<div style='position:absolute;'>");
                $path.addClass(path_class);
                $path.css("z-index", 0);
                $path.css("left", start_x - path_r);
                $path.css("top", start_y + path_r);
                $path.css("width", path_r * 2);
                $path.css("height", end_y - start_y - path_r * 2);
                $roadmap.append($path);
              }
            }
          }
          return $roadmap.css("height", height_walker);
        }
      });
    };

    return BuilderRoadmap;

  })(Builder);

  this.BuilderOverlayAchievements = (function(_super) {
    __extends(BuilderOverlayAchievements, _super);

    function BuilderOverlayAchievements() {
      _ref1 = BuilderOverlayAchievements.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    BuilderOverlayAchievements.prototype.on_build = function(block, $container, params) {
      var $achievements, ach, achievements, achievements_params, key, packer;
      ThemeCompiler.compile_block(block, params, $container);
      if (achievements = params["achievements"]) {
        $achievements = this.get_element("achievements");
        packer = Packers($achievements);
        achievements_params = [];
        for (key in achievements) {
          if (!__hasProp.call(achievements, key)) continue;
          ach = achievements[key];
          achievements_params.push({
            img: ach['image'],
            name: ach['title'],
            desc: ach['desc'],
            past: ach['past']
          });
        }
        return packer.add(achievements_params);
      }
    };

    return BuilderOverlayAchievements;

  })(Builder);

}).call(this);
