// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1, _ref2, _ref3,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.BuilderScriptListsPage = (function(_super) {
    __extends(BuilderScriptListsPage, _super);

    function BuilderScriptListsPage() {
      _ref = BuilderScriptListsPage.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    BuilderScriptListsPage.prototype.on_build = function(block, $container, params) {
      var $script_lists_container, $search, $sendfeedback, param_string, search, size, skip, sort,
        _this = this;
      skip = params['skip'];
      size = params['size'];
      search = params['search'];
      sort = params['sort'];
      if (!(sort != null)) {
        sort = "date";
      }
      params.sort = sort;
      param_string = {};
      param_string.sort = "date";
      params['date_sort_url'] = "/web/script/?" + Utils.generate_parameter_string(param_string);
      param_string.sort = "success_rate";
      params['success_rate_sort_url'] = "/web/script/?" + Utils.generate_parameter_string(param_string);
      if (!(skip != null)) {
        skip = 0;
      }
      if (!(size != null)) {
        size = 10;
      }
      ThemeCompiler.compile_block(block, params, $container);
      if ($search = this.get_element("search")) {
        $search.attr("value", search);
        $search.keyup(function(e) {
          var url;
          if (e.keyCode === KeyCode.KEYCODE_ENTER) {
            search = $search.attr("value");
            param_string.search = search;
            url = "/web/script/?" + Utils.generate_parameter_string(param_string);
            return Utils.redirect_to(url);
          }
        });
      }
      if ($script_lists_container = this.get_element("script_lists")) {
        Script.get_script_lists_with_sort(skip, size, null, sort, search, function(data) {
          block = Blocks("script-lists");
          _this.set_script_lists(block, $script_lists_container, data['lists']);
          return _this.set_pager($script_lists_container, skip, size, function(pageindex) {
            var url_params;
            url_params = {
              skip: pageindex * size,
              size: size,
              search: search,
              sort: sort
            };
            if (search != null) {
              url_params['search'] = search;
            }
            return "/web/script/?" + Utils.generate_parameter_string(url_params, true);
          }, data);
        });
      }
      $('.remove_button').live('click', function(event) {
        var nid;
        Overlay.set_loading("replying..");
        Overlay.show();
        nid = event.target.id.split("-")[2];
        return Script.remove_script(nid, function(data) {
          var url;
          if (data['success']) {
            Overlay.hide();
            url = "/web/script/";
            return Utils.redirect_to(url);
          }
        });
      });
      if ($sendfeedback = this.get_element("sendfeedback")) {
        return $sendfeedback.click(function() {
          return window.open("https://getsatisfaction.com/eternagame/categories/eternagame_tools");
        });
      }
    };

    BuilderScriptListsPage.prototype.set_pager = function($container, skip, size, callback, data) {
      var $pager, pager_str, total_script,
        _this = this;
      if ($pager = this.get_element("pager")) {
        total_script = data['total_script'];
        pager_str = EternaUtils.get_pager(Math.floor(skip / size), Math.ceil(total_script / size), function(pageindex) {
          return callback(pageindex);
        });
        return $pager.html(pager_str);
      }
    };

    BuilderScriptListsPage.prototype.set_script_lists = function(block, $container, lists) {
      var i, nid, script, script_param, script_params, _i, _ref1, _results;
      script_params = [];
      _results = [];
      for (i = _i = 0, _ref1 = lists.length - 1; _i <= _ref1; i = _i += 1) {
        script = lists[i];
        script_param = {};
        nid = script['nid'];
        script_param['id'] = nid;
        script_param['title'] = script['title'];
        script_param['name'] = script['author']['name'];
        script_param['uid'] = script['author']['uid'];
        script_param['body'] = script['body'];
        script_param['created'] = script['created'];
        script_param['commentcounts'] = script['commentcounts'];
        script_param['success_rate'] = script['success_rate'];
        script_param['type'] = script['type'];
        if (Application.CURRENT_USER != null) {
          script_param['user_id'] = Application.CURRENT_USER['uid'];
        } else {
          script_param['user_id'] = null;
        }
        if (!(script_param['success_rate'] != null) || isNaN(script_param['success_rate'])) {
          script_param['success_rate'] = "0.00";
        } else {
          script_param['success_rate'] = new Number(script_param['success_rate'] * 100).toFixed(2);
        }
        script_param['tested_time'] = script['tested_time'];
        if (!(script_param['tested_time'] != null)) {
          script_param['tested_time'] = "Please wait for test results";
        }
        _results.push(block.add_block($container, script_param));
      }
      return _results;
    };

    return BuilderScriptListsPage;

  })(Builder);

  this.BuilderScriptPage = (function(_super) {
    __extends(BuilderScriptPage, _super);

    function BuilderScriptPage() {
      _ref1 = BuilderScriptPage.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    BuilderScriptPage.prototype.on_build = function(block, $container, params) {
      var id, script_create,
        _this = this;
      this.Puzzle_solving = "Puzzle solving";
      this.RNA_scoring = "RNA scoring";
      this.Booster = "Booster";
      this.Etc = "Etc";
      params['readonly'] = false;
      script_create = function(block, $container, params) {
        _this.build_script_create(block, $container, params);
        _this.initialize_option_type();
        _this.initialize_script_batch();
        _this.initialize_test_script();
        if (!params['type'] || params['type'] === _this.Puzzle_solving) {
          return _this.initialize_test_script_local(_this.Puzzle_solving);
        }
      };
      if (params['nid'] || params['id']) {
        if (params['nid']) {
          id = params['nid'];
        } else {
          id = params['id'];
        }
        Script.increase_pageview(id, function(data) {});
        Script.get_script(id, function(data) {
          var script;
          script = data['script'][0];
          params.script = script;
          params.type = script['type'];
          if (params['nid']) {
            params['comments'] = data['comments'];
            _this.build_script_show(block, $container, params);
            _this.initialize_test_script_local(params.type);
            _this.initialize_script_batch();
            if (script['type'] === "Puzzle solving") {
              return _this.initialize_test_script();
            }
          } else {
            return script_create(block, $container, params);
          }
        });
      } else {
        script_create(block, $container, params);
      }
      return this;
    };

    BuilderScriptPage.prototype.findIdOfInput = function(inputName) {
      var ii, input, inputs;
      inputs = this.get_inputs();
      for (ii in inputs) {
        input = inputs[ii];
        if (input['value'] === inputName) {
          return input['name'] + "-value";
        }
      }
      return null;
    };

    BuilderScriptPage.prototype.initialize_sample_testsets = function(params) {
      var $add_testsets, $sample_testsets_select, Error, block, ii, name, sample, samples, testset_counts, value, _i, _ref2, _results,
        _this = this;
      if (params['nid']) {
        if ($sample_testsets_select = this.get_element("sample-testsets-select")) {
          $sample_testsets_select.change(function() {
            var $input_value, key, val, value, value_id, _results;
            val = $("#sample-testsets-select option:selected").val();
            if (val === "") {
              _this.clear_inputs();
              return;
            }
            val = JSON.parse(unescape(val));
            _results = [];
            for (key in val) {
              value = val[key];
              value_id = _this.findIdOfInput(key);
              if ($input_value = _this.get_element(value_id)) {
                _results.push($input_value.val(value));
              } else {
                _results.push(void 0);
              }
            }
            return _results;
          });
          if (params['script'] && params['script']['samples']) {
            block = Blocks("sample-testsets-option");
            samples = params['script']['samples'];
            if (samples.length) {
              _results = [];
              for (ii = _i = 0, _ref2 = samples.length - 1; 0 <= _ref2 ? _i <= _ref2 : _i >= _ref2; ii = 0 <= _ref2 ? ++_i : --_i) {
                try {
                  sample = samples[ii];
                  name = sample['name'];
                  value = escape(JSON.stringify(sample['value']));
                  if (!(name != null)) {
                    name = "Sample" + ii;
                  }
                  if (!(value != null)) {
                    throw "error";
                  }
                } catch (_error) {
                  Error = _error;
                  name = "Corrupted sample testsets ( " + Error.message + ")";
                  value = "";
                }
                _results.push(block.add_block($sample_testsets_select, {
                  name: name,
                  value: value
                }));
              }
              return _results;
            }
          }
        }
      } else {
        if ($add_testsets = this.get_element("add-testsets")) {
          testset_counts = 0;
          return $add_testsets.click(function() {
            var $sample_testsets;
            if ($sample_testsets = _this.get_element("sample-testsets")) {
              block = Blocks("sample-testset");
              block.add_block($sample_testsets, {
                count: testset_counts
              });
              return testset_counts++;
            }
          });
        }
      }
    };

    BuilderScriptPage.prototype.initialize_script_batch = function() {
      var $test_script_batch,
        _this = this;
      if ($test_script_batch = this.get_element("test-script-batch")) {
        return $test_script_batch.click(function() {
          Overlay.set_loading("replying..");
          Overlay.show();
          return Script.get_puzzles_for_batch({}, function(data) {
            var ii, input, input_array, puzzle, puzzles, secstruct, _i, _ref2;
            puzzles = data['puzzles'];
            for (ii = _i = 0, _ref2 = puzzles.length - 1; 0 <= _ref2 ? _i <= _ref2 : _i >= _ref2; ii = 0 <= _ref2 ? ++_i : --_i) {
              puzzle = puzzles[ii];
              if (puzzle) {
                secstruct = puzzle['secstruct'];
                input_array = ScriptInterface.set_input_val(_this.get_inputs(), 0, secstruct);
                input = ScriptInterface.codify_input(input_array);
                _this.on_evaluate_with_var(input, _this.editor.getValue(), _this.get_timeout(), function(result) {
                  Pervasives.outln("================ Test on the batch results with puzzle(" + puzzle['nid'] + ").... ================ ");
                  return _this.print_test_puzzle_results(puzzle, result);
                });
              }
            }
            Overlay.hide();
            return _this.scroll_to_result_console();
          });
        });
      }
    };

    BuilderScriptPage.prototype.initialize_option_type = function() {
      var $puzzle_solving, $rna_scoring, $script_type, sel,
        _this = this;
      $script_type = this.get_element("script_type");
      $puzzle_solving = this.get_element("puzzle-solving");
      $rna_scoring = this.get_element("rna-scoring");
      if ($script_type) {
        if (sel = $('#script_type option:selected').val()) {
          if ($puzzle_solving || $rna_scoring) {
            $puzzle_solving.hide();
            $rna_scoring.hide();
            if (sel === this.Puzzle_solving || sel === this.RNA_scoring) {
              if (sel === this.Puzzle_solving) {
                $puzzle_solving.show();
              } else if (sel === this.RNA_scoring) {
                $rna_scoring.show();
              }
            }
          }
        }
        return $script_type.change(function() {
          if (sel = $('#script_type option:selected').val()) {
            if ($puzzle_solving && $rna_scoring) {
              $puzzle_solving.hide();
              $rna_scoring.hide();
              if (sel === _this.Puzzle_solving) {
                return $puzzle_solving.show();
              } else if (sel === _this.RNA_scoring) {
                return $rna_scoring.show();
              }
            }
          }
        });
      }
    };

    BuilderScriptPage.prototype.clear_inputs = function() {
      var $input_value, ii, input, input_script, input_scripts, value_id, _i, _ref2, _results;
      if (input = this.get_inputs()) {
        input_scripts = input;
        _results = [];
        for (ii = _i = 0, _ref2 = input_scripts.length - 1; 0 <= _ref2 ? _i <= _ref2 : _i >= _ref2; ii = 0 <= _ref2 ? ++_i : --_i) {
          input_script = input_scripts[ii];
          value_id = input_script['name'] + "-value";
          if ($input_value = this.get_element(value_id)) {
            _results.push($input_value.val(''));
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      }
    };

    BuilderScriptPage.prototype.initialize_clear = function(params) {
      var $clear_input, $clear_output,
        _this = this;
      if ($clear_input = this.get_element("clear-input")) {
        $clear_input.click(function() {
          return _this.clear_inputs();
        });
      }
      if ($clear_output = this.get_element("clear-output")) {
        return $clear_output.click(function() {
          return Pervasives.clear();
        });
      }
    };

    BuilderScriptPage.prototype.print_test_puzzle_results = function(puzzle, result) {
      var eval_time, folded;
      if (!(this.Lib != null)) {
        this.Lib = new Library();
      }
      folded = this.Lib.fold(result['cause']);
      eval_time = result['eval_time'] / 1000;
      Pervasives.outln("-- Puzzle title : <a href='/web/puzzle/" + puzzle['nid'] + "/'>" + puzzle['title'] + "</a>");
      Pervasives.outln("-- Puzzle creator : " + puzzle['username']);
      Pervasives.outln("Script's Return : " + result['cause']);
      Pervasives.outln("Script's Folded  : " + folded);
      Pervasives.outln("Puzzle secstruct : " + puzzle['secstruct']);
      if (folded === puzzle['secstruct']) {
        result = "PASS";
      } else {
        result = "FAIL";
      }
      Pervasives.outln("Result : " + result);
      Pervasives.outln("Evaluation time : " + eval_time + " sec");
    };

    BuilderScriptPage.prototype.initialize_test_script_local = function(script_type) {
      var $puzzle_solving, $rna_scoring, common_cb, initialize_local, puzzle_test_script_local, solution_test_script_local,
        _this = this;
      puzzle_test_script_local = function(nid, cb) {
        return PageData.get_puzzle(nid, function(data) {
          var input, input_array, puzzle, secstruct;
          puzzle = data['puzzle'];
          if (puzzle) {
            secstruct = puzzle['secstruct'];
            input_array = ScriptInterface.set_input_val(_this.get_inputs(), 0, secstruct);
            input = ScriptInterface.codify_input(input_array);
            _this.on_evaluate_with_var(input, _this.editor.getValue(), _this.get_timeout(), function(result) {
              Pervasives.outln("================ Test on the fly results with puzzle(" + nid + ").... ================ ");
              return _this.print_test_puzzle_results(puzzle, result);
            });
          } else {
            alert("Please check puzzle id.. No puzzles!!");
          }
          if (cb) {
            return cb(data);
          }
        });
      };
      solution_test_script_local = function(nid, cb) {
        return Script.get_solution_for_script(nid, function(data) {
          var ii, input, input_array, secstruct, sequence, solution, solutions, _i, _ref2;
          solutions = data['solutions'];
          if (solutions.length > 0) {
            for (ii = _i = 0, _ref2 = solutions.length - 1; 0 <= _ref2 ? _i <= _ref2 : _i >= _ref2; ii = 0 <= _ref2 ? ++_i : --_i) {
              solution = solutions[ii];
              secstruct = solution['secstruct'];
              sequence = solution['sequence'];
              input_array = _this.get_inputs();
              input_array = ScriptInterface.set_input_val(input_array, 0, secstruct);
              input_array = ScriptInterface.set_input_val(input_array, 1, sequence);
              input = ScriptInterface.codify_input(input_array);
              _this.on_evaluate_with_var(input, _this.editor.getValue(), _this.get_timeout(), function(result) {
                Pervasives.outln("================ Test on the fly results with solution(" + nid + ").... ================ ");
                Pervasives.outln("Solution title : " + solution['title']);
                Pervasives.outln("Solution secstruct : " + solution['secstruct']);
                Pervasives.outln("Solution sequences : " + solution['sequence']);
                Pervasives.outln("Result : " + result['cause']);
                return Pervasives.outln("Evaluation time : " + result['eval_time'] / 1000 + " sec");
              });
            }
          } else {
            alert("Please check solution id.. No solutions!!");
          }
          if (cb) {
            return cb(data);
          }
        });
      };
      common_cb = function(data) {
        if (data['puzzle'] || (data['solutions'] && data['solutions'].length > 0)) {
          _this.scroll_to_result_console();
        }
        return Overlay.hide();
      };
      initialize_local = function($container, func) {
        var $test_script_local;
        if ($test_script_local = $container.find('#test-script-local')) {
          return $test_script_local.click(function() {
            var $test_script_local_input, nid;
            Overlay.set_loading("replying..");
            Overlay.show();
            if ($test_script_local_input = $container.find('#test-script-local-input')) {
              nid = $test_script_local_input.val();
              if (!(nid != null) || nid === void 0 || isNaN(nid)) {
                alert("Please check id you entered.. Numbers only!!");
                return Overlay.hide();
              } else {
                Pervasives.clear();
                return func(nid, common_cb);
              }
            }
          });
        }
      };
      if ($puzzle_solving = this.get_element('puzzle-solving')) {
        initialize_local($puzzle_solving, puzzle_test_script_local);
        if (script_type === this.Puzzle_solving) {
          $puzzle_solving.show();
        }
      }
      if ($rna_scoring = this.get_element("rna-scoring")) {
        initialize_local($rna_scoring, solution_test_script_local);
        if (script_type === this.RNA_scoring) {
          return $rna_scoring.show();
        }
      }
    };

    BuilderScriptPage.prototype.scroll_to_result_console = function() {
      var position;
      position = $('#result').position();
      return scroll(0, 1000);
    };

    BuilderScriptPage.prototype.initialize_test_script = function() {
      var $test_result, $test_script,
        _this = this;
      if ($test_result = this.get_element("test-result")) {
        $test_result.show();
      }
      if ($test_script = this.get_element("test-script")) {
        $test_script.show();
        return $test_script.click(function() {
          var input, name, source;
          Overlay.set_loading("replying..");
          Overlay.show();
          input = _this.get_inputs();
          source = _this.get_source();
          if (input && input[0]) {
            name = input[0]['value'];
          }
          return _this.test_scripts(name, void 0, source, function(test) {
            if ($test_result = _this.get_element("test-result")) {
              Overlay.hide();
              $test_result.html('');
              return _this.load_test_result(test);
            }
          }, function(error) {
            alert("Evaluation server is not available now.");
            return Overlay.hide();
          });
        });
      }
    };

    BuilderScriptPage.prototype.build_script_create = function(block, $container, params) {
      var $add_input, $documentation, $input_containers, $save_script, $update_nid, input_count,
        _this = this;
      ThemeCompiler.compile_block(block, params, $container);
      this.initialize_editor(params['readonly']);
      if (params['id']) {
        this.put_script(params['script'], true, true);
        if ($update_nid = this.get_element("update_nid")) {
          $update_nid.val(params['id']);
        }
      }
      this.initialize_flash();
      this.initialize_evaluate();
      this.initialize_clear(params);
      this.initialize_sample_testsets(params);
      if ($documentation = this.get_element("documentation")) {
        $documentation.click(function() {
          return window.open("/web/resources/documentation/script/");
        });
      }
      if ($save_script = this.get_element("submit-script")) {
        $save_script.click(function() {
          if (Application.CURRENT_USER) {
            return _this.save_script();
          } else {
            return alert("Please log in to submit script");
          }
        });
      }
      if ($add_input = this.get_element("add-input")) {
        if ($input_containers = this.get_element("input-containers")) {
          block = Blocks("input-container");
          input_count = 0;
          return $add_input.click(function() {
            block.add_block($input_containers, {
              num: input_count,
              create: true
            });
            return input_count++;
          });
        }
      }
    };

    BuilderScriptPage.prototype.build_script_show = function(block, $container, params) {
      var $start_from_copy,
        _this = this;
      ThemeCompiler.compile_block(block, params, $container);
      if (params['nid']) {
        params['readonly'] = true;
        this.initialize_editor(params['readonly']);
        this.put_script(params['script'], true, true);
        this.put_remove(params['script'], params['nid']);
      }
      this.initialize_flash();
      this.initialize_evaluate();
      this.initialize_clear(params);
      this.initialize_sample_testsets(params);
      if ($start_from_copy = this.get_element("start-from-copy")) {
        return $start_from_copy.click(function() {
          var url, url_params;
          url_params = {
            id: params['nid'],
            type: params['type']
          };
          url = "/web/script/create/?" + Utils.generate_parameter_string(url_params);
          return Utils.redirect_to(url);
        });
      }
    };

    BuilderScriptPage.prototype.load_script = function(id, code, input) {
      var _this = this;
      return Script.get_script(id, function(data) {
        var script;
        script = data['script'][0];
        return _this.put_script(script, code, input);
      });
    };

    BuilderScriptPage.prototype.put_script = function(script, code, input) {
      var $author, $desc, $description, $input_containers, $pageview, $see_results, $tested, $tested_time, $title, $type, author, block, description, i, input_script, input_scripts, name, pageview, type, value, _i, _ref2,
        _this = this;
      if (code) {
        this.editor.setValue(script['source']);
        $title = this.get_element("title");
        $title.html(script['title']);
        $title.val(script['title']);
        if ($desc = this.get_element("description")) {
          $desc.val(script['body']);
        }
        author = script['author'];
        if ($author = this.get_element("author")) {
          $author.html(author['name']);
          $author.click(function() {
            var url;
            url = "/web/player/" + author['uid'] + "/";
            return Utils.redirect_to(url);
          });
        }
      }
      if (input) {
        if (script['input'] !== null) {
          input_scripts = this.parse_inputs(script['input']);
          if ($input_containers = this.get_element("input-containers")) {
            block = Blocks("input-container");
            if (input_scripts.length > 0) {
              for (i = _i = 0, _ref2 = input_scripts.length - 1; 0 <= _ref2 ? _i <= _ref2 : _i >= _ref2; i = 0 <= _ref2 ? ++_i : --_i) {
                input_script = input_scripts[i];
                name = input_script['name'];
                value = input_script['value'];
                block.add_block($input_containers, {
                  name: name,
                  value: value
                });
              }
            }
          }
        }
      }
      if ($description = this.get_element("description-info")) {
        if (description = script['body']) {
          $description.html(description);
        }
      }
      if ($tested_time = this.get_element("tested-time")) {
        if (!(script['tested_time'] != null)) {
          $tested_time.html("Please wait for test results");
        } else {
          $tested_time.html(script['tested_time']);
        }
      }
      if ($type = this.get_element("type-info")) {
        if (type = script['type']) {
          $type.html(type);
        } else {
          type = "Etc";
          $type.html("Etc");
        }
        if (type === "Etc" || type === "RNA scoring" || type === "Booster") {
          if ($see_results = this.get_element("see-results")) {
            $see_results.hide();
          }
          if ($tested = this.get_element("tested")) {
            $tested.hide();
          }
        }
      }
      if ($pageview = this.get_element("pageview-info")) {
        if (pageview = script['pageview']) {
          return $pageview.html(pageview);
        } else {
          return $pageview.html("0");
        }
      }
    };

    BuilderScriptPage.prototype.put_remove = function(script, nid) {
      var $edit_button, $edit_script, $remove_button, $remove_script, author, user_id,
        _this = this;
      author = script['author'];
      if (Application.CURRENT_USER != null) {
        user_id = Application.CURRENT_USER['uid'];
      } else {
        user_id = null;
      }
      if (author['uid'] === user_id) {
        if ($remove_script = this.get_element("remove-script")) {
          $remove_script.html('<span id="remove-button" class="clickable green-button rounded-5" style="clear:both; margin-left:10px; padding:5px; width:100px;">Remove</span>');
          if ($remove_button = this.get_element("remove-button")) {
            $remove_button.click(function() {
              Overlay.set_loading("replying..");
              Overlay.show();
              return Script.remove_script(nid, function(data) {
                var url;
                if (data['success']) {
                  Overlay.hide();
                  url = "/web/script/";
                  return Utils.redirect_to(url);
                }
              });
            });
          }
        }
        if ($edit_script = this.get_element("edit-script")) {
          $edit_script.html('<span id="edit-button" class="clickable green-button rounded-5" style="clear:both; margin-left:10px; padding:5px; width:100px;">Edit</span>');
          if ($edit_button = this.get_element("edit-button")) {
            return $edit_button.click(function() {
              var url, url_params;
              url_params = {
                id: nid,
                type: script['type']
              };
              url = "/web/script/edit/?" + Utils.generate_parameter_string(url_params);
              return Utils.redirect_to(url);
            });
          }
        }
      }
    };

    BuilderScriptPage.prototype.load_test_result = function(test_result) {
      var $test_result, block, i, test, test_param, tests, _i, _ref2, _results;
      if ($test_result = this.get_element("test-result")) {
        if (tests = test_result) {
          block = Blocks("code-test-result");
          _results = [];
          for (i = _i = 0, _ref2 = tests.length - 1; 0 <= _ref2 ? _i <= _ref2 : _i >= _ref2; i = 0 <= _ref2 ? ++_i : --_i) {
            test = tests[i];
            test_param = {};
            test_param['puzzle_nid'] = test['nid'];
            test_param['puzzle_title'] = test['name'];
            test_param['num_cleared'] = test['num_cleared'] != null ? test['num_cleared'] : 0;
            test_param['test_result'] = test['result'];
            test_param['test_cause'] = test['cause'].length > 25 ? test['cause'].substring(0, 25) + "..." : test['cause'];
            test_param['test_time'] = test['eval_time'] / 1000;
            _results.push(block.add_block($test_result, test_param));
          }
          return _results;
        }
      }
    };

    BuilderScriptPage.prototype.save_script = function() {
      var $description, $nid, $title, Error, description, input, name, nid, samples, source, title, type;
      if ($title = this.get_element("title")) {
        if ($title.attr('value') === "") {
          alert("You have to write the title!!");
          return;
        }
      }
      if ($description = this.get_element("description")) {
        if ($description.attr('value') === "") {
          alert(" You have to write the description!!");
          return;
        }
      }
      nid = null;
      if ($nid = this.get_element("update_nid")) {
        nid = $nid.attr('value');
      }
      Overlay.set_loading("replying..");
      Overlay.show();
      title = $title.attr('value');
      description = $description.attr('value');
      type = $('#script_type option:selected').val();
      input = this.get_inputs();
      try {
        samples = this.get_samples();
      } catch (_error) {
        Error = _error;
        alert("Your sample testsets have an error : " + Error.message);
        Overlay.hide();
        return;
      }
      source = this.editor.getValue();
      if (input && input[0]) {
        name = input[0]['value'];
      }
      return Script.post_script(nid, title, source, type, input, samples, description, function(data) {
        if (!data['success'] || data['nid'] === null || data['nid'] === void 0) {
          alert("Submit fail. Try again please!!");
        }
        Utils.redirect_to("/web/script/" + data['nid'] + "/");
        return Overlay.hide();
      });
    };

    BuilderScriptPage.prototype.test_scripts = function(input, target_info, source, success_cb, fail_cb) {
      var test,
        _this = this;
      test = new Array();
      return Script.evaluate_script(input, target_info, source, function(data) {
        var i, test_target, test_targets, _i, _ref2;
        test_targets = data['data'];
        for (i = _i = 0, _ref2 = test_targets.length - 1; _i <= _ref2; i = _i += 1) {
          test_target = test_targets[i];
          test_result['nid'] = test_target['nid'];
          test_result['name'] = test_target['name'];
          test_result['result'] = test_target['result'];
          test_result['cause'] = test_target['cause'];
          test_result['eval_time'] = test_target['eval_time'];
          test_result['num_cleared'] = test_target['num_cleared'];
          test.push(test_result);
        }
        return success_cb(test);
      }, fail_cb);
    };

    BuilderScriptPage.prototype.initialize_editor = function(readonly) {
      var $code, wrapper;
      if ($code = this.get_element("code")) {
        this.editor = CodeMirror.fromTextArea($code.get(0), {
          lineNumbers: true,
          matchBrackets: true,
          extraKeys: {
            "Enter": "newlineAndIndentContinueComment"
          },
          readOnly: readonly
        });
        this.editor.setSize("97%", 600);
        if (readonly) {
          wrapper = this.editor.getWrapperElement();
          return $(wrapper).css('background-color', '#BDBDBD');
        }
      }
    };

    BuilderScriptPage.prototype.initialize_flash = function() {
      var attributes, flash_params, flashvars;
      flashvars = {};
      flash_params = {
        allowScriptAccesss: "always"
      };
      attributes = {
        id: "viennalib"
      };
      return swfobject.embedSWF("/eterna_resources/scriptfold.swf", "viennalib", "0", "0", "9.0.0", false, flashvars, flash_params, attributes);
    };

    BuilderScriptPage.prototype.initialize_evaluate = function() {
      var $code, $evaluation, $input,
        _this = this;
      $input = this.get_element("input");
      $code = this.get_element("code");
      if ($evaluation = this.get_element("evaluation")) {
        return $evaluation.click(function() {
          Pervasives.clear();
          return _this.on_evaluate();
        });
      }
    };

    BuilderScriptPage.prototype.on_evaluate = function() {
      var code, input_array, param, timeout;
      input_array = this.get_inputs_with_value();
      param = ScriptInterface.codify_input(input_array);
      code = this.editor.getValue();
      timeout = this.get_timeout();
      return this.on_evaluate_with_var(param, code, timeout);
    };

    BuilderScriptPage.prototype.on_evaluate_with_var = function(input, code, timeout_sec, cb) {
      var _this = this;
      code = ScriptInterface.insert_timeout(code, timeout_sec);
      return this.dynamic_load(code, function() {
        var result;
        result = ScriptInterface.evaluate(input + code);
        if (cb) {
          return cb(result);
        } else {
          Pervasives.outln("<br>Return : " + result['cause']);
          return Pervasives.outln("Evaluation time : " + result['eval_time'] / 1000 + " sec");
        }
      });
    };

    BuilderScriptPage.prototype.get_timeout = function() {
      var $timeout_sec, timeout_sec, value;
      timeout_sec = 10;
      if ($timeout_sec = this.get_element("timeout")) {
        value = $timeout_sec.attr('value');
        if (value !== "") {
          timeout_sec = value;
        }
      }
      return timeout_sec;
    };

    BuilderScriptPage.prototype.dynamic_load = function(code, cb) {
      var _this = this;
      if (!(this.loader != null)) {
        this.loader = new LibLoader();
      }
      if (typeof Overlay !== "undefined" && Overlay !== null) {
        Overlay.set_loading("replying..");
        Overlay.show();
      }
      Pervasives.outln("Library Loader use.... " + this.loader.getUse());
      return this.loader.parse(code, function(libs) {
        return _this.loader.dynamicLoad(libs, function(lib) {
          if (lib) {
            return Pervasives.outln(_this.loader.getName(lib) + " loading.... ");
          }
        }, function(state) {
          return Pervasives.outln(_this.loader.getNameFromState(state) + " loading " + _this.loader.getSuccessFromState(state));
        }, function(states) {
          if (typeof Overlay !== "undefined" && Overlay !== null) {
            Overlay.hide();
          }
          return cb();
        });
      });
    };

    BuilderScriptPage.prototype.resetTimeValue = function() {
      return this.setTimeValue(0, 0, 0);
    };

    BuilderScriptPage.prototype.setTimeValue = function(hour, min, sec) {
      var $hour, $min, $sec;
      if ($hour = this.get_element("timer-hour")) {
        $hour.html(this.format(hour));
      }
      if ($min = this.get_element("timer-min")) {
        $min.html(this.format(min));
      }
      if ($sec = this.get_element("timer-sec")) {
        return $sec.html(this.format(sec));
      }
    };

    BuilderScriptPage.prototype.format = function(num) {
      if (parseInt(num) < 10) {
        return String("0" + num);
      } else {
        return String(num);
      }
    };

    BuilderScriptPage.prototype.parse_inputs = function(input) {
      var Error, input_scripts;
      try {
        input_scripts = JSON.parse(input);
      } catch (_error) {
        Error = _error;
        input_scripts = [
          {
            name: "name0",
            value: input
          }
        ];
      }
      return input_scripts;
    };

    BuilderScriptPage.prototype.get_inputs = function() {
      var $input_form, arr, i, input, result, _i, _ref2;
      if ($input_form = this.get_element("input-form")) {
        arr = $input_form.serializeArray();
        if (arr.length > 0) {
          result = new Array;
          for (i = _i = 0, _ref2 = arr.length - 1; 0 <= _ref2 ? _i <= _ref2 : _i >= _ref2; i = 0 <= _ref2 ? ++_i : --_i) {
            input = arr[i];
            if (input['value'] !== "") {
              result.push(input);
            }
          }
          return result;
        }
      }
      return [];
    };

    BuilderScriptPage.prototype.get_inputs_with_value = function() {
      var $name, $value, ii, input_array, v, value, _i, _ref2;
      input_array = this.get_inputs();
      if (input_array.length > 0) {
        for (ii = _i = 0, _ref2 = input_array.length - 1; 0 <= _ref2 ? _i <= _ref2 : _i >= _ref2; ii = 0 <= _ref2 ? ++_i : --_i) {
          $name = this.get_element(input_array[ii]['name']);
          value = input_array[ii]['name'] + "-value";
          $value = this.get_element(value);
          v = $value.attr('value').replace(/\n/gi, '\\n');
          input_array = ScriptInterface.set_input_val(input_array, ii, v);
        }
      }
      return input_array;
    };

    BuilderScriptPage.prototype.get_source = function() {
      if (this.editor) {
        return this.editor.getValue();
      }
      return "";
    };

    BuilderScriptPage.prototype.put_source = function(src) {
      if (this.editor) {
        return this.editor.setValue(src);
      }
    };

    BuilderScriptPage.prototype.get_samples = function() {
      var $sample_testsets_form, arr, i, input, result, _i, _ref2;
      if ($sample_testsets_form = this.get_element("sample-testsets-form")) {
        arr = $sample_testsets_form.serializeArray();
        if (arr.length > 0) {
          result = new Array;
          for (i = _i = 0, _ref2 = arr.length - 1; 0 <= _ref2 ? _i <= _ref2 : _i >= _ref2; i = 0 <= _ref2 ? ++_i : --_i) {
            input = arr[i];
            if (input['value'] !== "") {
              result.push(JSON.parse(input['value']));
            }
          }
          return result;
        }
      }
      return [];
    };

    return BuilderScriptPage;

  })(Builder);

  this.BuilderInput = (function(_super) {
    __extends(BuilderInput, _super);

    function BuilderInput() {
      _ref2 = BuilderInput.__super__.constructor.apply(this, arguments);
      return _ref2;
    }

    BuilderInput.prototype.on_build = function(block, $container, params) {
      var $delete;
      ThemeCompiler.compile_block(block, params, $container);
      if ($delete = this.get_element("delete")) {
        return $delete.click(function() {
          return $container.html("");
        });
      }
    };

    return BuilderInput;

  })(Builder);

  this.BuilderScriptTestResultPage = (function(_super) {
    __extends(BuilderScriptTestResultPage, _super);

    function BuilderScriptTestResultPage() {
      _ref3 = BuilderScriptTestResultPage.__super__.constructor.apply(this, arguments);
      return _ref3;
    }

    BuilderScriptTestResultPage.prototype.on_build = function(block, $container, params) {
      var $after_result_more, $before_result_more, $fail, $pass, $timeout, param_string,
        _this = this;
      this.size = 20;
      this.before_skip = this.size;
      this.after_skip = this.size;
      if (params['nid'] == null) {
        return;
      }
      if (params['sort'] == null) {
        params['sort'] = "date";
      }
      param_string = {};
      param_string.search = params['search'];
      param_string.pass = params['pass'] ? params['pass'] : void 0;
      param_string.fail = params['fail'] ? params['fail'] : void 0;
      param_string.timeout = params['timeout'] ? params['timeout'] : void 0;
      param_string.sort = "date";
      params['date_sort_url'] = "/web/script/test/" + params['nid'] + "/?" + Utils.generate_parameter_string(param_string);
      param_string.sort = "time";
      params['time_sort_url'] = "/web/script/test/" + params['nid'] + "/?" + Utils.generate_parameter_string(param_string);
      param_string.sort = params['sort'];
      ThemeCompiler.compile_block(block, params, $container);
      this.generate_testresult(params['nid'], param_string);
      if ($pass = this.get_element("pass")) {
        if (params['pass'] === "true") {
          $pass.attr("checked", true);
        }
        $pass.click(function() {
          var url;
          if (params['pass'] !== "true") {
            param_string.pass = "true";
          } else {
            param_string.pass = void 0;
          }
          url = "/web/script/test/" + params['nid'] + "/?" + Utils.generate_parameter_string(param_string);
          return Utils.redirect_to(url);
        });
      }
      if ($fail = this.get_element("fail")) {
        if (params['fail'] === "true") {
          $fail.attr("checked", true);
        }
        $fail.click(function() {
          var url;
          if (params['fail'] !== "true") {
            param_string.fail = "true";
          } else {
            param_string.fail = void 0;
          }
          url = "/web/script/test/" + params['nid'] + "/?" + Utils.generate_parameter_string(param_string);
          return Utils.redirect_to(url);
        });
      }
      if ($timeout = this.get_element("timeout")) {
        if (params['timeout'] === "true") {
          $timeout.attr("checked", true);
        }
        $timeout.click(function() {
          var url;
          if (params['timeout'] !== "true") {
            param_string.timeout = "true";
          } else {
            param_string.timeout = void 0;
          }
          url = "/web/script/test/" + params['nid'] + "/?" + Utils.generate_parameter_string(param_string);
          return Utils.redirect_to(url);
        });
      }
      if ($before_result_more = this.get_element("before-result-more")) {
        $before_result_more.click(function() {
          _this.request_test_result_before(params['nid'], _this.before_skip, _this.size, param_string);
          return _this.before_skip += _this.size;
        });
      }
      if ($after_result_more = this.get_element("after-result-more")) {
        return $after_result_more.click(function() {
          _this.request_test_result_after(params['nid'], _this.after_skip, _this.size, param_string);
          return _this.after_skip += _this.size;
        });
      }
    };

    BuilderScriptTestResultPage.prototype.show_record = function($container, success, fail) {
      var block, record;
      block = Blocks("block-test-record");
      record = [];
      record['total'] = success + fail;
      if (isNaN(record['total'])) {
        record['total'] = 0;
      }
      record['success'] = success;
      if (isNaN(record['success'])) {
        record['success'] = 0;
      }
      record['fail'] = fail;
      if (isNaN(record['fail'])) {
        record['fail'] = 0;
      }
      if (record['total'] > 0) {
        record['rate'] = (record['success'] / record['total'] * 100).toFixed(2);
      } else {
        record['rate'] = 0;
      }
      return block.add_block($container, record);
    };

    BuilderScriptTestResultPage.prototype.generate_testresult = function(script_nid, params) {
      var $aloading, $bloading,
        _this = this;
      $bloading = this.get_element("before-loading");
      $bloading.show();
      $aloading = this.get_element("after-loading");
      $aloading.show();
      return Script.get_script_with_test(script_nid, this.skip, this.size, params, function(data) {
        var $record, $record_after, $record_before, $tested_time, after, before, script, test;
        _this.skip += _this.size;
        script = data['script'][0];
        if ($tested_time = _this.get_element("tested-time")) {
          if (!(script['tested_time'] != null)) {
            $tested_time.html("Please wait for test results");
          } else {
            $tested_time.html(script['tested_time']);
          }
        }
        _this.initialize_table_header(script['type']);
        test = script['test'];
        if (test) {
          before = test['before'];
          after = test['after'];
          if (script['type'] === "Puzzle solving") {
            if ($record = _this.get_element("record")) {
              _this.show_record($record, test['before']['success'] + test['after']['success'], test['before']['fail'] + test['after']['fail']);
            }
            if ($record_before = _this.get_element("record-before")) {
              _this.show_record($record_before, test['before']['success'], test['before']['fail']);
            }
            if ($record_after = _this.get_element("record-after")) {
              _this.show_record($record_after, test['after']['success'], test['after']['fail']);
            }
          }
          _this.load_test_result(before['test'], after['test']);
        }
        $bloading.hide();
        return $aloading.hide();
      });
    };

    BuilderScriptTestResultPage.prototype.initialize_table_header = function(type) {
      var $test_result_table_header, block;
      if ($test_result_table_header = this.get_element("test-result-table-header")) {
        block = Blocks("table-header-block");
        return block.add_block($test_result_table_header, {
          type: type
        });
      }
    };

    BuilderScriptTestResultPage.prototype.load_test_result = function(before, after) {
      var $test_result_after, $test_result_before;
      if ($test_result_before = this.get_element("test-result-before")) {
        this.load_test_result_with_container($test_result_before, before);
      }
      if ($test_result_after = this.get_element("test-result-after")) {
        return this.load_test_result_with_container($test_result_after, after);
      }
    };

    BuilderScriptTestResultPage.prototype.request_test_result_before = function(nid, skip, size, options) {
      var $loading,
        _this = this;
      $loading = this.get_element("before-loading");
      $loading.show();
      return Script.get_script_with_test(nid, skip, size, options, function(data) {
        var $test_result_before, script;
        script = data['script'][0];
        if ($test_result_before = _this.get_element("test-result-before")) {
          _this.load_test_result_with_container($test_result_before, script['test']['before']['test']);
        }
        return $loading.hide();
      });
    };

    BuilderScriptTestResultPage.prototype.request_test_result_after = function(nid, skip, size, options) {
      var $loading,
        _this = this;
      $loading = this.get_element("after-loading");
      $loading.show();
      return Script.get_script_with_test(nid, skip, size, options, function(data) {
        var $test_result_after, script;
        script = data['script'][0];
        if ($test_result_after = _this.get_element("test-result-after")) {
          _this.load_test_result_with_container($test_result_after, script['test']['after']['test']);
        }
        return $loading.hide();
      });
    };

    BuilderScriptTestResultPage.prototype.load_test_result_with_container = function($container, result) {
      if ($container) {
        if (result.length > 0) {
          return this.load_test_result_packer($container, result);
        } else {
          return $container.find('#noresult').show();
        }
      }
    };

    BuilderScriptTestResultPage.prototype.load_test_result_packer = function($test_result, testresults) {
      var block, puzzle_nid, solution_nid, test, test_param, test_result_params, _i, _len, _results,
        _this = this;
      block = Blocks("test-result-block");
      test_result_params = [];
      _results = [];
      for (_i = 0, _len = testresults.length; _i < _len; _i++) {
        test = testresults[_i];
        test_param = {};
        if (test['puzzle_nid']) {
          puzzle_nid = test['puzzle_nid'];
          solution_nid = test['nid'];
          test_param['type'] = "RNA scoring";
          test_param['nid'] = puzzle_nid;
          test_param['score'] = Number(test['cause']);
          if (isNaN(test_param['score'])) {
            test_param['score'] = "Not a Number";
          }
          test_param['target_url'] = "/game/browse/" + puzzle_nid + "/?filter1=Id&filter1_arg1=" + solution_nid + "&filter1_arg2=" + solution_nid;
        } else {
          test_param['type'] = "Puzzle solving";
          test_param['nid'] = test['nid'];
          test_param['target_url'] = "/web/puzzle/" + test_param['nid'] + "/";
        }
        test_param['puzzle_nid'] = test['nid'];
        test_param['puzzle_title'] = test['name'];
        test_param['num_cleared'] = test['num_cleared'] != null ? test['num_cleared'] : 0;
        test_param['test_result'] = test['result'];
        test_param['test_cause'] = test['cause'];
        test_param['test_time'] = test['eval_time'] / 1000;
        test_result_params.push(test_param);
        block.add_block($test_result, test_param);
        _results.push((function(test_param) {
          var $show_sequence, $test_cause;
          if ($show_sequence = _this.get_element(test_param['puzzle_nid'] + '_show_sequence')) {
            if ($test_cause = _this.get_element(test_param['puzzle_nid'] + '_test_cause')) {
              $test_cause.hide();
              return $show_sequence.click(function() {
                $show_sequence.hide();
                return $test_cause.show();
              });
            }
          }
        })(test_param));
      }
      return _results;
    };

    return BuilderScriptTestResultPage;

  })(Builder);

}).call(this);
