// Generated by CoffeeScript 1.6.3
(function() {
  var __hasProp = {}.hasOwnProperty;

  this.EternaUtils = {
    format_body: function(str) {
      if (!str) {
        return "";
      }
      str = Utils.strip_html(str, ["script"]);
      return Utils.newline_to_br(str);
    },
    format_summary: function(str, len) {
      if (!str) {
        return "";
      }
      str = str.replace(/\n\r/g, "");
      str = Utils.remove_html(str);
      if (str.length > len) {
        str = str.substring(0, len) + "..";
      }
      return str;
    },
    format_comment_mentions: function(str) {
      var s, uname;
      if (!str) {
        return "";
      }
      uname = Application.CURRENT_USER['name'];
      if (!(uname != null)) {
        return str;
      }
      s = "<span class='interactive-mention-me'>@" + uname + "</span>";
      str = str.replace(/(@[A-Za-z0-9_]+)/, function($mention) {
        if ($mention.indexOf(uname) >= 0) {
          $mention = s;
        }
        return $mention;
      });
      return str;
    },
    get_pager: function(current_page, total_pages, pageindex_to_url) {
      var big_index, chunk, ii, str, _i, _ref, _ref1;
      if (total_pages < 1) {
        return "";
      }
      str = "";
      chunk = 10;
      big_index = Math.floor(current_page / chunk);
      str += "<a href='" + pageindex_to_url(0) + "'>&lsaquo;&lsaquo;</a> &nbsp;&nbsp;";
      if (big_index > 0) {
        str += "<a href='" + pageindex_to_url(big_index * chunk - 1) + "'>&lsaquo;</a> &nbsp;&nbsp;";
      }
      for (ii = _i = _ref = big_index * chunk, _ref1 = Math.min((big_index + 1) * chunk, total_pages) - 1; _i <= _ref1; ii = _i += 1) {
        if (ii === current_page) {
          str += "<strong>" + (ii + 1) + "</strong> &nbsp;&nbsp;";
        } else {
          str += "<a href='" + pageindex_to_url(ii) + "'>" + (ii + 1) + "</a> &nbsp;&nbsp;";
        }
      }
      if (total_pages > (big_index + 1) * chunk) {
        str += "<a href='" + pageindex_to_url((big_index + 1) * chunk) + "'>&rsaquo;</a> &nbsp;&nbsp;";
      }
      str += "<a href='" + pageindex_to_url(total_pages - 1) + "'>&rsaquo;&rsaquo;</a>";
      return str;
    },
    process_response: function(response, success_cb, fail_cb) {
      var $overlay_slot, achievements, block, key, new_achievements, val;
      if (!(response != null)) {
        if (fail_cb != null) {
          fail_cb();
          return;
        }
      }
      if (response['error'] != null) {
        Utils.display_error(response['error']);
        return;
      }
      if (!(response['data'] != null)) {
        if (fail_cb != null) {
          fail_cb();
          return;
        }
      }
      if (new_achievements = response['new_achievements']) {
        achievements = [];
        for (key in new_achievements) {
          if (!__hasProp.call(new_achievements, key)) continue;
          val = new_achievements[key];
          achievements.push(val);
        }
        block = Blocks("overlay-achievements");
        $overlay_slot = Overlay.get_slot("achievements");
        Overlay.load_overlay_content("achievements");
        Overlay.show();
        block.add_block($overlay_slot, {
          achievements: achievements
        });
      }
      if (success_cb != null) {
        return success_cb(response['data']);
      }
    },
    get_user_picture: function(uri) {
      if ((uri != null) && !Utils.is_text_empty(uri)) {
        if (/^http/i.exec(uri)) {
          return uri;
        }
        return "/" + uri;
      } else {
        return Application.DEFAULT_USER_PICTURE;
      }
    },
    get_puzzle_middle_thumbnail: function(nid) {
      return "https://s3.amazonaws.com/eterna/puzzle_mid_thumbnails/thumbnail" + nid + ".png";
    },
    get_puzzle_cloud_thumbnail: function(nid) {
      return "https://s3.amazonaws.com/eterna/puzzle_cloud_thumbnails/thumbnail" + nid + ".png";
    },
    format_sequence_base_number: function(str) {
      var ii, left, r_str, _i, _ref;
      if (!str) {
        return "";
      }
      r_str = "";
      left = 16 * 4;
      for (ii = _i = 0, _ref = str.length - 1; _i <= _ref; ii = _i += 1) {
        if (!((ii + 1) % 5)) {
          r_str += "<span class='monospace' style='position:relative; left:" + left + "px; font-family:arial;color:#000000;'>" + (ii + 1) + "</span>";
          if (ii < 99) {
            left += 16 * 4;
          } else {
            left += 16 * 4 - 8;
          }
        }
      }
      return r_str;
    },
    format_sequence_base_color: function(str) {
      var ch, fifth_base, ii, r_str, _i, _ref;
      if (!str) {
        return "";
      }
      str = str.toUpperCase();
      r_str = "";
      for (ii = _i = 0, _ref = str.length - 1; _i <= _ref; ii = _i += 1) {
        if (!((ii - 4) % 5)) {
          fifth_base = " line-per-five-base";
        } else {
          fifth_base = "";
        }
        ch = str.charAt(ii);
        if (ch === "G") {
          r_str += "<span class='monospace" + fifth_base + "' style='font-family:arial;color:#FF3333;'>G</span>";
        }
        if (ch === "C") {
          r_str += "<span class='monospace" + fifth_base + "' style='font-family:arial;color:#33FF33;'>C</span>";
        }
        if (ch === "A") {
          r_str += "<span class='monospace" + fifth_base + "' style='font-family:arial;color:#FFFF33;'>A</span>";
        }
        if (ch === "U") {
          r_str += "<span class='monospace" + fifth_base + "' style='font-family:arial;color:#7777FF;'>U</span>";
        }
      }
      return r_str;
    },
    format_sequence_exp_data_absolute: function(seq, shape_value, shape_threshold, struct, continuous) {
      var bg_color, ch, fifth_base, ii, jj, max, min, r_seq, sec, t, v, _i, _ref;
      if (!seq) {
        return "";
      }
      r_seq = "";
      jj = 1;
      if (shape_value != null) {
        min = 0;
        max = 1;
        shape_value = this.transform(shape_value, min, max);
      }
      for (ii = _i = 0, _ref = seq.length - 1; _i <= _ref; ii = _i += 1) {
        if (!((ii - 4) % 5)) {
          fifth_base = " line-per-five-base";
        } else {
          fifth_base = "";
        }
        ch = seq.charAt(ii);
        sec = struct.charAt(ii);
        if (sec === "(" || sec === ")") {
          bg_color = 'rgba(0,0,102,0.5)';
        } else {
          bg_color = 'rgba(255,255,0,0.5)';
        }
        r_seq += '<span class="monospace' + fifth_base + '" style="font-family:arial;background-color:' + bg_color + ';color:';
        if (shape_value === null || shape_value[0] === "FAILED") {
          r_seq += 'grey;">';
        } else {
          if (parseInt(shape_value[0], 10) - 1 > ii || ii >= shape_value.length + parseInt(shape_value[0], 10) - 1) {
            r_seq += 'grey;">';
          } else {
            v = parseFloat(shape_value[jj]);
            t = 0.5;
            if (continuous) {
              if (v < t) {
                r_seq += this.find_color_by_level(this.find_level(min, max, t, v));
                r_seq += ';';
              } else if (v === t) {
                r_seq += '#FFFFFF;';
              } else {
                r_seq += this.find_color_by_level(this.find_level(min, max, t, v));
                r_seq += ';';
              }
            } else {
              if (v <= t) {
                r_seq += '#2222FF;';
              } else {
                r_seq += '#FFFF00;';
              }
            }
            r_seq += '" title="location:' + ii + ' shape value:' + v + '">';
            jj += 1;
          }
        }
        r_seq += ch + '</span>';
      }
      return r_seq;
    },
    format_sequence_exp_data_absolute_error: function(seq, shape_value, shape_threshold, struct, continuous, shape_error) {
      var bg_color, ch, fifth_base, ii, jj, max, min, r_seq, sec, t, v, _i, _ref;
      if (!seq) {
        return "";
      }
      r_seq = "";
      jj = 1;
      if (shape_value != null) {
        min = 0;
        max = 1;
        shape_value = this.transform(shape_value, min, max);
      }
      for (ii = _i = 0, _ref = seq.length - 1; _i <= _ref; ii = _i += 1) {
        fifth_base = "";
        ch = seq.charAt(ii);
        sec = struct.charAt(ii);
        if (sec === "(" || sec === ")") {
          bg_color = 'rgba(0,0,102,0.5)';
        } else {
          bg_color = 'rgba(255,255,0,0.5)';
        }
        if (shape_value === null || shape_value[0] === "FAILED") {
          r_seq += '<span class="monospace' + fifth_base + '" style="background-color:' + bg_color + ';color:grey;">';
        } else {
          if (parseInt(shape_value[0], 10) - 1 > ii || ii >= shape_value.length + parseInt(shape_value[0], 10) - 1) {
            r_seq += '<span class="monospace' + fifth_base + '" style="background-color:' + bg_color + ';color:grey;">';
          } else {
            if ((shape_error != null) && parseFloat(shape_error[jj]) >= 0.8) {
              r_seq += '<span class="monospace red-border-for-err' + fifth_base + '" style="background-color:' + bg_color + ';color:';
            } else {
              r_seq += '<span class="monospace' + fifth_base + '" style="background-color:' + bg_color + ';color:';
            }
            v = parseFloat(shape_value[jj]);
            t = 0.5;
            if (continuous) {
              if (v < t) {
                r_seq += this.find_color_by_level(this.find_level(min, max, t, v));
                r_seq += ';';
              } else if (v === t) {
                r_seq += '#FFFFFF;';
              } else {
                r_seq += this.find_color_by_level(this.find_level(min, max, t, v));
                r_seq += ';';
              }
            } else {
              if (v <= t) {
                r_seq += '#2222FF;';
              } else {
                r_seq += '#FFFF00;';
              }
            }
            r_seq += '" title="location:' + ii + ' shape value:' + v + '">';
            jj += 1;
          }
        }
        r_seq += ch + '</span>';
      }
      return r_seq;
    },
    format_sequence_exp_data_legacy: function(seq, shape_value, shape_threshold, struct, continuous) {
      var avg, ch, fifth_base, ii, jj, max, min, min_max, r_seq, sec, t, v, _i, _ref;
      if (!seq) {
        return "";
      }
      r_seq = "";
      jj = 1;
      if (shape_value != null) {
        min_max = this.find_min_max(shape_value);
        min = min_max['min'];
        max = min_max['max'];
        avg = this.find_average(shape_value);
      }
      for (ii = _i = 0, _ref = seq.length - 1; _i <= _ref; ii = _i += 1) {
        if (!((ii - 4) % 5)) {
          fifth_base = " line-per-five-base";
        } else {
          fifth_base = "";
        }
        ch = seq.charAt(ii);
        sec = struct.charAt(ii);
        if (sec === "(" || sec === ")") {
          r_seq += '<span class="monospace' + fifth_base + '" style="font-family:arial;background-color:rgba(0,0,102,0.5);color:';
        } else {
          r_seq += '<span class="monospace' + fifth_base + '" style="font-family:arial;background-color:rgba(255,255,0,0.5);color:';
        }
        if (shape_value === null || shape_value[0] === "FAILED") {
          r_seq += 'grey;">';
        } else {
          if (parseInt(shape_value[0], 10) - 1 > ii || ii >= shape_value.length + parseInt(shape_value[0], 10) - 1) {
            r_seq += 'grey;">';
          } else {
            v = parseFloat(shape_value[jj]);
            t = parseFloat(shape_threshold);
            if (continuous) {
              if (v < t) {
                r_seq += this.find_color_by_level(this.find_level(min, max, avg, v));
                r_seq += ';" title="location:' + ii + ' shape value:' + v + '">';
              } else if (v === t) {
                r_seq += '#FFFFFF;" title="location:' + ii + ' shape value:' + v + '">';
              } else {
                r_seq += this.find_color_by_level(this.find_level(min, max, avg, v));
                r_seq += ';" title="location:' + ii + ' shape value:' + v + '">';
              }
            } else {
              if (v <= t) {
                r_seq += '#2222FF;" title="location:' + ii + ' shape value:' + v + '">';
              } else {
                r_seq += '#FFFF00;" title="location:' + ii + ' shape value:' + v + '">';
              }
            }
            jj += 1;
          }
        }
        r_seq += ch + '</span>';
      }
      return r_seq;
    },
    format_sequence_exp_data_cont_bg: function(seq, shape_value, shape_threshold, struct) {
      var avg, ch, fifth_base, ii, jj, max, min, min_max, r_seq, sec, t, v, _i, _ref;
      if (!seq) {
        return "";
      }
      r_seq = "";
      jj = 1;
      if (shape_value != null) {
        min_max = this.find_min_max(shape_value);
        min = min_max['min'];
        max = min_max['max'];
        avg = this.find_average(shape_value);
      }
      for (ii = _i = 0, _ref = seq.length - 1; _i <= _ref; ii = _i += 1) {
        if (!((ii - 4) % 5)) {
          fifth_base = " line-per-five-base";
        } else {
          fifth_base = "";
        }
        ch = seq.charAt(ii);
        sec = struct.charAt(ii);
        r_seq += '<span class="monospace' + fifth_base + '" style="font-family:arial;';
        if (ch === "G") {
          r_seq += 'color:#FF3333; background-color:';
        }
        if (ch === "C") {
          r_seq += 'color:#33FF33; background-color:';
        }
        if (ch === "A") {
          r_seq += 'color:#FFFF33; background-color:';
        }
        if (ch === "U") {
          r_seq += 'color:#7777FF; background-color:';
        }
        if (shape_value === null || shape_value[0] === "FAILED") {
          r_seq += 'none;"';
        } else {
          if (parseInt(shape_value[0], 10) - 1 > ii || ii >= shape_value.length + parseInt(shape_value[0], 10) - 1) {
            r_seq += 'none;"';
          } else {
            v = parseFloat(shape_value[jj]);
            t = parseFloat(shape_threshold);
            if (v < t) {
              r_seq += this.find_color_by_level(this.find_level(min, max, avg, v), true);
              r_seq += ';" title="location:' + ii + ' shape value:' + v + '"';
            } else if (v === t) {
              r_seq += 'gray;" title="location:' + ii + ' shape value:' + v + '"';
            } else {
              r_seq += this.find_color_by_level(this.find_level(min, max, avg, v), true);
              r_seq += ';" title="location:' + ii + ' shape value:' + v + '"';
            }
            jj += 1;
          }
        }
        if (ch === "G") {
          r_seq += '>G</span>';
        }
        if (ch === "C") {
          r_seq += '>C</span>';
        }
        if (ch === "A") {
          r_seq += '>A</span>';
        }
        if (ch === "U") {
          r_seq += '>U</span>';
        }
      }
      return r_seq;
    },
    generate_mutation_map: function(sequence) {
      var i, k, mmaps, mutation_map, mutation_title, pairs, _i, _ref;
      pairs = {
        'A': 'U',
        'U': 'A',
        'G': 'C',
        'C': 'G'
      };
      mutation_map = Array();
      mutation_title = Array();
      sequence = sequence.toUpperCase();
      mutation_map.push(sequence);
      mutation_title.push("WT");
      for (i = _i = 0, _ref = sequence.length - 1; _i <= _ref; i = _i += 1) {
        if (k = pairs[sequence.charAt(i)]) {
          mutation_map.push(sequence.substring(0, i) + k + sequence.substring(i + 1, sequence.length));
          mutation_title.push(sequence.charAt(i) + (i + 1) + k);
        } else {
          return null;
        }
      }
      mmaps = Array();
      mmaps['map'] = mutation_map;
      mmaps['title'] = mutation_title;
      return mmaps;
    },
    transform: function(shape_value, min, max) {
      var ii, _i, _ref;
      for (ii = _i = 1, _ref = shape_value.length - 1; _i <= _ref; ii = _i += 1) {
        if (shape_value[ii] > max) {
          shape_value[ii] = 1;
        }
        if (shape_value[ii] < min) {
          shape_value[ii] = 0;
        }
      }
      return shape_value;
    },
    find_min_max: function(shape) {
      var NUM_COLORS, ii, max, min, _i, _ref;
      min = 9999;
      max = -9999;
      NUM_COLORS = 5;
      for (ii = _i = 1, _ref = shape.length - 1; _i <= _ref; ii = _i += 1) {
        if (shape[ii] <= min) {
          min = shape[ii];
        }
        if (shape[ii] >= max) {
          max = shape[ii];
        }
      }
      return {
        'min': min,
        'max': max
      };
    },
    find_average: function(shape) {
      var ii, total, _i, _ref;
      total = 0;
      for (ii = _i = 1, _ref = shape.length - 1; _i <= _ref; ii = _i += 1) {
        total += parseInt(shape[ii]);
      }
      return total * 1.0 / (shape.length - 1);
    },
    find_level: function(min, max, avg, v) {
      var NUM_COLORS, diff, level;
      diff = v - avg;
      NUM_COLORS = 5;
      if (diff > 0) {
        diff = diff / (max - avg);
        if (diff > 1) {
          diff = 1;
        }
        if (diff < 0) {
          diff = 0;
        }
        level = Math.round(NUM_COLORS * diff);
      } else {
        diff *= -1;
        diff = diff / (avg - min);
        if (diff > 1) {
          diff = 1;
        }
        if (diff < 0) {
          diff = 0;
        }
        level = Math.round(NUM_COLORS * diff) * -1;
      }
      return level;
    },
    find_color_by_level: function(level, grayscale) {
      var EXPOSED_B, EXPOSED_G, EXPOSED_R, MID_B, MID_G, MID_R, NUM_COLORS, UNEXPOSED_B, UNEXPOSED_G, UNEXPOSED_R, b, diff, g, r;
      NUM_COLORS = 5;
      diff = 1.0 / NUM_COLORS * level;
      if (grayscale === true) {
        UNEXPOSED_R = 255;
        UNEXPOSED_G = 255;
        UNEXPOSED_B = 255;
        EXPOSED_R = 0;
        EXPOSED_G = 0;
        EXPOSED_B = 0;
        MID_R = 127;
        MID_G = 127;
        MID_B = 127;
      } else {
        UNEXPOSED_R = 34;
        UNEXPOSED_G = 34;
        UNEXPOSED_B = 255;
        EXPOSED_R = 255;
        EXPOSED_G = 255;
        EXPOSED_B = 0;
        MID_R = 255;
        MID_G = 255;
        MID_B = 255;
      }
      if (diff > 0) {
        r = EXPOSED_R * diff + MID_R * (1 - diff);
        g = EXPOSED_G * diff + MID_G * (1 - diff);
        b = EXPOSED_B * diff + MID_B * (1 - diff);
      } else {
        diff *= -1;
        r = UNEXPOSED_R * diff + MID_R * (1 - diff);
        g = UNEXPOSED_G * diff + MID_G * (1 - diff);
        b = UNEXPOSED_B * diff + MID_B * (1 - diff);
      }
      return 'rgb(' + Math.floor(r) + ',' + Math.floor(g) + ',' + Math.floor(b) + ')';
    },
    format_sequence_exp_data: function(seq, shape_value, shape_threshold, struct, version) {
      var bg, bgcolor, ch, fifth_base, ii, jj, level, max, min, min_max, r_seq, sec, t, v, _i, _ref;
      if (!seq) {
        return "";
      }
      r_seq = "";
      jj = 1;
      if (shape_value != null) {
        min_max = this.find_min_max(shape_value);
        min = min_max['min'];
        max = min_max['max'];
      }
      for (ii = _i = 0, _ref = seq.length - 1; _i <= _ref; ii = _i += 1) {
        if (!((ii - 4) % 5)) {
          fifth_base = " line-per-five-base";
        } else {
          fifth_base = "";
        }
        ch = seq.charAt(ii);
        sec = struct.charAt(ii);
        if (version === 3) {
          if (sec === "(" || sec === ")") {
            r_seq += '<span class="monospace' + fifth_base + '" style="font-family:arial;';
          } else {
            r_seq += '<span class="monospace' + fifth_base + '" style="font-family:arial;';
          }
        } else {
          if (sec === "(" || sec === ")") {
            r_seq += '<span class="monospace' + fifth_base + '" style="font-family:arial;background-color:rgba(0,0,102,0.5);color:';
          } else {
            r_seq += '<span class="monospace' + fifth_base + '" style="font-family:arial;background-color:rgba(255,255,0,0.5);color:';
          }
        }
        if (shape_value === null || shape_value[0] === "FAILED") {
          if (version === 3) {
            r_seq += ' color:grey;">';
          } else {
            r_seq += 'grey;">';
          }
        } else {
          if (parseInt(shape_value[0], 10) - 1 > ii || ii >= shape_value.length + parseInt(shape_value[0], 10) - 1) {
            r_seq += 'grey;">';
          } else {
            v = parseFloat(shape_value[jj]);
            t = parseFloat(shape_threshold);
            if (version === 2) {
              if (v < t) {
                r_seq += this.find_color(min, max, v, t);
                r_seq += ';" title="location:' + ii + ' shape value:' + v + '">';
              } else if (v === t) {
                r_seq += '#FFFFFF;" title="location:' + ii + ' shape value:' + v + '">';
              } else {
                r_seq += this.find_color(min, max, v, t);
                r_seq += ';" title="location:' + ii + ' shape value:' + v + '">';
              }
            } else {
              if (version === 1) {
                if (v <= t) {
                  r_seq += '#2222FF;" title="location:' + ii + ' shape value:' + v + '">';
                } else {
                  r_seq += '#FFFF00;" title="location:' + ii + ' shape value:' + v + '">';
                }
              } else {
                level = (v - min) * 10 / (max - min);
                bgcolor = Math.floor(255 * level * 0.1);
                bg = 'rgba(' + bgcolor + ',' + bgcolor + ',' + bgcolor + ',0.75)';
                if (v <= t) {
                  r_seq += ' background-color:' + bg + '; color:#2222FF;" title="location:' + ii + ' shape value:' + v + '">';
                } else {
                  r_seq += ' background-color:' + bg + '; color:#FFFF00;" title="location:' + ii + ' shape value:' + v + '">';
                }
              }
            }
            jj += 1;
          }
        }
        r_seq += ch + '</span>';
      }
      return r_seq;
    },
    draw_secstructure: function(secstruct, div, sequence, shape_value, shape_threshold, in_canvas, using_line, primary_space, pair_space, line_width) {
      var innerHTML, inner_div, rna_layout_layer, rna_tree_root, thumbnail_canvas;
      if (!secstruct) {
        return "";
      }
      rna_layout_layer = null;
      if (in_canvas !== true) {
        div.addClass("rna-canvas-outer");
        innerHTML = '';
        innerHTML += '<div class="green-button clickable rounded-5 rna-canvas-zoom" id="zoom-out-' + div.attr('id') + '"><div class="green-button-bg"></div> - </div>';
        innerHTML += '<div class="green-button clickable rounded-5 rna-canvas-zoom" id="zoom-in-' + div.attr('id') + '" ><div class="green-button-bg"></div> + </div>';
        innerHTML += '<div class="clearer"></div>';
        innerHTML += '<div id="_' + div.attr('id') + '" class="rna-canvas"></div>';
        div.append(innerHTML);
        $('#zoom-out-' + div.attr('id')).on("click", function() {
          return rna_layout_layer.zoom_out();
        });
        $('#zoom-in-' + div.attr('id')).on("click", function() {
          return rna_layout_layer.zoom_in();
        });
        if (inner_div = div.children("#_" + div.attr('id'))) {
          rna_tree_root = new RNATree(secstruct);
          rna_layout_layer = new RNALayout(rna_tree_root, inner_div, secstruct, sequence, primary_space, pair_space);
          rna_layout_layer.draw_tree_in_html(sequence, shape_value, shape_threshold);
          return rna_layout_layer;
        }
      } else {
        rna_tree_root = new RNATree(secstruct);
        rna_layout_layer = new RNALayout(rna_tree_root, div, secstruct, sequence, primary_space, pair_space);
        thumbnail_canvas = div.children();
        rna_layout_layer.draw_tree_in_canvas(thumbnail_canvas[0], using_line, line_width);
        return rna_layout_layer;
      }
      return window.onload = function() {
        if (in_canvas) {
          rna_tree_root = new RNATree(secstruct);
          rna_layout_layer = new RNALayout(rna_tree_root, div, secstruct, sequence, primary_space, pair_space);
          thumbnail_canvas = div.children();
          rna_layout_layer.draw_tree_in_canvas(thumbnail_canvas[0], using_line, line_width);
          return rna_layout_layer;
        }
      };
    }
  };

  this.RNATreeNode = (function() {
    function RNATreeNode() {
      this.children_ = new Array;
      this.index_a_ = -1;
      this.index_b_ = -1;
      this.is_pair_ = false;
    }

    return RNATreeNode;

  })();

  this.RNATree = (function() {
    function RNATree(secstruct) {
      this.root = null;
      if (secstruct != null) {
        this.create_tree(secstruct);
      }
      return this.root;
    }

    RNATree.prototype.get_root = function() {
      return this.root;
    };

    RNATree.prototype.create_tree = function(secstruct) {
      var pairs;
      this.root = new RNATreeNode;
      pairs = this.get_pairmap(secstruct);
      return this.setup_tree(pairs, this.root);
    };

    RNATree.prototype.get_pairmap = function(secstruct) {
      var ii, index, pair_stack, pairs_array, _i, _j, _ref, _ref1;
      pair_stack = new Array;
      pairs_array = new Array;
      for (ii = _i = 0, _ref = secstruct.length - 1; _i <= _ref; ii = _i += 1) {
        pairs_array.push(-1);
      }
      for (ii = _j = 0, _ref1 = secstruct.length - 1; _j <= _ref1; ii = _j += 1) {
        if (secstruct.charAt(ii) === "(") {
          pair_stack.push(ii);
        } else if (secstruct.charAt(ii) === ")") {
          index = pair_stack.pop();
          pairs_array[index] = ii;
          pairs_array[ii] = index;
        }
      }
      return pairs_array;
    };

    RNATree.prototype.setup_tree = function(pairs, root) {
      var bi_pairs, ii, new_sub_node, _i, _j, _k, _ref, _ref1, _ref2;
      bi_pairs = new Array(pairs.length);
      for (ii = _i = 0, _ref = pairs.length - 1; _i <= _ref; ii = _i += 1) {
        bi_pairs[ii] = -1;
      }
      for (ii = _j = 0, _ref1 = pairs.length - 1; _j <= _ref1; ii = _j += 1) {
        if (ii < pairs[ii]) {
          bi_pairs[ii] = pairs[ii];
          bi_pairs[pairs[ii]] = ii;
        }
      }
      for (ii = _k = 0, _ref2 = bi_pairs.length - 1; _k <= _ref2; ii = _k += 1) {
        if (bi_pairs[ii] >= 0) {
          this.add_nodes(bi_pairs, root, ii, bi_pairs[ii]);
          _k = bi_pairs[ii];
        } else {
          new_sub_node = new RNATreeNode;
          new_sub_node.is_pair_ = false;
          new_sub_node.index_a_ = ii;
          root.children_.push(new_sub_node);
        }
      }
    };

    RNATree.prototype.add_nodes = function(bi_pairs, root, start, end) {
      var jj, new_node, new_sub_node, _i;
      if (start > end) {
        return;
      }
      new_node = new RNATreeNode;
      if (bi_pairs[start] === end) {
        new_node.is_pair_ = true;
        new_node.index_a_ = start;
        new_node.index_b_ = end;
        this.add_nodes(bi_pairs, new_node, start + 1, end - 1);
      } else {
        for (jj = _i = start; _i <= end; jj = _i += 1) {
          if (bi_pairs[jj] >= 0) {
            this.add_nodes(bi_pairs, new_node, jj, bi_pairs[jj]);
            _i = bi_pairs[jj];
          } else {
            new_sub_node = new RNATreeNode;
            new_sub_node.is_pair_ = false;
            new_sub_node.index_a_ = jj;
            new_node.children_.push(new_sub_node);
          }
        }
      }
      root.children_.push(new_node);
    };

    return RNATree;

  })();

  this.RNALayout = (function() {
    function RNALayout(root, div, secstruct, sequence, primary_space, pair_space) {
      this.root = root;
      this.div = div;
      this.secstruct = secstruct;
      this.sequence = sequence;
      this.node_r = 7;
      if (primary_space != null) {
        this.PRIMARY_SPACE = primary_space;
      } else {
        this.PRIMARY_SPACE = 10;
      }
      if (pair_space != null) {
        this.PAIR_SPACE = pair_space;
      } else {
        this.PAIR_SPACE = 10;
      }
      this.x_array = new Array;
      this.y_array = new Array;
      this.draw_tree();
    }

    RNALayout.prototype.draw_tree = function() {
      if (this.root != null) {
        return this.draw_tree_recursive(this.root, null, 0, 0, 0, 1);
      }
    };

    RNALayout.prototype.draw_tree_recursive = function(root, parent, start_x, start_y, go_x, go_y) {
      var child_go_len, child_go_x, child_go_y, child_x, child_y, children_width, circle_length, circle_radius, cross_x, cross_y, ii, length_walker, npairs, rad_angle, _i, _j, _ref, _ref1, _results;
      cross_x = -go_y;
      cross_y = go_x;
      children_width = root.children_.length * this.node_r * 2.0;
      root.go_x_ = go_x;
      root.go_y_ = go_y;
      if (root.children_.length === 1) {
        root.x_ = start_x;
        root.y_ = start_y;
        if (root.children_[0].is_pair_) {
          return this.draw_tree_recursive(root.children_[0], root, start_x + go_x * this.PRIMARY_SPACE, start_y + go_y * this.PRIMARY_SPACE, go_x, go_y);
        } else if (!root.children_[0].is_pair_ && root.children_[0].index_a_ < 0) {
          return this.draw_tree_recursive(root.children_[0], root, start_x, start_y, go_x, go_y);
        } else {
          return this.draw_tree_recursive(root.children_[0], root, start_x + go_x * this.PRIMARY_SPACE, start_y + go_y * this.PRIMARY_SPACE, go_x, go_y);
        }
      } else if (root.children_.length > 1) {
        npairs = 0;
        for (ii = _i = 0, _ref = root.children_.length - 1; _i <= _ref; ii = _i += 1) {
          if (root.children_[ii].is_pair_) {
            npairs += 1;
          }
        }
        circle_length = (root.children_.length + 1) * this.PRIMARY_SPACE * 1.0 + (npairs + 1) * this.PAIR_SPACE * 1.0;
        circle_radius = circle_length / (2.0 * Math.PI);
        length_walker = this.PAIR_SPACE / 2.0;
        if (parent != null) {
          root.x_ = parent.x_ + go_x * circle_radius * 1.0;
          root.y_ = parent.y_ + go_y * circle_radius * 1.0;
        } else {
          root.x_ = go_x * circle_radius * 1.0;
          root.y_ = go_y * circle_radius * 1.0;
        }
        _results = [];
        for (ii = _j = 0, _ref1 = root.children_.length - 1; _j <= _ref1; ii = _j += 1) {
          length_walker += this.PRIMARY_SPACE;
          if (root.children_[ii].is_pair_) {
            length_walker += this.PAIR_SPACE / 2.0;
          }
          rad_angle = length_walker / circle_length * 2 * Math.PI - Math.PI / 2.0;
          child_x = root.x_ + Math.cos(rad_angle) * cross_x * circle_radius + Math.sin(rad_angle) * go_x * circle_radius * 1.0;
          child_y = root.y_ + Math.cos(rad_angle) * cross_y * circle_radius + Math.sin(rad_angle) * go_y * circle_radius * 1.0;
          child_go_x = child_x - root.x_;
          child_go_y = child_y - root.y_;
          child_go_len = Math.sqrt(child_go_x * child_go_x * 1.0 + child_go_y * child_go_y * 1.0);
          this.draw_tree_recursive(root.children_[ii], root, child_x, child_y, child_go_x / child_go_len, child_go_y / child_go_len);
          if (root.children_[ii].is_pair_) {
            _results.push(length_walker += this.PAIR_SPACE / 2.0);
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      } else {
        root.x_ = start_x;
        return root.y_ = start_y;
      }
    };

    RNALayout.prototype.get_coords = function() {
      if (this.root != null) {
        return this.get_coords_recursive(this.root);
      }
    };

    RNALayout.prototype.get_coords_recursive = function(root) {
      var cross_x, cross_y, ii, _i, _ref, _results;
      if (root.is_pair_) {
        cross_x = -root.go_y_;
        cross_y = root.go_x_;
        this.x_array[root.index_a_] = root.x_ + cross_x * this.PAIR_SPACE / 2.0;
        this.x_array[root.index_b_] = root.x_ - cross_x * this.PAIR_SPACE / 2.0;
        this.y_array[root.index_a_] = root.y_ + cross_y * this.PAIR_SPACE / 2.0;
        this.y_array[root.index_b_] = root.y_ - cross_y * this.PAIR_SPACE / 2.0;
      } else if (root.index_a_ >= 0) {
        this.x_array[root.index_a_] = root.x_;
        this.y_array[root.index_a_] = root.y_;
      }
      _results = [];
      for (ii = _i = 0, _ref = root.children_.length - 1; _i <= _ref; ii = _i += 1) {
        _results.push(this.get_coords_recursive(root.children_[ii]));
      }
      return _results;
    };

    RNALayout.prototype.set_sizes = function() {
      var ii, max_x, max_y, min_x, min_y, node_r, x, x_array, y, y_array, _i, _j, _k, _ref, _ref1, _ref2;
      node_r = this.node_r;
      x_array = this.x_array;
      y_array = this.y_array;
      min_x = x_array[0] - node_r;
      max_x = x_array[0] + node_r;
      min_y = y_array[0] - node_r;
      max_y = y_array[0] + node_r;
      for (ii = _i = 0, _ref = x_array.length - 1; _i <= _ref; ii = _i += 1) {
        x = x_array[ii];
        if ((x - node_r) < min_x) {
          min_x = x - node_r;
        }
        if ((x + node_r) > max_x) {
          max_x = x + node_r;
        }
      }
      for (ii = _j = 0, _ref1 = y_array.length - 1; _j <= _ref1; ii = _j += 1) {
        y = y_array[ii];
        if ((y - node_r) < min_y) {
          min_y = y - node_r;
        }
        if ((y + node_r) > max_y) {
          max_y = y + node_r;
        }
      }
      for (ii = _k = 0, _ref2 = x_array.length - 1; _k <= _ref2; ii = _k += 1) {
        x_array[ii] -= min_x;
        y_array[ii] -= min_y;
      }
      this.width = max_x - min_x;
      return this.height = max_y - min_y;
    };

    RNALayout.prototype.recoordinate = function(new_width) {
      var ii, node_r, original_height, original_width, ratio, x_array, y_array, _i, _ref;
      original_width = this.width;
      original_height = this.height;
      node_r = this.node_r;
      x_array = this.x_array;
      y_array = this.y_array;
      ratio = new_width / original_width;
      for (ii = _i = 0, _ref = x_array.length - 1; _i <= _ref; ii = _i += 1) {
        this.x_array[ii] = x_array[ii] * ratio;
        this.y_array[ii] = y_array[ii] * ratio;
      }
      this.width = original_width * ratio;
      this.height = original_height * ratio;
      return this.node_r = node_r * ratio;
    };

    RNALayout.prototype.layout_draggable = function() {
      return this.div.draggable();
    };

    RNALayout.prototype.verify_structure = function(secstruct) {
      var ch, ii, _i, _ref;
      for (ii = _i = 0, _ref = secstruct.length - 1; _i <= _ref; ii = _i += 1) {
        ch = secstruct.charAt(ii);
        if (ch !== '.' && ch !== '(' && ch !== ')') {
          return false;
        }
      }
      return true;
    };

    RNALayout.prototype.verify_sequence = function(sequence) {
      var ch, ii, _i, _ref;
      if (sequence.length === this.secstruct.length) {
        for (ii = _i = 0, _ref = sequence.length - 1; _i <= _ref; ii = _i += 1) {
          ch = sequence.charAt(ii).toUpperCase();
          if (ch !== 'A' && ch !== 'U' && ch !== 'G' && ch !== 'C') {
            return false;
          }
        }
        return true;
      } else {
        return false;
      }
    };

    RNALayout.prototype.initialize = function() {
      this.root = null;
      this.x_array = new Array;
      return this.y_array = new Array;
    };

    RNALayout.prototype.change_structure_to = function(secstruct) {
      var rna_tree_root;
      if (this.verify_structure(secstruct)) {
        rna_tree_root = new RNATree(secstruct);
        this.initialize();
        this.remove_redundant_bases(secstruct);
        this.root = rna_tree_root;
        this.secstruct = secstruct;
        this.draw_tree();
        this.get_coords();
        this.set_sizes();
        this.animate_bases(null);
        return true;
      } else {
        return false;
      }
    };

    RNALayout.prototype.remove_redundant_bases = function(curr) {
      var canvas_id, ii, _i, _ref, _ref1, _results;
      canvas_id = this.div.attr('id');
      _results = [];
      for (ii = _i = _ref = curr.length, _ref1 = this.secstruct.length - 1; _i <= _ref1; ii = _i += 1) {
        _results.push($('#' + canvas_id + '-base-' + ii).remove());
      }
      return _results;
    };

    RNALayout.prototype.change_sequence_to = function(sequence) {
      var canvas_id, ii, _i, _ref;
      if (sequence !== null && this.verify_sequence(sequence)) {
        this.sequence = sequence;
        for (ii = _i = 0, _ref = sequence.length - 1; _i <= _ref; ii = _i += 1) {
          canvas_id = this.div.attr('id');
          $('#' + canvas_id + '-base-' + ii).removeClass();
          $('#' + canvas_id + '-base-' + ii).addClass(sequence.charAt(ii).toUpperCase() + '-base');
        }
        return true;
      } else {
        return false;
      }
    };

    RNALayout.prototype.animate_bases = function(zoom) {
      var $base_panel, canvas_id, ii, innerHTML, innerSTYLE, left, new_width, node_r, top, x_array, y_array, _i, _ref;
      if (zoom != null) {
        new_width = this.width;
        if (zoom === "zoom_in") {
          new_width = new_width * 1.2;
        } else {
          new_width = new_width * 5 / 6;
        }
        this.recoordinate(new_width);
        this.div.width(this.width);
      }
      x_array = this.x_array;
      y_array = this.y_array;
      node_r = this.node_r;
      innerHTML = "";
      innerSTYLE = "";
      for (ii = _i = 0, _ref = x_array.length - 1; _i <= _ref; ii = _i += 1) {
        canvas_id = this.div.attr('id');
        $base_panel = $('#' + canvas_id + '-base-' + ii);
        left = x_array[ii];
        top = y_array[ii];
        if ($base_panel.length !== 0) {
          $base_panel.animate({
            left: left.toFixed(3) + 'px',
            top: top.toFixed(3) + 'px'
          }, "false");
          innerSTYLE += '#' + canvas_id + '-base-' + ii + ' { width: ' + Math.ceil(node_r) + 'px; height:' + Math.ceil(node_r) + 'px; background-size:' + Math.floor(node_r) + 'px }\n';
        } else {
          innerHTML += '<span id="' + canvas_id + '-base-' + ii + '" class="N-base"></span>';
          innerSTYLE += '#' + canvas_id + '-base-' + ii + ' { width: ' + Math.ceil(node_r) + 'px; height:' + Math.ceil(node_r) + 'px; left:' + x_array[ii] + 'px; top:' + y_array[ii] + 'px; background-size:' + Math.floor(node_r) + 'px }\n';
        }
      }
      this.div.append(innerHTML);
      return this.add_bases_style(innerSTYLE, canvas_id);
    };

    RNALayout.prototype.add_bases_style = function(bases_style, canvas_id) {
      var css_id, style;
      css_id = canvas_id + '_css';
      if (!(style = document.getElementById(css_id))) {
        style = document.createElement('style');
        style.id = css_id;
        style.type = 'text/css';
      }
      style.innerHTML = bases_style;
      return document.getElementsByTagName('head')[0].appendChild(style);
    };

    RNALayout.prototype.add_zoom_javascript = function(zoom_javascript) {
      var script;
      script = document.createElement("script");
      script.type = "text/javascript";
      script.innerHTML = zoom_javascript;
      return document.body.appendChild(script);
    };

    RNALayout.prototype.reset_canvas_height = function(height) {
      this.height = height;
      return this.div.height(height);
    };

    RNALayout.prototype.reset_canvas_parent_height = function(height) {
      return this.div.parent().height(height + 55);
    };

    RNALayout.prototype.reset_canvas_parent_width = function(width) {
      return this.div.parent().width(width + 55);
    };

    RNALayout.prototype.reset_canvas_width = function(width) {
      this.width = width;
      return this.div.width(width);
    };

    RNALayout.prototype.draw_line = function(context, line_width) {
      var ii, next_x, next_y, x, y, _i, _ref;
      context.clearRect(0, 0, this.width, this.height);
      context.beginPath();
      context.lineWidth = line_width;
      context.strokeStyle = '#ffffff';
      for (ii = _i = 0, _ref = this.x_array.length - 2; _i <= _ref; ii = _i += 1) {
        x = this.x_array[ii];
        y = this.y_array[ii];
        context.moveTo(x, y);
        next_x = this.x_array[ii + 1];
        next_y = this.y_array[ii + 1];
        context.lineTo(next_x, next_y);
      }
      return context.stroke();
    };

    RNALayout.prototype.draw_dot = function(context) {
      var ii, radius, x, y, _i, _ref, _results;
      context.beginPath();
      radius = 3.5;
      _results = [];
      for (ii = _i = 0, _ref = this.x_array.length - 1; _i <= _ref; ii = _i += 1) {
        x = this.x_array[ii];
        y = this.y_array[ii];
        context.arc(x, y, radius, 0, 2 * Math.PI, false);
        context.fillStyle = '#ffffff';
        _results.push(context.fill());
      }
      return _results;
    };

    RNALayout.prototype.draw_tree_in_canvas = function(canvas, using_line, line_width) {
      var context;
      this.get_coords();
      this.set_sizes();
      canvas.width = this.width;
      canvas.height = this.height;
      context = canvas.getContext('2d');
      if (using_line === true) {
        return this.draw_line(context, line_width);
      } else {
        return this.draw_dot(context, line_width);
      }
    };

    RNALayout.prototype.draw_tree_in_html = function(sequence, shape_value, shape_threshold) {
      var base, canvas_id, cont_width, ii, innerHTML, innerSTYLE, jj, node_r, t, v, x_array, y_array, _i, _ref;
      this.get_coords();
      this.set_sizes();
      cont_width = this.div.width();
      if (cont_width < this.width && cont_width > 0) {
        this.recoordinate(cont_width);
      }
      innerHTML = "";
      innerSTYLE = "";
      canvas_id = this.div.attr('id');
      jj = 1;
      x_array = this.x_array;
      y_array = this.y_array;
      node_r = this.node_r;
      if (sequence != null) {
        sequence = sequence.toUpperCase();
      }
      for (ii = _i = 0, _ref = x_array.length - 1; _i <= _ref; ii = _i += 1) {
        innerHTML += '<span id="' + canvas_id + '-base-' + ii + '" ';
        if (sequence != null) {
          base = sequence.charAt(ii);
          if ((base != null) && (base.length > 0) && (base === "A" || base === "G" || base === "U" || base === "C")) {
            innerHTML += 'class="' + base + '-base"></span>';
          } else {
            innerHTML += 'class="N-base"></span>';
          }
        } else if (shape_value === null || shape_value[0] === "FAILED") {
          innerHTML += 'class="N-base"></span>';
        } else {
          if (parseInt(shape_value[0], 10) - 1 > ii || ii >= shape_value.length + parseInt(shape_value[0], 10) - 1) {
            innerHTML += 'class="N-base"></span>';
          } else {
            v = parseFloat(shape_value[jj]);
            t = parseFloat(shape_threshold);
            if (v <= t) {
              innerHTML += 'class="U-base"></span>';
            } else {
              innerHTML += 'class="A-base"></span>';
            }
            jj += 1;
          }
        }
        innerSTYLE += '#' + canvas_id + '-base-' + ii + ' { width: ' + Math.ceil(node_r) + 'px; height:' + Math.ceil(node_r) + 'px; left:' + x_array[ii] + 'px; top:' + y_array[ii] + 'px; background-size:' + Math.floor(node_r) + 'px }\n';
      }
      this.div.html(innerHTML);
      this.add_bases_style(innerSTYLE, canvas_id);
      this.layout_draggable();
      this.reset_canvas_width(this.width);
      this.reset_canvas_height(this.height);
      return this.reset_canvas_parent_height(this.height);
    };

    RNALayout.prototype.zoom_in = function() {
      return this.animate_bases("zoom_in");
    };

    RNALayout.prototype.zoom_out = function() {
      return this.animate_bases("zoom_out");
    };

    return RNALayout;

  })();

}).call(this);
