// Generated by CoffeeScript 1.6.3
(function() {
  var __hasProp = {}.hasOwnProperty;

  this.Roadmap = (function() {
    function Roadmap() {}

    Roadmap.roadmap_nodes_ = new Object();

    Roadmap.prototype.set_nodes = function(achievements, ignore, ach_type) {
      var ach_key, ach_prereq, ach_types, ach_val, former_state, ii, jj, _i, _j, _ref, _ref1, _ref2, _ref3, _ref4, _results;
      if (ignore == null) {
        ignore = true;
      }
      if (ach_type == null) {
        ach_type = "";
      }
      ach_types = [];
      if (ach_type.indexOf("side-quests") > -1) {
        ach_types.push("ten_tools");
        ach_types.push("side_quest");
      } else if (ach_type.indexOf("legacy") > -1) {
        ach_types.push("legacy");
      } else {
        ach_types.push("ten_tools");
      }
      this.roadmap_nodes_ = [];
      for (ii = _i = 0, _ref = achievements.length - 1; _i <= _ref; ii = _i += 1) {
        if (achievements[ii]['key'] !== "founding" && achievements[ii]['key'] !== "beta_tester" && achievements[ii]['key'] !== "eternacon2015") {
          if (ach_types.indexOf("legacy") < 0) {
            for (jj = _j = 0, _ref1 = ach_types.length - 1; _j <= _ref1; jj = _j += 1) {
              if (achievements[ii]['key'].indexOf(ach_types[jj]) > -1) {
                this.roadmap_nodes_.push(Utils.clone_object(achievements[ii]));
                break;
              }
            }
          } else {
            this.roadmap_nodes_.push(Utils.clone_object(achievements[ii]));
          }
        }
      }
      _ref2 = this.roadmap_nodes_;
      for (ach_key in _ref2) {
        if (!__hasProp.call(_ref2, ach_key)) continue;
        ach_val = _ref2[ach_key];
        ach_val['node_key'] = ach_val['key'] + (ach_val['level'] != null ? ach_val['level'] : "");
        ach_val['width'] = 245;
        ach_val['height'] = 300;
        ach_val['state'] = "inactive";
        if (ach_val['current_level'] >= ach_val['level']) {
          if (ach_val['key'].indexOf("side_quest") > -1 && ach_val['level'] >= ach_val['maxlevel']) {
            ach_val['state'] = "active";
            ach_val['to_next'] = 1.0;
          } else {
            ach_val['state'] = "cleared";
          }
        } else if (ach_val['level'] === 1) {
          if (Application.GLOBAL_THEME_PARAMETERS['is_lab_member'] === true) {
            if (ach_val['key'].indexOf("side_quest") > -1) {
              ach_val['state'] = "active";
            }
          }
        }
        ach_val['progress'] = Math.floor(parseFloat(ach_val['to_next']) * 100);
        if (ach_val['level'] > 1) {
          ach_val['prereq'] = ach_val['key'] + (ach_val['level'] - 1);
        }
      }
      _ref3 = this.roadmap_nodes_;
      for (ach_key in _ref3) {
        if (!__hasProp.call(_ref3, ach_key)) continue;
        ach_val = _ref3[ach_key];
        former_state = ach_val['state'];
        if (former_state === "cleared" || former_state === "active") {
          ach_prereq = this.get_node(ach_val['prereq']);
          if (Application.GLOBAL_THEME_PARAMETERS['is_lab_member'] !== true) {
            if (ach_prereq != null) {
              if (ach_prereq['state'] !== "cleared") {
                ach_val['state'] = "inactive";
              }
            }
          }
          continue;
        }
        if (ach_val['prereq'] != null) {
          ach_prereq = this.get_node(ach_val['prereq']);
          if (!(ach_prereq != null)) {
            Utils.display_error("Can't find " + ach_val['prereq']);
          } else {
            if (ach_prereq['state'] === "cleared") {
              ach_val['state'] = "active";
            }
          }
        } else {
          if (ach_val['node_key'] !== "founding1") {
            ach_val['state'] = "active";
          }
        }
      }
      _ref4 = this.roadmap_nodes_;
      _results = [];
      for (ach_key in _ref4) {
        if (!__hasProp.call(_ref4, ach_key)) continue;
        ach_val = _ref4[ach_key];
        ach_val['link'] = this.get_link_from_key(ach_val['key']);
        _results.push(ach_val['image_link'] = this.get_image_link_from_key(ach_val['key']));
      }
      return _results;
    };

    Roadmap.prototype.get_nodes = function() {
      return this.roadmap_nodes_;
    };

    Roadmap.prototype.get_node = function(key) {
      var ii, _i, _ref;
      for (ii = _i = 0, _ref = this.roadmap_nodes_.length - 1; _i <= _ref; ii = _i += 1) {
        if (this.roadmap_nodes_[ii].node_key === key) {
          return this.roadmap_nodes_[ii];
        }
      }
      return null;
    };

    Roadmap.prototype.get_active_node = function(key) {
      var ii, _i, _ref;
      for (ii = _i = 0, _ref = this.roadmap_nodes_.length - 1; _i <= _ref; ii = _i += 1) {
        if (this.roadmap_nodes_[ii].key === key && this.roadmap_nodes_[ii].state === "active") {
          return this.roadmap_nodes_[ii];
        }
      }
      return null;
    };

    Roadmap.prototype.get_current_puzzle = function(key) {
      var node;
      node = this.get_active_node(key);
      if ((node != null) && (node.current_puzzle != null)) {
        return node.current_puzzle;
      }
      return null;
    };

    Roadmap.prototype.get_link_from_key = function(key) {
      var current_puzzle, user_puzzle;
      if (key === "register") {
        return "/web/register/";
      } else if (key === "tutorial") {
        return "/web/tutorials/";
      } else if (key === "switch_tutorial") {
        return "/web/tutorials/";
      } else if (key === "puzzle_solver") {
        return "/web/challenges/";
      } else if (key === "lab") {
        return "/web/challenges/";
      } else if (key === "comments") {
        return "/web/news/";
      } else if (key === "profile_desc") {
        if (Application.CURRENT_USER) {
          return "/web/player/" + Application.CURRENT_USER['uid'] + "/";
        } else {
          return "/web/register/";
        }
      } else if (key === "follower") {
        return "/web/players/?sort=synthesizes";
      } else if (key === "leader") {
        return "/web/players/";
      } else if (key === "vote") {
        return "/web/labs/";
      } else if (key === "synthesizer") {
        return "/web/labs/";
      } else if (key === "lab_winner") {
        return "/web/labs/";
      } else if (key === "top_player") {
        return "/web/challenges/";
      } else if (key === "puzzle_architect") {
        return "/web/playerpuzzles/";
      } else if (key === "millionaire") {
        return "/web/challenges/";
      } else if (key === "nova") {
        return "http://www.pbs.org/wgbh/nova/labs/lab/rna/";
      } else if (key === "eternacon2015") {
        return "https://sites.google.com/site/eternacon2015/";
      } else if (key === "eterna100") {
        return "/web/blog/6136054/";
      } else if (key === "ten_tools") {
        if (Application.CURRENT_USER) {
          current_puzzle = this.get_current_puzzle(key);
          if (current_puzzle != null) {
            return "/game/puzzle/" + current_puzzle + "/";
          } else {
            return "/web/progression/?size=10";
          }
        } else {
          return "/web/register/";
        }
      } else if (key === "side_quest_just_for_fun") {
        if (Application.CURRENT_USER) {
          current_puzzle = this.get_current_puzzle(key);
          if (current_puzzle != null) {
            return "/web/puzzle/" + current_puzzle + "/";
          } else {
            return "/web/playerpuzzles/?size=24&search=Fun&sort=date";
          }
        } else {
          return "/web/register/";
        }
      } else if (key === "side_quest_nova_videos") {
        return "http://www.pbs.org/wgbh/nova/labs/lab/rna/";
      } else if (key === "side_quest_challenge_puzzles") {
        return "/web/challenges/?size=50&notcleared=true&sort=solved";
      } else if (key === "side_quest_puzzle_of_the_day") {
        return "/web/playerpuzzles/?size=1&search:SPPuzzleOfTheDay&notcleared=true&sort=date";
      } else if (key === "side_quest_eterna100") {
        return "/web/playerpuzzles/?size=50&search=:Eterna100&notcleared=true&sort=solved";
      } else if (key === "side_quest_best_lab_practices") {
        if (Application.CURRENT_USER) {
          current_puzzle = this.get_current_puzzle(key);
          if (current_puzzle != null) {
            return "/web/puzzle/" + current_puzzle + "/";
          } else {
            return "/web/playerpuzzles/?skip=72&search=%5BLab%20Tutorial%5D&sort=date";
          }
        } else {
          return "/web/register/";
        }
      } else if (key === "side_quest_switch_puzzles") {
        if (Application.CURRENT_USER) {
          current_puzzle = this.get_current_puzzle(key);
          if (current_puzzle != null) {
            return "/web/puzzle/" + current_puzzle + "/";
          } else {
            return "/web/playerpuzzles/?size=24&search=switch&switch=checked&sort=date";
          }
        } else {
          return "/web/register/";
        }
      } else if (key === "side_quest_create_a_puzzle") {
        return "/game/puzzlemaker/";
      } else if (key === "side_quest_create_a_tutorial") {
        if (Application.CURRENT_USER) {
          user_puzzle = this.get_current_puzzle(key);
          if (user_puzzle != null) {
            return "/game/tuttest/?pid=" + user_puzzle;
          } else {
            return "/game/puzzlemaker/";
          }
        } else {
          return "/web/tutscripts/";
        }
      } else if (key === "side_quest_create_a_script") {
        return "/web/script/create/";
      }
      return "";
    };

    Roadmap.prototype.get_image_link_from_key = function(key) {
      if (key === "side_quest_just_for_fun") {
        if (Application.CURRENT_USER) {
          return "/web/playerpuzzles/?size=24&search=Fun&sort=date";
        } else {
          return "/web/register/";
        }
      } else if (key === "side_quest_nova_videos") {
        return "http://www.pbs.org/wgbh/nova/labs/lab/rna/";
      } else if (key === "side_quest_challenge_puzzles") {
        return "/web/challenges/?size=50&notcleared=true&sort=solved";
      } else if (key === "side_quest_puzzle_of_the_day") {
        return "/web/playerpuzzles/?size=1&search:SPPuzzleOfTheDay&notcleared=true&sort=date";
      } else if (key === "side_quest_eterna100") {
        return "/web/playerpuzzles/?size=50&search=:Eterna100&notcleared=true&sort=solved";
      } else if (key === "side_quest_best_lab_practices") {
        if (Application.CURRENT_USER) {
          return "/web/playerpuzzles/?skip=72&search=%5BLab%20Tutorial%5D&sort=date";
        } else {
          return "/web/register/";
        }
      } else if (key === "side_quest_switch_puzzles") {
        if (Application.CURRENT_USER) {
          return "/web/playerpuzzles/?size=24&search=switch&switch=checked&sort=date";
        } else {
          return "/web/register/";
        }
      } else if (key === "side_quest_create_a_puzzle") {
        return "/game/puzzlemaker/";
      } else if (key === "side_quest_create_a_tutorial") {
        return "/web/tutscripts/";
      } else if (key === "side_quest_create_a_script") {
        return "/web/script/";
      }
      return "";
    };

    return Roadmap;

  })();

}).call(this);
