// Generated by CoffeeScript 1.6.3
(function() {
  this.Pervasives = {
    _get_lists: function() {
      return ["clear", "out", "outln", "draw", "zoomin", "zoomout"];
    },
    _set: function(key, func, w) {
      return w[key] = func;
    },
    init: function(w) {
      var ii, lists, _i, _ref, _results;
      lists = this._get_lists();
      _results = [];
      for (ii = _i = 0, _ref = lists.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; ii = 0 <= _ref ? ++_i : --_i) {
        _results.push(this._set(lists[ii], this[lists[ii]], w));
      }
      return _results;
    },
    ignore: function() {
      var ii, lambda, lists, w, _i, _ref, _results;
      lambda = function() {
        return true;
      };
      if (window) {
        w = window;
      } else {
        return;
      }
      lists = this._get_lists();
      _results = [];
      for (ii = _i = 0, _ref = lists.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; ii = 0 <= _ref ? ++_i : --_i) {
        _results.push(this._set(lists[ii], lambda, w));
      }
      return _results;
    },
    _pre_out: function(result, pipe) {
      var func, ii, _i, _ref;
      for (ii = _i = 0, _ref = pipe.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; ii = 0 <= _ref ? ++_i : --_i) {
        func = pipe[ii];
        result = func(result);
      }
      return result;
    },
    _coloring: function(text) {
      var _set_color;
      _set_color = function(_text, word, color) {
        var _regexp;
        _regexp = "/" + word + "/gi";
        _text = _text.replace(_regexp, "<span style='color:" + color + ";'>" + word + "</span>");
        return _text;
      };
      text = _set_color(text, "PASS", "green");
      text = _set_color(text, "FAIL", "red");
      text = _set_color(text, "true", "blue");
      return text = _set_color(text, "false", "red");
    },
    out: function(result) {
      var $result, value;
      $result = $('#result');
      value = $result.get(0).innerHTML;
      return $result.html(value + result);
    },
    outln: function(result) {
      this.out(result);
      return this.out("<br>");
    },
    clear: function() {
      var $result;
      $result = $('#result');
      return $result.html("");
    },
    draw: function(secstruct, sequence, width, height, div, background_color) {
      var divstr, _div_id;
      if (!(this._div_container != null)) {
        this._div_container = new Array;
      }
      if (div != null) {
        div.change_structure_to(secstruct);
        div.change_sequence_to(sequence);
      } else {
        _div_id = this._div_container.length;
        divstr = "<div id='_draw" + _div_id + "'></div>";
        this._div_container.push(divstr);
        Pervasives.outln(divstr);
        div = EternaUtils.draw_secstructure(secstruct, $('#_draw' + _div_id), sequence, null, null);
      }
      return div;
    },
    zoomin: function(div) {
      return div.zoom_in();
    },
    zoomout: function(div) {
      return div.zoom_out();
    }
  };

  this.ScriptInterface = {
    "eval": function(testsets, cb) {
      return Script.evaluate_testsets(testsets, cb);
    },
    set_input_val: function(input_array, index, value) {
      if (input_array.length > index) {
        input_array[index]['val'] = value;
      }
      return input_array;
    },
    codify_input: function(input_array) {
      var i, input, param, _i, _ref;
      param = "";
      if (input_array.length > 0) {
        for (i = _i = 0, _ref = input_array.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
          input = input_array[i];
          if (input['value']) {
            param += "var " + input['value'] + "='" + input['val'] + "';";
          }
        }
      }
      return param;
    },
    set_library: function(Library) {
      return this.Lib = Library;
    },
    set_pervasives: function(p) {
      return this.Pervasives = p;
    },
    set_rna: function(RNA) {
      return this.RNA = RNA;
    },
    set_rnaelement: function(RNAElement) {
      return this.RNAElement = RNAElement;
    },
    set_rnaexception: function(RNAException) {
      return this.RNAException = RNAException;
    },
    evaluate_init: function() {
      if (Library !== null && !(this.Lib != null)) {
        this.Lib = Library;
      }
      if (!(this.RNA != null)) {
        this.RNA = RNA;
      }
      if (!(this.RNAElement != null)) {
        this.RNAElement = RNAElement;
      }
      if (!(this.RNAException != null)) {
        this.RNAException = RNAException;
      }
      if (!(this.Pervasives != null)) {
        this.Pervasives = Pervasives;
      }
      if ((typeof window !== "undefined" && window !== null) && !(window.out != null)) {
        return this.Pervasives.init(window);
      }
    },
    evaluate: function(source) {
      var Error, Lib, Library, RNA, RNAElement, RNAException, code, ret, _global_timer;
      this.evaluate_init();
      ret = {};
      try {
        Library = this.Lib;
        Lib = new Library();
        RNA = this.RNA;
        RNAElement = this.RNAElement;
        RNAException = this.RNAException;
        _global_timer = new Date();
        code = '(function(){' + source + '})()';
        ret['cause'] = eval(code);
        ret['result'] = true;
        ret['eval_time'] = (new Date()).getTime() - _global_timer.getTime();
        return ret;
      } catch (_error) {
        Error = _error;
        ret['cause'] = Error.message;
        ret['result'] = false;
        ret['eval_time'] = (new Date()).getTime() - _global_timer.getTime();
        return ret;
      }
    },
    evaluate_flash: function(nid, sequences, constraints) {
      var params,
        _this = this;
      params = {
        'sequences': sequences,
        'constraints': constraints
      };
      return ScriptInterface.evaluate_script_with_nid(nid, params, function(result) {
        var maingame;
        if (maingame = document.getElementById('maingame')) {
          return maingame.end(result);
        }
      });
    },
    evaluate_script_with_nid: function(nid, params, callback, _sync) {
      var _this = this;
      return Script.get_script(nid, function(data) {
        var coded_input, ii, input, input_array, maingame, parameter_name, result, script, source, timeout, _i, _ref;
        if (data['script'].length === 0) {
          alert("please check nid");
          return;
        }
        script = data['script'][0];
        input_array = JSON.parse(script['input']);
        if (input_array.length > 0 && (params != null)) {
          for (ii = _i = 0, _ref = input_array.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; ii = 0 <= _ref ? ++_i : --_i) {
            input = input_array[ii];
            parameter_name = input['value'];
            if (params[parameter_name]) {
              _this.set_input_val(input_array, ii, params[parameter_name]);
            }
          }
          coded_input = _this.codify_input(input_array);
        } else {
          coded_input = "";
        }
        if ((params != null) && (params.timeout != null)) {
          timeout = params.timeout;
        } else {
          timeout = 10;
        }
        source = _this.insert_timeout(script['source'], timeout);
        if (_this.Pervasives != null) {
          _this.Pervasives.ignore();
        }
        result = _this.evaluate(coded_input + source);
        if (maingame = document.getElementById("maingame")) {
          if (maingame['end_' + nid]) {
            maingame['end_' + nid](result);
          } else if (maingame['end']) {
            maingame.end(result);
          }
        }
        if (callback) {
          return callback(result);
        }
      }, (_sync != null) ? _sync : false);
    },
    evaluate_puzzle_solving: function(script, secstruct, timeout) {
      var input, input_array, result, source;
      input_array = JSON.parse(script['input']);
      input_array = this.set_input_val(input_array, 0, secstruct);
      input = this.codify_input(input_array);
      if (!(timeout != null)) {
        timeout = 10;
      }
      source = this.insert_timeout(script['source'], timeout);
      if (this.Pervasives != null) {
        this.Pervasives.ignore();
      }
      result = this.evaluate(input + source);
      return result;
    },
    evaluate_solution_scoring: function(script, secstruct, sequence) {
      var input, input_array, result, source;
      input_array = JSON.parse(script['input']);
      input_array = this.set_input_val(input_array, 0, secstruct);
      input_array = this.set_input_val(input_array, 1, sequence);
      input = this.codify_input(input_array);
      source = this.insert_timeout(script['source'], 10);
      if (this.Pervasives != null) {
        this.Pervasives.ignore();
      }
      result = this.evaluate(input + source);
      return result;
    },
    insert_timeout_depcrecated: function(source, timeout) {
      var chunk, code, index, inserted_code, nextRegexp, nextline, regexp;
      inserted_code = "if((new Date()).getTime() - global_timer.getTime() > " + timeout * 1000 + ") {outln(\"" + timeout + "sec timeout\");return 'timeout';};";
      regexp = /while\s*\([^\)]*\)\s*\{?|for\s*\([^\)]*\)\s*\{?/;
      code = "var global_timer = new Date(); ";
      while (source.search(regexp) !== -1) {
        chunk = source.match(regexp)[0];
        index = source.indexOf(chunk) + chunk.length;
        if ((chunk.charAt(chunk.length - 1)) !== "{") {
          nextRegexp = /.*[\(.*\)|[^;]|\n]*;{0,1}/;
          nextline = source.substring(index);
          nextline = nextline.match(nextRegexp)[0];
          code += source.substring(0, index) + "{" + inserted_code + nextline + "}";
          index += nextline.length;
        } else {
          code += source.substring(0, index) + inserted_code;
        }
        if (source.length > index) {
          source = source.substring(index);
        } else {
          source = "";
          break;
        }
      }
      code += source;
      return code;
    },
    balance: function(open, close, start, code) {
      var ii, isStart, stack, _i, _ref;
      stack = new Array();
      isStart = false;
      for (ii = _i = start, _ref = code.length - 1; start <= _ref ? _i <= _ref : _i >= _ref; ii = start <= _ref ? ++_i : --_i) {
        if (code[ii] === open) {
          if (!isStart) {
            isStart = true;
          }
          stack.push(ii);
        } else if (code[ii] === close) {
          stack.pop();
        }
        if (isStart && !stack.length) {
          return ii;
        }
      }
      return -1;
    },
    balance_search: function(target, start, code) {
      var ii, stack, _i, _ref;
      stack = new Array();
      for (ii = _i = start, _ref = code.length - 1; start <= _ref ? _i <= _ref : _i >= _ref; ii = start <= _ref ? ++_i : --_i) {
        if (code[ii] === "(" || code[ii] === "{") {
          stack.push(ii);
        } else if (code[ii] === ")" || code[ii] === "}") {
          stack.pop();
        }
        if (stack.length === 0 && code[ii] === target) {
          return ii;
        }
      }
      return ii;
    },
    insert_timeout: function(source, timeout) {
      var chunk, code, ii, index, inserted_code, jj, nextline, regexp, _i, _ref;
      inserted_code = "if((new Date()).getTime() - global_timer.getTime() > " + timeout * 1000 + ") {outln(\"" + timeout + "sec timeout\");return 'timeout';};";
      regexp = /(while\s*\()|(for\s*\()/m;
      code = "var global_timer = new Date(); ";
      while (source.search(regexp) !== -1) {
        chunk = source.match(regexp)[0];
        index = this.balance("(", ")", source.indexOf(chunk), source) + 1;
        for (ii = _i = index, _ref = source.length - 1; index <= _ref ? _i <= _ref : _i >= _ref; ii = index <= _ref ? ++_i : --_i) {
          if (source[ii] !== " " && source[ii] !== "\n") {
            break;
          }
        }
        index = ii;
        if ((source.charAt(index)) !== "{") {
          jj = this.balance_search(";", index, source);
          nextline = source.substring(index, jj + 1);
          code += source.substring(0, index) + "{" + inserted_code + nextline + "}";
          index += nextline.length;
        } else {
          code += source.substring(0, index + 1) + inserted_code;
        }
        if (source.length > index) {
          source = source.substring(index + 1);
        } else {
          source = "";
          break;
        }
      }
      code += source;
      return code;
    }
  };

  this.LibLoader = (function() {
    function LibLoader() {
      this.url = "/EteRNA-Script-Interface/Eterna/library/";
      this.states = new Array;
      this._use = true;
    }

    LibLoader.prototype.setUse = function(b) {
      return this._use = b;
    };

    LibLoader.prototype.getUse = function() {
      return this._use;
    };

    LibLoader.prototype.setDefaultUrl = function(url) {
      return this.url = url;
    };

    LibLoader.prototype.getDefaultUrl = function() {
      return this.url;
    };

    LibLoader.prototype.check = function(libs) {
      var ii, _i, _ref;
      for (ii = _i = 0, _ref = libs.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; ii = 0 <= _ref ? ++_i : --_i) {
        if (libs['name'] != null) {
          return false;
        }
      }
      return true;
    };

    LibLoader.prototype.getName = function(lib) {
      if (lib) {
        return lib['name'];
      }
    };

    LibLoader.prototype.getUrl = function(lib) {
      if (lib) {
        return lib['url'];
      }
    };

    LibLoader.prototype.remove = function(code) {
      var chunk, regexp, revised, start;
      regexp = /(\/\*[\w\'\s\r\n\*]*\*\/)|(\/\/[\w\s\']*)|(\".*\")|(\'.*\')/;
      revised = code;
      while (revised.search(regexp) !== -1) {
        chunk = revised.match(regexp)[0];
        start = revised.indexOf(chunk);
        revised = revised.substring(0, start) + revised.substring(start + chunk.length);
      }
      return revised;
    };

    LibLoader.prototype.parse = function(code, cb) {
      var ii, lib, libs, need, rcode, _i, _ref;
      libs = [
        {
          name: "LibVrna185"
        }, {
          name: "LibVrna211"
        }
      ];
      need = new Array;
      rcode = this.remove(code);
      for (ii = _i = 0, _ref = libs.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; ii = 0 <= _ref ? ++_i : --_i) {
        lib = libs[ii];
        if (rcode.indexOf(this.getName(lib)) !== -1) {
          need.push(lib);
        }
      }
      return cb(need);
    };

    LibLoader.prototype.dynamicLoad = function(libs, before_cb, after_cb, final_cb) {
      var ii, lib, s, _i, _isFinish, _name, _ref, _results, _url,
        _this = this;
      if (!libs.length || !this.getUse()) {
        final_cb();
        return;
      }
      _isFinish = function(num) {
        return _this.getStates().length >= num;
      };
      _results = [];
      for (ii = _i = 0, _ref = libs.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; ii = 0 <= _ref ? ++_i : --_i) {
        lib = libs[ii];
        if (lib) {
          _name = this.getName(lib);
          _url = this.getUrl(lib);
          before_cb(lib);
          if (s = this.alreadyLoad(_name, "js", _url)) {
            after_cb(s);
            if (_isFinish(libs.length) && ii === libs.length - 1) {
              _results.push(final_cb(this.getStates()));
            } else {
              _results.push(void 0);
            }
          } else {
            _results.push((function(_name, _url) {
              return _this.load(_name, "js", _url, function(data, textStatus, jqxhr) {
                var state;
                state = _this.makeState(_name, _url, textStatus);
                _this.setState(state);
                after_cb(state);
                if (_isFinish(libs.length)) {
                  final_cb(_this.getStates());
                }
              });
            })(_name, _url));
          }
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };

    LibLoader.prototype.load = function(name, ext, url, cb) {
      var target,
        _this = this;
      if (url) {
        target = url + name + "." + ext;
      } else {
        target = this.liburl(name);
      }
      return $.getScript(target).done(function(script, status) {
        if (cb) {
          return cb(script, status, {});
        }
      }).fail(function(jqxhr, settings, exception) {
        return alert("library load fail");
      });
    };

    LibLoader.prototype.alreadyLoad = function(name, ext, url) {
      var ii, state, states, _i, _ref;
      if (states = this.getStates()) {
        for (ii = _i = 0, _ref = states.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; ii = 0 <= _ref ? ++_i : --_i) {
          state = states[ii];
          if (state && this.getNameFromState(state) && this.getNameFromState(state) === name) {
            return state;
          }
        }
      }
      return null;
    };

    LibLoader.prototype.getStates = function() {
      return this.states;
    };

    LibLoader.prototype.setState = function(state) {
      if (this.getStates()) {
        return this.getStates().push(state);
      } else {
        this.states = new Array;
        return this.states.push(state);
      }
    };

    LibLoader.prototype.resetStates = function() {
      return this.states = new Array;
    };

    LibLoader.prototype.makeState = function(name, url, ok) {
      return {
        "name": name,
        "url": url,
        "ok": ok
      };
    };

    LibLoader.prototype.getNameFromState = function(state) {
      return state['name'];
    };

    LibLoader.prototype.getUrlFromState = function(state) {
      return state['url'];
    };

    LibLoader.prototype.getSuccessFromState = function(state) {
      return state['ok'];
    };

    LibLoader.prototype.liburl = function(name) {
      return this.url + name + ".js";
    };

    return LibLoader;

  })();

}).call(this);
