// Generated by CoffeeScript 1.6.3
(function() {
  var __hasProp = {}.hasOwnProperty;

  this.Overlay = {
    VIEW_CURTAIN_Z: 4010,
    overlay_simple_: false,
    $overlay_panelholder_: null,
    $overlay_: null,
    $overlay_close_layer_: null,
    $overlay_under_: null,
    $content_: null,
    last_scroll_: null,
    $L_slots_: null,
    close_disabled_: false,
    showing_: false,
    return_uri_: null,
    initialize: function($body, $content) {
      var $overlay_under, builder, overlay_block,
        _this = this;
      this.overlay_simple_ = Utils.is_mobile();
      if (!($content.exists())) {
        this.overlay_simple_ = false;
      }
      overlay_block = BlockManager.get_block("overlay");
      builder = overlay_block.build($body, null, false);
      this.$overlay_panelholder_ = builder.get_element('overlay-panelholder');
      this.$overlay_close_layer_ = builder.get_element('overlay-close-layer');
      this.$overlay_ = builder.get_element('overlay');
      if (this.overlay_simple_) {
        this.$content_ = $content;
        this.$overlay_.css("position", "relative");
        $overlay_under = builder.get_element("overlay-under");
        if ($overlay_under.exists()) {
          $overlay_under.css("display", "none");
        }
      } else {
        this.$overlay_.css("overflow-y", "scroll");
        this.$overlay_under_ = builder.get_element('overlay-under');
      }
      this.$overlay_close_layer_.click(function() {
        if (_this.close_disabled_) {
          return;
        }
        _this.clear();
        return _this.hide();
      });
      $(document).keyup(function(e) {
        if (e.keyCode === KeyCode.KEYCODE_ESCAPE) {
          if (!_this.showing_) {
            return;
          }
          if (_this.close_disabled_) {
            return;
          }
          Overlay.clear();
          return Overlay.hide();
        }
      });
      this.$overlay_.css("display", "none");
      if (!this.overlay_simple_) {
        this.$overlay_under_.css("display", "none");
      }
      return this.$L_slots_ = new Object();
    },
    show: function() {
      if (this.overlay_simple_) {
        this.last_scroll_ = $(window).scrollTop();
        this.$content_.css("display", "none");
      } else {
        this.$overlay_under_.css("display", "block");
        $("body").css("overflow", "hidden");
      }
      this.$overlay_.css("display", "block");
      this.showing_ = true;
      if (this.close_disabled_) {
        return this.$overlay_close_layer_.css("display", "none");
      } else {
        return this.$overlay_close_layer_.css("display", "block");
      }
    },
    set_return_uri: function(uri) {
      return this.return_uri_ = uri;
    },
    clear: function() {
      var $panel, key, _ref, _results;
      this.close_disabled_ = false;
      _ref = this.$L_slots_;
      _results = [];
      for (key in _ref) {
        if (!__hasProp.call(_ref, key)) continue;
        $panel = _ref[key];
        _results.push($panel.css("display", "none"));
      }
      return _results;
    },
    hide: function() {
      var return_uri;
      if (this.return_uri_ != null) {
        return_uri = this.return_uri_;
        this.return_uri_ = null;
        Page.transit(return_uri, false);
        return;
      }
      if (this.overlay_simple_) {
        this.$content_.css("display", "block");
      } else {
        this.$overlay_under_.css("display", "none");
        $("body").css("overflow", "auto");
      }
      this.$overlay_.css("display", "none");
      this.showing_ = false;
      if ((this.last_scroll_ != null) && this.overlay_simple_) {
        return $(window).scrollTop(this.last_scroll_);
      }
    },
    get_slot: function(key) {
      var $panel;
      if (this.$L_slots_[key]) {
        return this.$L_slots_[key];
      }
      $panel = $("<div style='display:none'>");
      this.$L_slots_[key] = $panel;
      this.$overlay_panelholder_.prepend($panel);
      return $panel;
    },
    set_loading: function() {
      var $loading_panel;
      this.clear();
      this.$overlay_close_layer_.css("display", "none");
      if (this.is_overlay_content_there("loading")) {
        $loading_panel = this.get_slot("loading");
        $loading_panel.css("display", "block");
      } else {
        $loading_panel = this.get_slot('loading', "");
        ThemeCompiler.compile_block(BlockManager.get_block("overlay-loading"), null, $loading_panel);
        $loading_panel.css("display", "block");
      }
      return this.close_disabled_ = true;
    },
    set_yesno: function(text, yes_cb, no_cb) {
      var $no, $yes, $yesno_panel;
      this.clear();
      $yesno_panel = this.get_slot('yesno');
      $yesno_panel.html("");
      $yesno_panel.css("display", "block");
      ThemeCompiler.compile_block(Blocks("overlay-yesno"), {
        "text": text
      }, $yesno_panel);
      $yes = $yesno_panel.find("#yes");
      $no = $yesno_panel.find("#no");
      if ($yes.exists()) {
        $yes.click(yes_cb);
      }
      if ($no.exists()) {
        return $no.click(no_cb);
      }
    },
    set_message: function(text) {
      var $message_panel, $ok,
        _this = this;
      this.clear();
      $message_panel = this.get_slot('message-box');
      $message_panel.html("");
      $message_panel.css("display", "block");
      ThemeCompiler.compile_block(Blocks("overlay-message"), {
        "text": text
      }, $message_panel);
      $ok = $message_panel.find("#ok");
      if ($ok.exists()) {
        return $ok.click(function() {
          return Overlay.hide();
        });
      }
    },
    is_overlay_content_there: function(key) {
      return this.$L_slots_[key] != null;
    },
    return_overlay_content: function(key) {
      if (this.$L_slots_[key] != null) {
        return this.$L_slots_[key];
      } else {
        return null;
      }
    },
    load_overlay_content: function(key) {
      var $panel;
      if (!this.is_overlay_content_there(key)) {
        Utils.dipslay_error("Trying to setup unknown overlay " + key);
        return;
      }
      this.clear();
      this.$overlay_close_layer_.css("display", "block");
      $panel = Overlay.get_slot(key);
      return $panel.css("display", "block");
    }
  };

}).call(this);
