// Generated by CoffeeScript 1.6.3
(function() {
  var BINS, H_MARGIN, bin_height, fitting_score, is_fittable, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BINS = [
    [
      {
        pos: [0, 0],
        size: [1, 0.4068]
      }
    ], [
      {
        pos: [0, 0],
        size: [0.4915, 0.4068]
      }, {
        pos: [0.5084, 0],
        size: [0.4915, 0.4068]
      }
    ], [
      {
        pos: [0, 0],
        size: [0.3220, 0.4068]
      }, {
        pos: [0.3390, 0],
        size: [0.3220, 0.4068]
      }, {
        pos: [0.6780, 0],
        size: [0.3220, 0.4068]
      }
    ], [
      {
        pos: [0, 0],
        size: [0.2373, 0.1949]
      }, {
        pos: [0, 0.2119],
        size: [0.2373, 0.1949]
      }, {
        pos: [0.2542, 0],
        size: [0.4915, 0.4068]
      }, {
        pos: [0.7627, 0],
        size: [0.2373, 0.4068]
      }
    ], [
      {
        pos: [0, 0],
        size: [0.4915, 0.1949]
      }, {
        pos: [0, 0.2119],
        size: [0.2373, 0.1949]
      }, {
        pos: [0.2542, 0.2119],
        size: [0.2373, 0.1949]
      }, {
        pos: [0.5084, 0],
        size: [0.2373, 0.4068]
      }, {
        pos: [0.7627, 0],
        size: [0.2373, 0.4068]
      }
    ]
  ];

  H_MARGIN = 0.0169;

  fitting_score = function(w, h, box, container_width) {
    var aspect_box, aspect_factor, aspect_img, h_scale, scale_factor, w_scale;
    aspect_img = Number(h) / w;
    aspect_box = Number(box.size[1]) / box.size[0];
    aspect_factor = Math.max(aspect_img, aspect_box) / Math.min(aspect_img, aspect_box);
    w_scale = Math.max(Number(w) / (box.size[0] * container_width), 1.0);
    h_scale = Math.max(Number(h) / (box.size[1] * container_width), 1.0);
    scale_factor = Math.min(w_scale, h_scale);
    return aspect_factor * scale_factor;
  };

  is_fittable = function(w, h, box, container_width, index) {
    var aspect_box, aspect_factor, aspect_img, sizetest_failed;
    if (box.owner != null) {
      return false;
    }
    sizetest_failed = false;
    if (box.size[1] * container_width > h || box.size[0] * container_width > w) {
      sizetest_failed = true;
    }
    aspect_img = Number(h) / w;
    aspect_box = Number(box.size[1]) / box.size[0];
    aspect_factor = Math.max(aspect_img, aspect_box) / Math.min(aspect_img, aspect_box);
    if (index < 0.5) {
      return !sizetest_failed;
    } else if (index < 0.75) {
      return !sizetest_failed;
    } else {
      return true;
    }
  };

  bin_height = function(bin, container_width) {
    var box, h, height, _i, _len;
    height = 0;
    for (_i = 0, _len = bin.length; _i < _len; _i++) {
      box = bin[_i];
      if (box.owner != null) {
        h = (box.pos[1] + box.size[1]) * container_width;
        if (h > height) {
          height = h;
        }
      }
    }
    return height;
  };

  this.PackerGallery = (function(_super) {
    __extends(PackerGallery, _super);

    function PackerGallery() {
      _ref = PackerGallery.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    PackerGallery.prototype.layout = function() {
      var $container, block_params, builders;
      $container = this.$container_;
      $container.css("position", "relative");
      $container.html("");
      block_params = this.block_params_;
      this.block_params_ = new Array();
      builders = this.builders_ = new Array();
      this.current_height_ = 0;
      return this.add(block_params);
    };

    PackerGallery.prototype.on_clean = function() {
      return this.current_height_ = 0;
    };

    PackerGallery.prototype.add = function(new_block_params) {
      var $block_container, $container, bb, best_fit_box, best_fit_score, bin, bin_sizes, bins, block, block_params, box, builder, builders, container_width, fit_score, h, height, height_walker, ii, new_blocks_size, param, pass_count, rand_size, size, w, width, _i, _j, _k, _l, _len, _len1, _m, _ref1, _ref2, _ref3;
      $container = this.$container_;
      $container.css("position", "relative");
      width = null;
      if (this.setting_ != null) {
        width = parseInt(this.setting_['width']);
      }
      if (width != null) {
        $container.css("width", width + "px");
      } else {
        $container.css("width", "100%");
      }
      container_width = $container.width();
      bins = [];
      bin_sizes = [];
      size = new_block_params.length;
      while (size > 0) {
        if (size < 6) {
          bins.push(Utils.clone_object(BINS[size - 1]));
          bin_sizes.push(size);
          break;
        }
        rand_size = Math.floor(Math.random() * (BINS.length - 1)) % (BINS.length - 1) + 2;
        bins.push(Utils.clone_object(BINS[rand_size - 1]));
        bin_sizes.push(rand_size);
        size -= rand_size;
      }
      new_blocks_size = new_block_params.length;
      pass_count = 0;
      for (ii = _i = 0, _ref1 = new_block_params.length - 1; _i <= _ref1; ii = _i += 1) {
        param = new_block_params[ii];
        w = param['width'];
        h = param['height'];
        if (!w) {
          w = 0.5 * container_width;
        }
        if (!h) {
          h = 0.4 * container_width;
        }
        best_fit_box = null;
        best_fit_score = -1;
        for (bb = _j = 0, _ref2 = bins.length - 1; _j <= _ref2; bb = _j += 1) {
          bin = bins[bb];
          for (_k = 0, _len = bin.length; _k < _len; _k++) {
            box = bin[_k];
            if (is_fittable(w, h, box, container_width, Number(ii) / (new_blocks_size - 1))) {
              fit_score = fitting_score(w, h, box, container_width);
              if (!(best_fit_box != null) || best_fit_score > fit_score) {
                best_fit_score = fit_score;
                best_fit_box = box;
              }
            }
          }
        }
        if (best_fit_box != null) {
          best_fit_box.owner = ii;
        } else {
          pass_count += 1;
        }
      }
      block_params = this.block_params_;
      builders = this.builders_;
      block = this.block_;
      height_walker = this.current_height_;
      if (!height_walker) {
        height_walker = 0;
      }
      for (bb = _l = 0, _ref3 = bins.length - 1; _l <= _ref3; bb = _l += 1) {
        bin = bins[bb];
        height = bin_height(bin, container_width);
        if (height === 0) {
          continue;
        }
        for (_m = 0, _len1 = bin.length; _m < _len1; _m++) {
          box = bin[_m];
          if (box.owner != null) {
            block_params = new_block_params[box.owner];
            builder = block.add_block($container, block_params);
            $block_container = builder.get_container();
            $block_container.css("position", "absolute");
            $block_container.css("left", box.pos[0] * container_width + "px");
            $block_container.css("top", box.pos[1] * container_width + height_walker + "px");
            $block_container.css("width", box.size[0] * container_width + "px");
            $block_container.css("height", box.size[1] * container_width + "px");
          }
        }
        height_walker += height;
        height_walker += H_MARGIN * container_width;
      }
      this.current_height_ = height_walker;
      return $container.css("height", height_walker + "px");
    };

    return PackerGallery;

  })(Packer);

}).call(this);
