// Generated by CoffeeScript 1.6.3
(function() {
  var _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  this.Packers = function($container, setting, block) {
    var name, packerinput;
    if (!(setting != null)) {
      if (packerinput = $container.attr("packerinput")) {
        setting = ThemeCompiler.get_attr_value(packerinput);
      }
    }
    if (!(setting != null)) {
      setting = {};
    }
    name = null;
    if (setting['type'] != null) {
      name = setting['type'];
    } else {
      if ((setting['min-columns'] != null) || (setting['max-columns'] != null)) {
        name = "cards";
      }
    }
    if ((setting['block-name'] != null) && !(block != null)) {
      block = Blocks(setting['block-name']);
    }
    if (!(block != null)) {
      Utils.display_error("Block name not specified in Packers " + setting['block-name']);
      return null;
    }
    if (name === "cards") {
      return new PackerCards(block, $container, setting);
    } else if (name === "float") {
      return new PackerFloat(block, $container, setting);
    } else {
      return new Packer(block, $container, setting);
    }
  };

  this.Packer = (function() {
    function Packer(block_, $container_, setting_) {
      this.block_ = block_;
      this.$container_ = $container_;
      this.setting_ = setting_;
      this.block_params_ = new Array();
      this.builders_ = new Array();
      this.scroll_cb_ = null;
      this.scroll_buffer_ = 300;
      if (!this.block_) {
        Utils.display_error("NULL block in Packer");
        return;
      }
      if (!this.$container_.exists()) {
        Utils.display_error("NULL container in Packer");
      }
      if (this.on_initialize != null) {
        this.on_initialize();
      }
    }

    Packer.prototype.on_layout = function() {
      var block, block_params, builders, ii, _i, _ref, _results;
      block = this.block_;
      block_params = this.block_params_;
      builders = this.builders_ = new Array();
      _results = [];
      for (ii = _i = 0, _ref = block_params.length - 1; _i <= _ref; ii = _i += 1) {
        _results.push(builders.push(block.add_block($container, block_params[ii])));
      }
      return _results;
    };

    Packer.prototype.layout = function() {
      var $container, builders, classes, ii, _i, _ref, _results;
      $container = this.$container_;
      $container.html("");
      this.on_layout();
      if (this.setting_ && (classes = this.setting_['class'])) {
        if (builders = this.builders_) {
          _results = [];
          for (ii = _i = 0, _ref = builders.length - 1; _i <= _ref; ii = _i += 1) {
            _results.push(builders.get_container().addClass(classes));
          }
          return _results;
        }
      }
    };

    Packer.prototype.on_add = function(new_block_params) {
      var $container, block, block_params, builders, ii, _i, _ref, _results;
      $container = this.$container_;
      block = this.block_;
      block_params = this.block_params_;
      builders = this.builders_;
      _results = [];
      for (ii = _i = 0, _ref = new_block_params.length - 1; _i <= _ref; ii = _i += 1) {
        builders.push(block.add_block($container, new_block_params[ii]));
        _results.push(block_params.push(new_block_params[ii]));
      }
      return _results;
    };

    Packer.prototype.add = function(new_block_params) {
      var builders, classes, ii, _i, _ref, _results;
      this.on_add(new_block_params);
      if (this.setting_ && (classes = this.setting_['class'])) {
        if (builders = this.builders_) {
          _results = [];
          for (ii = _i = 0, _ref = builders.length - 1; _i <= _ref; ii = _i += 1) {
            _results.push(builders[ii].get_container().addClass(classes));
          }
          return _results;
        }
      }
    };

    Packer.prototype.clean = function() {
      this.$container_.html("");
      this.block_params_ = new Array();
      this.builders_ = new Array();
      if (this.on_clean != null) {
        return this.on_clean();
      }
    };

    Packer.prototype.get_builders = function() {
      return this.builders_;
    };

    Packer.prototype.bind_resize = function(cb) {};

    Packer.prototype.get_current_height = function() {
      return this.$container_.offset().top + this.$container_.height();
    };

    Packer.prototype.set_scroll_cb = function(cb, scroll_buffer) {
      var on_scroll,
        _this = this;
      if (scroll_buffer != null) {
        this.scroll_buffer_ = scroll_buffer;
      }
      on_scroll = function() {
        var current_height;
        current_height = _this.get_current_height();
        if ($(window).scrollTop() + $(window).height() > current_height - _this.scroll_buffer_) {
          return _this.scroll_cb_();
        }
      };
      if (!(this.scroll_cb_ != null)) {
        this.$container_.bind_window_event("scroll swipedown", on_scroll);
      }
      if (!(cb != null)) {
        this.$container_.unbind_window_events("scroll swipedown");
      }
      return this.scroll_cb_ = cb;
    };

    Packer.prototype.need_to_load = function() {
      var current_height;
      current_height = this.get_current_height();
      return $(window).scrollTop() + $(window).height() > current_height - this.scroll_buffer_;
    };

    return Packer;

  })();

  this.PackerFloat = (function(_super) {
    __extends(PackerFloat, _super);

    function PackerFloat() {
      _ref = PackerFloat.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    PackerFloat.prototype.on_layout = function() {
      var block, block_params, builder, builders, ii, _i, _ref1, _results;
      block = this.block_;
      block_params = this.block_params_;
      builders = this.builders_ = new Array();
      _results = [];
      for (ii = _i = 0, _ref1 = block_params.length - 1; _i <= _ref1; ii = _i += 1) {
        builder = block.add_block($container, block_params[ii]);
        builders.push(builder);
        _results.push(builder.get_container().css("float", "left"));
      }
      return _results;
    };

    PackerFloat.prototype.on_add = function(new_block_params) {
      var $container, block, block_params, builder, builders, ii, _i, _ref1, _results;
      $container = this.$container_;
      block = this.block_;
      block_params = this.block_params_;
      builders = this.builders_;
      _results = [];
      for (ii = _i = 0, _ref1 = new_block_params.length - 1; _i <= _ref1; ii = _i += 1) {
        builder = block.add_block($container, new_block_params[ii]);
        builders.push(builder);
        builder.get_container().css("float", "left");
        _results.push(block_params.push(new_block_params[ii]));
      }
      return _results;
    };

    return PackerFloat;

  })(Packer);

  this.PackerCards = (function(_super) {
    __extends(PackerCards, _super);

    function PackerCards() {
      _ref1 = PackerCards.__super__.constructor.apply(this, arguments);
      return _ref1;
    }

    PackerCards.prototype.on_initialize = function() {
      var $container,
        _this = this;
      $container = this.$container_;
      return $container.bind_window_event("resize", function() {
        var browser_width, container_old_width, content_width, max_columns, min_columns, num_columns, old_num_columns, setting, width;
        old_num_columns = _this.num_columns_;
        if (!old_num_columns) {
          return;
        }
        width = _this.width_;
        if (!width) {
          return;
        }
        setting = _this.setting_;
        if (setting != null) {
          if (setting['width']) {
            content_width = parseInt(setting['width']);
          }
          min_columns = 0;
          if (setting['min-columns']) {
            min_columns = parseInt(setting['min-columns']);
          }
          container_old_width = $container.css("width");
          $container.css("width", "100%");
          browser_width = $container.width();
          $container.css("width", container_old_width);
          if (width > 0) {
            num_columns = Math.max(min_columns, parseInt(browser_width / width));
            if (max_columns = setting['max-columns']) {
              num_columns = Math.min(max_columns, num_columns);
            }
          } else {
            num_columns = 1;
          }
          if (num_columns !== old_num_columns) {
            return _this.layout();
          }
        }
      });
    };

    PackerCards.prototype.on_layout = function() {
      var $L_columns, $container, actual_num_columns, block, block_params, builders, cc, ii, num_columns, width, _i, _ref2;
      $container = this.$container_;
      block = this.block_;
      block_params = this.block_params_;
      builders = this.builders_ = new Array();
      this.add_columns();
      num_columns = this.num_columns_;
      $L_columns = this.$L_columns_;
      for (cc = _i = 0, _ref2 = num_columns - 1; _i <= _ref2; cc = _i += 1) {
        ii = cc;
        while (ii < block_params.length) {
          builders.push(block.add_block($L_columns[cc], block_params[ii]));
          ii += num_columns;
        }
      }
      width = this.width_;
      actual_num_columns = Math.min(block_params.length, num_columns);
      if (width != null) {
        $container.css("width", width * actual_num_columns + "px");
      } else {
        $container.css("width", "100%");
      }
      return $container.append("<div style='clear:both'></div>");
    };

    PackerCards.prototype.on_add = function(new_block_params) {
      var $L_columns, $column, $container, actual_num_columns, block, block_params, builders, c_index, cc, column_start, ii, num_columns, width, _i, _ref2, _results;
      $container = this.$container_;
      block = this.block_;
      block_params = this.block_params_;
      builders = this.builders_;
      num_columns = this.num_columns_;
      $L_columns = this.$L_columns_;
      width = this.width_;
      if (!num_columns) {
        this.add_columns();
        num_columns = this.num_columns_;
        $L_columns = this.$L_columns_;
        width = this.width_;
      }
      column_start = block_params.length % num_columns;
      actual_num_columns = Math.min(new_block_params.length + block_params.length, num_columns);
      if (width != null) {
        $container.css("width", width * actual_num_columns + "px");
      } else {
        $container.css("width", "100%");
      }
      _results = [];
      for (cc = _i = column_start, _ref2 = column_start + num_columns - 1; column_start <= _ref2 ? _i <= _ref2 : _i >= _ref2; cc = column_start <= _ref2 ? ++_i : --_i) {
        c_index = cc % num_columns;
        $column = $L_columns[c_index];
        ii = cc - column_start;
        _results.push((function() {
          var _results1;
          _results1 = [];
          while (ii < new_block_params.length) {
            builders.push(block.add_block($column, new_block_params[ii]));
            block_params.push(new_block_params[ii]);
            _results1.push(ii += num_columns);
          }
          return _results1;
        })());
      }
      return _results;
    };

    PackerCards.prototype.add_columns = function() {
      var $L_columns, $column, $container, browser_width, content_width, ii, max_columns, min_columns, num_columns, setting, width, _i, _ref2;
      $container = this.$container_;
      content_width = 300;
      min_columns = 1;
      num_columns = 1;
      setting = this.setting_;
      if (setting != null) {
        if (setting['width']) {
          content_width = parseInt(setting['width']);
        }
        min_columns = 0;
        if (setting['min-columns']) {
          min_columns = parseInt(setting['min-columns']);
        }
        this.width_ = width = content_width;
        $container.css("width", "100%");
        browser_width = $container.width();
        if (width) {
          num_columns = Math.max(min_columns, parseInt(browser_width / width));
          if (max_columns = setting['max-columns']) {
            num_columns = Math.min(max_columns, num_columns);
          }
        } else {
          num_columns = 1;
        }
      }
      $L_columns = new Array();
      for (ii = _i = 0, _ref2 = num_columns - 1; _i <= _ref2; ii = _i += 1) {
        $column = $("<div style='float:left; width:" + content_width + "px'></div>");
        $column.addClass('packer-card-column');
        $column.addClass('packer-card-column-' + ii);
        $container.append($column);
        $L_columns.push($column);
      }
      $container.append("<div style='clear:both'></div>");
      if (num_columns === 1) {
        $L_columns[0].css("float", "none");
      }
      this.$L_columns_ = $L_columns;
      return this.num_columns_ = num_columns;
    };

    PackerCards.prototype.get_current_height = function() {
      var $column, cc, min_column_height, _i, _ref2;
      min_column_height = Number.MAX_VALUE;
      if (!this.$L_columns_) {
        return 0;
      }
      for (cc = _i = 0, _ref2 = this.$L_columns_.length - 1; _i <= _ref2; cc = _i += 1) {
        $column = this.$L_columns_[cc];
        min_column_height = Math.min(min_column_height, $column.height() + $column.offset().top);
      }
      return min_column_height;
    };

    return PackerCards;

  })(Packer);

}).call(this);
